/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/*********** Preprocessed module -- do not edit ***************/
/***************** gpre version LI-V2.0.0.12724 Firebird 2.0 Release Candidate 4 **********************/
/*
 *	PROGRAM:	JRD Backup and Restore Program
 *	MODULE:		backup.epp
 *	DESCRIPTION:	Backup routine
 *
 * The contents of this file are subject to the Interbase Public
 * License Version 1.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a copy
 * of the License at http://www.Inprise.com/IPL.html
 *
 * Software distributed under the License is distributed on an
 * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * rights and limitations under the License.
 *
 * The Original Code was created by Inprise Corporation
 * and its predecessors. Portions created by Inprise Corporation are
 * Copyright (C) Inprise Corporation.
 *
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 *
 * Toni Martir: Added verbose backup records as BACKUP_VERBOSE_INTERVAL
 * 2001.07.06 Sean Leyne - Code Cleanup, removed "#ifdef READONLY_DATABASE"
 *                         conditionals, as the engine now fully supports
 *                         readonly databases.
 * 2001.11.20 Claudio Valderrama: fix problem with embedded blanks in
 * generators and use symbol_length effective length calculation from put_text.
 * This minimizes code redundancy and fixes SF Bug #483276. 
 * 2001.12.15 Claudio Valderrama: copy should run through symbol_length instead
 * of using just another length calculation algorithm. Callers of put_text, copy
 * and symbol_length (if used directly) should use sizeof. Changed all callers
 * and sizeof() works because the strings are local to the functions. This
 * eliminates the problem with harcoded limits in each call.
 * 2002.10.29 Mike Nordell: UINT64 backup message.
 * 2003.08.17 Claudio Valderrama: Fix SF Bug #750659.
 * 2005.04.29 Claudio Valderrama: Moved symbol_length to misc.cpp.
 */


#include "firebird.h"
#include <stdio.h>
#include <memory.h>
#include <string.h>
#include "../burp/burp.h"
#include "../jrd/ods.h"
#include "../jrd/align.h"
#include "../jrd/gdsassert.h"
#include "../jrd/thd.h"
#include "../common/stuff.h"
#include "../burp/backu_proto.h"
#include "../burp/burp_proto.h"
#include "../burp/canon_proto.h"
#include "../burp/mvol_proto.h"
#include "../remote/protocol.h"
#ifdef DEBUG
#include "../gpre/prett_proto.h"
#endif

//  For service APIs the follow DB handle is a value stored
//  in thread data.  This is also done for other statics generated by
//  GPRE.  This is to avoid multiple threading problems with module
//  level statics.

/*DATABASE DB = STATIC FILENAME "yachts.lnk" RUNTIME * dbb_file;*/
/**** GDS Preprocessor Definitions ****/
#ifndef JRD_IBASE_H
#include <ibase.h>
#endif

static ISC_QUAD
   isc_blob_null = {0, 0};	/* initializer for blobs */
static isc_db_handle
   DB = 0;		/* database handle */

static isc_tr_handle
   gds_trans = 0;		/* default transaction handle */
static long
   isc_status [20],	/* status vector */
   isc_status2 [20];	/* status vector */
static ISC_LONG
   isc_array_length, 	/* array return size */
   SQLCODE;		/* SQL status code */
static char
   isc_tpb_3 [4] = {1,9,2,6};

static char
   isc_tpb_2 [5] = {1,9,2,6,20};

static char
   isc_tpb_1 [4] = {1,9,2,6};

static char
   isc_tpb_0 [5] = {1,9,2,6,20};

static short
   isc_4l = 216;
static char
   isc_4 [] = {
   4,2,4,0,8,0,40,32,0,40,32,0,40,32,0,40,32,0,7,0,7,0,7,0,40,7,
   0,2,7,'C',1,'J',19,'R','D','B','$','U','S','E','R','_','P','R',
   'I','V','I','L','E','G','E','S',0,-1,14,0,2,1,23,0,14,'R','D',
   'B','$','F','I','E','L','D','_','N','A','M','E',41,0,0,0,5,0,
   1,23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'N','A','M','E',25,0,1,0,1,23,0,11,'R','D','B','$','G','R','A',
   'N','T','O','R',25,0,2,0,1,23,0,8,'R','D','B','$','U','S','E',
   'R',25,0,3,0,1,21,8,0,1,0,0,0,25,0,4,0,1,23,0,16,'R','D','B',
   '$','G','R','A','N','T','_','O','P','T','I','O','N',25,0,6,0,
   1,23,0,13,'R','D','B','$','P','R','I','V','I','L','E','G','E',
   25,0,7,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,4,0,-1,-1,'L'
   };	/* end of blr string for request isc_4 */

static short
   isc_14l = 264;
static char
   isc_14 [] = {
   4,2,4,0,10,0,40,32,0,40,32,0,40,32,0,40,32,0,7,0,7,0,7,0,7,0,
   7,0,40,7,0,2,7,'C',1,'J',19,'R','D','B','$','U','S','E','R',
   '_','P','R','I','V','I','L','E','G','E','S',0,-1,14,0,2,1,23,
   0,14,'R','D','B','$','F','I','E','L','D','_','N','A','M','E',
   41,0,0,0,7,0,1,23,0,17,'R','D','B','$','R','E','L','A','T','I',
   'O','N','_','N','A','M','E',25,0,1,0,1,23,0,11,'R','D','B','$',
   'G','R','A','N','T','O','R',25,0,2,0,1,23,0,8,'R','D','B','$',
   'U','S','E','R',25,0,3,0,1,21,8,0,1,0,0,0,25,0,4,0,1,23,0,15,
   'R','D','B','$','O','B','J','E','C','T','_','T','Y','P','E',
   25,0,5,0,1,23,0,13,'R','D','B','$','U','S','E','R','_','T','Y',
   'P','E',25,0,6,0,1,23,0,16,'R','D','B','$','G','R','A','N','T',
   '_','O','P','T','I','O','N',25,0,8,0,1,23,0,13,'R','D','B','$',
   'P','R','I','V','I','L','E','G','E',25,0,9,0,-1,14,0,1,21,8,
   0,0,0,0,0,25,0,4,0,-1,-1,'L'
   };	/* end of blr string for request isc_14 */

static short
   isc_26l = 222;
static char
   isc_26 [] = {
   4,2,4,0,6,0,9,0,40,32,0,40,32,0,7,0,7,0,7,0,2,7,'C',1,'J',9,
   'R','D','B','$','T','Y','P','E','S',0,'G',57,48,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',21,8,
   0,1,0,0,0,61,23,0,15,'R','D','B','$','S','Y','S','T','E','M',
   '_','F','L','A','G',-1,14,0,2,1,23,0,15,'R','D','B','$','D',
   'E','S','C','R','I','P','T','I','O','N',25,0,0,0,1,23,0,14,'R',
   'D','B','$','F','I','E','L','D','_','N','A','M','E',25,0,1,0,
   1,23,0,13,'R','D','B','$','T','Y','P','E','_','N','A','M','E',
   25,0,2,0,1,21,8,0,1,0,0,0,25,0,3,0,1,23,0,15,'R','D','B','$',
   'S','Y','S','T','E','M','_','F','L','A','G',25,0,4,0,1,23,0,
   8,'R','D','B','$','T','Y','P','E',25,0,5,0,-1,14,0,1,21,8,0,
   0,0,0,0,25,0,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_26 */

static short
   isc_34l = 248;
static char
   isc_34 [] = {
   4,2,4,0,4,0,40,32,0,7,0,40,-2,3,7,0,2,7,'C',2,'J',12,'R','D',
   'B','$','T','R','I','G','G','E','R','S',0,'J',20,'R','D','B',
   '$','T','R','I','G','G','E','R','_','M','E','S','S','A','G',
   'E','S',1,'G',58,47,23,1,16,'R','D','B','$','T','R','I','G',
   'G','E','R','_','N','A','M','E',23,0,16,'R','D','B','$','T',
   'R','I','G','G','E','R','_','N','A','M','E',57,48,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',21,8,
   0,1,0,0,0,61,23,0,15,'R','D','B','$','S','Y','S','T','E','M',
   '_','F','L','A','G',-1,14,0,2,1,23,1,16,'R','D','B','$','T',
   'R','I','G','G','E','R','_','N','A','M','E',25,0,0,0,1,21,8,
   0,1,0,0,0,25,0,1,0,1,23,1,11,'R','D','B','$','M','E','S','S',
   'A','G','E',25,0,2,0,1,23,1,18,'R','D','B','$','M','E','S','S',
   'A','G','E','_','N','U','M','B','E','R',25,0,3,0,-1,14,0,1,21,
   8,0,0,0,0,0,25,0,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_34 */

static short
   isc_40l = 118;
static char
   isc_40 [] = {
   4,2,4,1,3,0,7,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',12,
   'R','D','B','$','T','R','I','G','G','E','R','S',0,'G',47,25,
   0,0,0,23,0,16,'R','D','B','$','T','R','I','G','G','E','R','_',
   'N','A','M','E',-1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,9,
   'R','D','B','$','F','L','A','G','S',41,1,2,0,1,0,-1,14,1,1,21,
   8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_40 */

static short
   isc_47l = 352;
static char
   isc_47 [] = {
   4,2,4,0,10,0,9,0,9,0,9,0,40,32,0,40,32,0,7,0,7,0,7,0,7,0,7,0,
   2,7,'C',1,'J',12,'R','D','B','$','T','R','I','G','G','E','R',
   'S',0,'G',57,48,23,0,15,'R','D','B','$','S','Y','S','T','E',
   'M','_','F','L','A','G',21,8,0,1,0,0,0,61,23,0,15,'R','D','B',
   '$','S','Y','S','T','E','M','_','F','L','A','G',-1,14,0,2,1,
   23,0,15,'R','D','B','$','D','E','S','C','R','I','P','T','I',
   'O','N',25,0,0,0,1,23,0,18,'R','D','B','$','T','R','I','G','G',
   'E','R','_','S','O','U','R','C','E',25,0,1,0,1,23,0,15,'R','D',
   'B','$','T','R','I','G','G','E','R','_','B','L','R',25,0,2,0,
   1,23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'N','A','M','E',25,0,3,0,1,23,0,16,'R','D','B','$','T','R','I',
   'G','G','E','R','_','N','A','M','E',25,0,4,0,1,21,8,0,1,0,0,
   0,25,0,5,0,1,23,0,20,'R','D','B','$','T','R','I','G','G','E',
   'R','_','I','N','A','C','T','I','V','E',25,0,6,0,1,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',25,0,
   7,0,1,23,0,16,'R','D','B','$','T','R','I','G','G','E','R','_',
   'T','Y','P','E',25,0,8,0,1,23,0,20,'R','D','B','$','T','R','I',
   'G','G','E','R','_','S','E','Q','U','E','N','C','E',25,0,9,0,
   -1,14,0,1,21,8,0,0,0,0,0,25,0,5,0,-1,-1,'L'
   };	/* end of blr string for request isc_47 */

static short
   isc_59l = 375;
static char
   isc_59 [] = {
   4,2,4,0,12,0,9,0,9,0,9,0,40,32,0,40,32,0,7,0,7,0,7,0,7,0,7,0,
   7,0,7,0,2,7,'C',1,'J',12,'R','D','B','$','T','R','I','G','G',
   'E','R','S',0,'G',57,48,23,0,15,'R','D','B','$','S','Y','S',
   'T','E','M','_','F','L','A','G',21,8,0,1,0,0,0,61,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',-1,14,
   0,2,1,23,0,15,'R','D','B','$','D','E','S','C','R','I','P','T',
   'I','O','N',25,0,0,0,1,23,0,18,'R','D','B','$','T','R','I','G',
   'G','E','R','_','S','O','U','R','C','E',25,0,1,0,1,23,0,15,'R',
   'D','B','$','T','R','I','G','G','E','R','_','B','L','R',25,0,
   2,0,1,23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N',
   '_','N','A','M','E',25,0,3,0,1,23,0,16,'R','D','B','$','T','R',
   'I','G','G','E','R','_','N','A','M','E',25,0,4,0,1,21,8,0,1,
   0,0,0,25,0,5,0,1,23,0,9,'R','D','B','$','F','L','A','G','S',
   41,0,7,0,6,0,1,23,0,20,'R','D','B','$','T','R','I','G','G','E',
   'R','_','I','N','A','C','T','I','V','E',25,0,8,0,1,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',25,0,
   9,0,1,23,0,16,'R','D','B','$','T','R','I','G','G','E','R','_',
   'T','Y','P','E',25,0,10,0,1,23,0,20,'R','D','B','$','T','R',
   'I','G','G','E','R','_','S','E','Q','U','E','N','C','E',25,0,
   11,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,5,0,-1,-1,'L'
   };	/* end of blr string for request isc_59 */

static short
   isc_73l = 107;
static char
   isc_73 [] = {
   4,2,4,0,3,0,40,32,0,40,32,0,7,0,2,7,'C',1,'J',9,'R','D','B',
   '$','R','O','L','E','S',0,-1,14,0,2,1,23,0,14,'R','D','B','$',
   'O','W','N','E','R','_','N','A','M','E',25,0,0,0,1,23,0,13,'R',
   'D','B','$','R','O','L','E','_','N','A','M','E',25,0,1,0,1,21,
   8,0,1,0,0,0,25,0,2,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,2,0,-1,-1,
   'L'
   };	/* end of blr string for request isc_73 */

static short
   isc_78l = 183;
static char
   isc_78 [] = {
   4,2,4,0,5,0,9,0,40,32,0,40,32,0,7,0,7,0,2,7,'C',1,'J',9,'R',
   'D','B','$','R','O','L','E','S',0,'G',57,48,23,0,15,'R','D',
   'B','$','S','Y','S','T','E','M','_','F','L','A','G',21,8,0,1,
   0,0,0,61,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_',
   'F','L','A','G',-1,14,0,2,1,23,0,15,'R','D','B','$','D','E',
   'S','C','R','I','P','T','I','O','N',41,0,0,0,4,0,1,23,0,14,'R',
   'D','B','$','O','W','N','E','R','_','N','A','M','E',25,0,1,0,
   1,23,0,13,'R','D','B','$','R','O','L','E','_','N','A','M','E',
   25,0,2,0,1,21,8,0,1,0,0,0,25,0,3,0,-1,14,0,1,21,8,0,0,0,0,0,
   25,0,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_78 */

static short
   isc_85l = 261;
static char
   isc_85 [] = {
   4,2,4,0,7,0,8,0,8,0,7,0,7,0,7,0,7,0,40,-2,0,2,7,'C',1,'J',9,
   'R','D','B','$','F','I','L','E','S',0,'G',58,59,61,23,0,17,'R',
   'D','B','$','S','H','A','D','O','W','_','N','U','M','B','E',
   'R',48,23,0,17,'R','D','B','$','S','H','A','D','O','W','_','N',
   'U','M','B','E','R',21,8,0,0,0,0,0,-1,14,0,2,1,23,0,15,'R','D',
   'B','$','F','I','L','E','_','L','E','N','G','T','H',25,0,0,0,
   1,23,0,14,'R','D','B','$','F','I','L','E','_','S','T','A','R',
   'T',25,0,1,0,1,21,8,0,1,0,0,0,25,0,2,0,1,23,0,17,'R','D','B',
   '$','S','H','A','D','O','W','_','N','U','M','B','E','R',25,0,
   3,0,1,23,0,14,'R','D','B','$','F','I','L','E','_','F','L','A',
   'G','S',25,0,4,0,1,23,0,17,'R','D','B','$','F','I','L','E','_',
   'S','E','Q','U','E','N','C','E',25,0,5,0,1,23,0,13,'R','D','B',
   '$','F','I','L','E','_','N','A','M','E',25,0,6,0,-1,14,0,1,21,
   8,0,0,0,0,0,25,0,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_85 */

static short
   isc_94l = 188;
static char
   isc_94 [] = {
   4,2,4,1,5,0,40,32,0,9,0,7,0,7,0,40,-2,0,4,0,1,0,40,32,0,12,0,
   2,7,'C',1,'J',13,'R','D','B','$','R','E','L','A','T','I','O',
   'N','S',0,'G',47,23,0,17,'R','D','B','$','R','E','L','A','T',
   'I','O','N','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,14,
   'R','D','B','$','O','W','N','E','R','_','N','A','M','E',25,1,
   0,0,1,23,0,24,'R','D','B','$','E','X','T','E','R','N','A','L',
   '_','D','E','S','C','R','I','P','T','I','O','N',25,1,1,0,1,21,
   8,0,1,0,0,0,25,1,2,0,1,23,0,17,'R','D','B','$','E','X','T','E',
   'R','N','A','L','_','F','I','L','E',41,1,4,0,3,0,-1,14,1,1,21,
   8,0,0,0,0,0,25,1,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_94 */

static short
   isc_103l = 130;
static char
   isc_103 [] = {
   4,2,4,1,3,0,40,32,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',
   13,'R','D','B','$','R','E','L','A','T','I','O','N','S',0,'G',
   47,23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,18,'R','D','B','$',
   'S','E','C','U','R','I','T','Y','_','C','L','A','S','S',41,1,
   0,0,2,0,1,21,8,0,1,0,0,0,25,1,1,0,-1,14,1,1,21,8,0,0,0,0,0,25,
   1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_103 */

static short
   isc_110l = 120;
static char
   isc_110 [] = {
   4,2,4,1,3,0,7,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',13,
   'R','D','B','$','R','E','L','A','T','I','O','N','S',0,'G',47,
   23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'N','A','M','E',25,0,0,0,-1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,
   1,23,0,9,'R','D','B','$','F','L','A','G','S',41,1,2,0,1,0,-1,
   14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_110 */

static short
   isc_117l = 259;
static char
   isc_117 [] = {
   4,2,4,0,7,0,9,0,9,0,9,0,40,32,0,7,0,7,0,7,0,2,7,'C',1,'J',13,
   'R','D','B','$','R','E','L','A','T','I','O','N','S',0,'G',57,
   48,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L',
   'A','G',21,8,0,1,0,0,0,61,23,0,15,'R','D','B','$','S','Y','S',
   'T','E','M','_','F','L','A','G',-1,14,0,2,1,23,0,15,'R','D',
   'B','$','V','I','E','W','_','S','O','U','R','C','E',25,0,0,0,
   1,23,0,15,'R','D','B','$','D','E','S','C','R','I','P','T','I',
   'O','N',25,0,1,0,1,23,0,12,'R','D','B','$','V','I','E','W','_',
   'B','L','R',25,0,2,0,1,23,0,17,'R','D','B','$','R','E','L','A',
   'T','I','O','N','_','N','A','M','E',25,0,3,0,1,21,8,0,1,0,0,
   0,25,0,4,0,1,23,0,15,'R','D','B','$','R','E','L','A','T','I',
   'O','N','_','I','D',25,0,5,0,1,23,0,15,'R','D','B','$','S','Y',
   'S','T','E','M','_','F','L','A','G',25,0,6,0,-1,14,0,1,21,8,
   0,0,0,0,0,25,0,4,0,-1,-1,'L'
   };	/* end of blr string for request isc_117 */

static short
   isc_126l = 406;
static char
   isc_126 [] = {
   4,2,4,0,15,0,40,32,0,9,0,9,0,9,0,40,32,0,9,0,40,32,0,7,0,7,0,
   7,0,40,-2,0,7,0,7,0,7,0,7,0,2,7,'C',1,'J',13,'R','D','B','$',
   'R','E','L','A','T','I','O','N','S',0,'G',57,48,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',21,8,
   0,1,0,0,0,61,23,0,15,'R','D','B','$','S','Y','S','T','E','M',
   '_','F','L','A','G',-1,14,0,2,1,23,0,14,'R','D','B','$','O',
   'W','N','E','R','_','N','A','M','E',25,0,0,0,1,23,0,24,'R','D',
   'B','$','E','X','T','E','R','N','A','L','_','D','E','S','C',
   'R','I','P','T','I','O','N',25,0,1,0,1,23,0,15,'R','D','B','$',
   'V','I','E','W','_','S','O','U','R','C','E',25,0,2,0,1,23,0,
   15,'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N',
   25,0,3,0,1,23,0,18,'R','D','B','$','S','E','C','U','R','I','T',
   'Y','_','C','L','A','S','S',41,0,4,0,11,0,1,23,0,12,'R','D',
   'B','$','V','I','E','W','_','B','L','R',25,0,5,0,1,23,0,17,'R',
   'D','B','$','R','E','L','A','T','I','O','N','_','N','A','M',
   'E',25,0,6,0,1,21,8,0,1,0,0,0,25,0,7,0,1,23,0,15,'R','D','B',
   '$','R','E','L','A','T','I','O','N','_','I','D',25,0,8,0,1,23,
   0,17,'R','D','B','$','E','X','T','E','R','N','A','L','_','F',
   'I','L','E',41,0,10,0,9,0,1,23,0,9,'R','D','B','$','F','L','A',
   'G','S',41,0,13,0,12,0,1,23,0,15,'R','D','B','$','S','Y','S',
   'T','E','M','_','F','L','A','G',25,0,14,0,-1,14,0,1,21,8,0,0,
   0,0,0,25,0,7,0,-1,-1,'L'
   };	/* end of blr string for request isc_126 */

static short
   isc_143l = 248;
static char
   isc_143 [] = {
   4,2,4,0,8,0,40,32,0,40,32,0,40,32,0,40,4,0,40,4,0,40,12,0,7,
   0,7,0,2,7,'C',1,'J',24,'R','D','B','$','R','E','L','A','T','I',
   'O','N','_','C','O','N','S','T','R','A','I','N','T','S',0,-1,
   14,0,2,1,23,0,14,'R','D','B','$','I','N','D','E','X','_','N',
   'A','M','E',41,0,0,0,7,0,1,23,0,17,'R','D','B','$','R','E','L',
   'A','T','I','O','N','_','N','A','M','E',25,0,1,0,1,23,0,19,'R',
   'D','B','$','C','O','N','S','T','R','A','I','N','T','_','N',
   'A','M','E',25,0,2,0,1,23,0,22,'R','D','B','$','I','N','I','T',
   'I','A','L','L','Y','_','D','E','F','E','R','R','E','D',25,0,
   3,0,1,23,0,14,'R','D','B','$','D','E','F','E','R','R','A','B',
   'L','E',25,0,4,0,1,23,0,19,'R','D','B','$','C','O','N','S','T',
   'R','A','I','N','T','_','T','Y','P','E',25,0,5,0,1,21,8,0,1,
   0,0,0,25,0,6,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,6,0,-1,-1,'L'
   };	/* end of blr string for request isc_143 */

static short
   isc_153l = 205;
static char
   isc_153 [] = {
   4,2,4,0,6,0,40,8,0,40,32,0,40,32,0,40,12,0,40,12,0,7,0,2,7,'C',
   1,'J',19,'R','D','B','$','R','E','F','_','C','O','N','S','T',
   'R','A','I','N','T','S',0,-1,14,0,2,1,23,0,16,'R','D','B','$',
   'M','A','T','C','H','_','O','P','T','I','O','N',25,0,0,0,1,23,
   0,17,'R','D','B','$','C','O','N','S','T','_','N','A','M','E',
   '_','U','Q',25,0,1,0,1,23,0,19,'R','D','B','$','C','O','N','S',
   'T','R','A','I','N','T','_','N','A','M','E',25,0,2,0,1,23,0,
   15,'R','D','B','$','D','E','L','E','T','E','_','R','U','L','E',
   25,0,3,0,1,23,0,15,'R','D','B','$','U','P','D','A','T','E','_',
   'R','U','L','E',25,0,4,0,1,21,8,0,1,0,0,0,25,0,5,0,-1,14,0,1,
   21,8,0,0,0,0,0,25,0,5,0,-1,-1,'L'
   };	/* end of blr string for request isc_153 */

static short
   isc_161l = 248;
static char
   isc_161 [] = {
   4,2,4,1,6,0,9,0,40,32,0,40,32,0,7,0,7,0,7,0,4,0,1,0,40,32,0,
   12,0,2,7,'C',1,'J',24,'R','D','B','$','P','R','O','C','E','D',
   'U','R','E','_','P','A','R','A','M','E','T','E','R','S',0,'G',
   47,23,0,18,'R','D','B','$','P','R','O','C','E','D','U','R','E',
   '_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,15,'R','D','B',
   '$','D','E','S','C','R','I','P','T','I','O','N',25,1,0,0,1,23,
   0,16,'R','D','B','$','F','I','E','L','D','_','S','O','U','R',
   'C','E',25,1,1,0,1,23,0,18,'R','D','B','$','P','A','R','A','M',
   'E','T','E','R','_','N','A','M','E',25,1,2,0,1,21,8,0,1,0,0,
   0,25,1,3,0,1,23,0,18,'R','D','B','$','P','A','R','A','M','E',
   'T','E','R','_','T','Y','P','E',25,1,4,0,1,23,0,20,'R','D','B',
   '$','P','A','R','A','M','E','T','E','R','_','N','U','M','B',
   'E','R',25,1,5,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,3,0,-1,-1,'L'
   
   };	/* end of blr string for request isc_161 */

static short
   isc_171l = 340;
static char
   isc_171 [] = {
   4,2,4,0,10,0,40,32,0,40,32,0,9,0,9,0,9,0,40,32,0,7,0,7,0,7,0,
   7,0,2,7,'C',1,'J',14,'R','D','B','$','P','R','O','C','E','D',
   'U','R','E','S',0,'G',57,61,23,0,15,'R','D','B','$','S','Y',
   'S','T','E','M','_','F','L','A','G',48,23,0,15,'R','D','B','$',
   'S','Y','S','T','E','M','_','F','L','A','G',21,8,0,1,0,0,0,-1,
   14,0,2,1,23,0,14,'R','D','B','$','O','W','N','E','R','_','N',
   'A','M','E',25,0,0,0,1,23,0,18,'R','D','B','$','S','E','C','U',
   'R','I','T','Y','_','C','L','A','S','S',41,0,1,0,7,0,1,23,0,
   17,'R','D','B','$','P','R','O','C','E','D','U','R','E','_','B',
   'L','R',25,0,2,0,1,23,0,20,'R','D','B','$','P','R','O','C','E',
   'D','U','R','E','_','S','O','U','R','C','E',25,0,3,0,1,23,0,
   15,'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N',
   25,0,4,0,1,23,0,18,'R','D','B','$','P','R','O','C','E','D','U',
   'R','E','_','N','A','M','E',25,0,5,0,1,21,8,0,1,0,0,0,25,0,6,
   0,1,23,0,21,'R','D','B','$','P','R','O','C','E','D','U','R',
   'E','_','O','U','T','P','U','T','S',25,0,8,0,1,23,0,20,'R','D',
   'B','$','P','R','O','C','E','D','U','R','E','_','I','N','P',
   'U','T','S',25,0,9,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,6,0,-1,-1,
   'L'
   };	/* end of blr string for request isc_171 */

static short
   isc_183l = 124;
static char
   isc_183 [] = {
   4,2,4,1,3,0,7,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',10,
   'R','D','B','$','F','I','E','L','D','S',0,'G',47,23,0,14,'R',
   'D','B','$','F','I','E','L','D','_','N','A','M','E',25,0,0,0,
   -1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,19,'R','D','B','$',
   'F','I','E','L','D','_','P','R','E','C','I','S','I','O','N',
   41,1,2,0,1,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_183 */

static short
   isc_190l = 280;
static char
   isc_190 [] = {
   4,2,4,1,13,0,9,0,9,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,
   7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',10,'R','D','B','$','F',
   'I','E','L','D','S',0,'G',47,23,0,14,'R','D','B','$','F','I',
   'E','L','D','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,18,
   'R','D','B','$','M','I','S','S','I','N','G','_','S','O','U',
   'R','C','E',41,1,0,0,7,0,1,23,0,18,'R','D','B','$','D','E','F',
   'A','U','L','T','_','S','O','U','R','C','E',41,1,1,0,8,0,1,21,
   8,0,1,0,0,0,25,1,2,0,1,23,0,16,'R','D','B','$','C','O','L','L',
   'A','T','I','O','N','_','I','D',41,1,4,0,3,0,1,23,0,20,'R','D',
   'B','$','C','H','A','R','A','C','T','E','R','_','S','E','T',
   '_','I','D',41,1,6,0,5,0,1,23,0,20,'R','D','B','$','C','H','A',
   'R','A','C','T','E','R','_','L','E','N','G','T','H',41,1,10,
   0,9,0,1,23,0,13,'R','D','B','$','N','U','L','L','_','F','L',
   'A','G',41,1,12,0,11,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,2,0,-1,
   -1,'L'
   };	/* end of blr string for request isc_190 */

static short
   isc_207l = 199;
static char
   isc_207 [] = {
   4,2,4,1,5,0,7,0,7,0,7,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',
   1,'J',10,'R','D','B','$','F','I','E','L','D','S',0,'G',47,23,
   0,14,'R','D','B','$','F','I','E','L','D','_','N','A','M','E',
   25,0,0,0,-1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,14,'R','D',
   'B','$','D','I','M','E','N','S','I','O','N','S',25,1,1,0,1,23,
   0,18,'R','D','B','$','E','X','T','E','R','N','A','L','_','S',
   'C','A','L','E',25,1,2,0,1,23,0,17,'R','D','B','$','E','X','T',
   'E','R','N','A','L','_','T','Y','P','E',25,1,3,0,1,23,0,19,'R',
   'D','B','$','E','X','T','E','R','N','A','L','_','L','E','N',
   'G','T','H',25,1,4,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,
   'L'
   };	/* end of blr string for request isc_207 */

static short
   isc_216l = 557;
static char
   isc_216 [] = {
   4,2,4,0,18,0,9,0,9,0,9,0,9,0,9,0,9,0,9,0,9,0,40,32,0,40,32,0,
   7,0,7,0,7,0,7,0,7,0,7,0,7,0,40,126,0,2,7,'C',1,'J',10,'R','D',
   'B','$','F','I','E','L','D','S',0,'G',57,48,23,0,15,'R','D',
   'B','$','S','Y','S','T','E','M','_','F','L','A','G',21,8,0,1,
   0,0,0,61,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_',
   'F','L','A','G',-1,14,0,2,1,23,0,15,'R','D','B','$','D','E',
   'S','C','R','I','P','T','I','O','N',25,0,0,0,1,23,0,19,'R','D',
   'B','$','C','O','M','P','U','T','E','D','_','S','O','U','R',
   'C','E',25,0,1,0,1,23,0,16,'R','D','B','$','C','O','M','P','U',
   'T','E','D','_','B','L','R',25,0,2,0,1,23,0,21,'R','D','B','$',
   'V','A','L','I','D','A','T','I','O','N','_','S','O','U','R',
   'C','E',25,0,3,0,1,23,0,18,'R','D','B','$','V','A','L','I','D',
   'A','T','I','O','N','_','B','L','R',25,0,4,0,1,23,0,17,'R','D',
   'B','$','D','E','F','A','U','L','T','_','V','A','L','U','E',
   25,0,5,0,1,23,0,17,'R','D','B','$','M','I','S','S','I','N','G',
   '_','V','A','L','U','E',25,0,6,0,1,23,0,16,'R','D','B','$','Q',
   'U','E','R','Y','_','H','E','A','D','E','R',25,0,7,0,1,23,0,
   14,'R','D','B','$','Q','U','E','R','Y','_','N','A','M','E',25,
   0,8,0,1,23,0,14,'R','D','B','$','F','I','E','L','D','_','N',
   'A','M','E',25,0,9,0,1,21,8,0,1,0,0,0,25,0,10,0,1,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',25,0,
   11,0,1,23,0,18,'R','D','B','$','S','E','G','M','E','N','T','_',
   'L','E','N','G','T','H',25,0,12,0,1,23,0,15,'R','D','B','$',
   'F','I','E','L','D','_','S','C','A','L','E',25,0,13,0,1,23,0,
   18,'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T',
   'Y','P','E',25,0,14,0,1,23,0,16,'R','D','B','$','F','I','E',
   'L','D','_','L','E','N','G','T','H',25,0,15,0,1,23,0,14,'R',
   'D','B','$','F','I','E','L','D','_','T','Y','P','E',25,0,16,
   0,1,23,0,15,'R','D','B','$','E','D','I','T','_','S','T','R',
   'I','N','G',25,0,17,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,10,0,-1,
   -1,'L'
   };	/* end of blr string for request isc_216 */

static short
   isc_236l = 887;
static char
   isc_236 [] = {
   4,2,4,0,'$',0,9,0,9,0,9,0,9,0,9,0,9,0,9,0,9,0,9,0,9,0,40,32,
   0,40,32,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,
   0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,40,126,0,2,7,'C',1,
   'J',10,'R','D','B','$','F','I','E','L','D','S',0,'G',57,48,23,
   0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L','A',
   'G',21,8,0,1,0,0,0,61,23,0,15,'R','D','B','$','S','Y','S','T',
   'E','M','_','F','L','A','G',-1,14,0,2,1,23,0,18,'R','D','B',
   '$','M','I','S','S','I','N','G','_','S','O','U','R','C','E',
   41,0,0,0,19,0,1,23,0,18,'R','D','B','$','D','E','F','A','U',
   'L','T','_','S','O','U','R','C','E',41,0,1,0,20,0,1,23,0,15,
   'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N',
   25,0,2,0,1,23,0,19,'R','D','B','$','C','O','M','P','U','T','E',
   'D','_','S','O','U','R','C','E',25,0,3,0,1,23,0,16,'R','D','B',
   '$','C','O','M','P','U','T','E','D','_','B','L','R',25,0,4,0,
   1,23,0,21,'R','D','B','$','V','A','L','I','D','A','T','I','O',
   'N','_','S','O','U','R','C','E',25,0,5,0,1,23,0,18,'R','D','B',
   '$','V','A','L','I','D','A','T','I','O','N','_','B','L','R',
   25,0,6,0,1,23,0,17,'R','D','B','$','D','E','F','A','U','L','T',
   '_','V','A','L','U','E',25,0,7,0,1,23,0,17,'R','D','B','$','M',
   'I','S','S','I','N','G','_','V','A','L','U','E',25,0,8,0,1,23,
   0,16,'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D',
   'E','R',25,0,9,0,1,23,0,14,'R','D','B','$','Q','U','E','R','Y',
   '_','N','A','M','E',25,0,10,0,1,23,0,14,'R','D','B','$','F',
   'I','E','L','D','_','N','A','M','E',25,0,11,0,1,21,8,0,1,0,0,
   0,25,0,12,0,1,23,0,19,'R','D','B','$','F','I','E','L','D','_',
   'P','R','E','C','I','S','I','O','N',41,0,14,0,13,0,1,23,0,16,
   'R','D','B','$','C','O','L','L','A','T','I','O','N','_','I',
   'D',41,0,16,0,15,0,1,23,0,20,'R','D','B','$','C','H','A','R',
   'A','C','T','E','R','_','S','E','T','_','I','D',41,0,18,0,17,
   0,1,23,0,20,'R','D','B','$','C','H','A','R','A','C','T','E',
   'R','_','L','E','N','G','T','H',41,0,22,0,21,0,1,23,0,13,'R',
   'D','B','$','N','U','L','L','_','F','L','A','G',41,0,24,0,23,
   0,1,23,0,14,'R','D','B','$','D','I','M','E','N','S','I','O',
   'N','S',25,0,25,0,1,23,0,18,'R','D','B','$','E','X','T','E',
   'R','N','A','L','_','S','C','A','L','E',25,0,26,0,1,23,0,17,
   'R','D','B','$','E','X','T','E','R','N','A','L','_','T','Y',
   'P','E',25,0,27,0,1,23,0,19,'R','D','B','$','E','X','T','E',
   'R','N','A','L','_','L','E','N','G','T','H',25,0,28,0,1,23,0,
   15,'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G',
   25,0,29,0,1,23,0,18,'R','D','B','$','S','E','G','M','E','N',
   'T','_','L','E','N','G','T','H',25,0,30,0,1,23,0,15,'R','D',
   'B','$','F','I','E','L','D','_','S','C','A','L','E',25,0,31,
   0,1,23,0,18,'R','D','B','$','F','I','E','L','D','_','S','U',
   'B','_','T','Y','P','E',25,0,32,0,1,23,0,16,'R','D','B','$',
   'F','I','E','L','D','_','L','E','N','G','T','H',25,0,33,0,1,
   23,0,14,'R','D','B','$','F','I','E','L','D','_','T','Y','P',
   'E',25,0,34,0,1,23,0,15,'R','D','B','$','E','D','I','T','_',
   'S','T','R','I','N','G',25,0,35,0,-1,14,0,1,21,8,0,0,0,0,0,25,
   0,12,0,-1,-1,'L'
   };	/* end of blr string for request isc_236 */

static short
   isc_274l = 139;
static char
   isc_274 [] = {
   4,2,4,0,2,0,40,32,0,7,0,2,7,'C',1,'J',14,'R','D','B','$','G',
   'E','N','E','R','A','T','O','R','S',0,'G',57,61,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',48,23,
   0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L','A',
   'G',21,8,0,1,0,0,0,-1,14,0,2,1,23,0,18,'R','D','B','$','G','E',
   'N','E','R','A','T','O','R','_','N','A','M','E',25,0,0,0,1,21,
   8,0,1,0,0,0,25,0,1,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,1,0,-1,-1,
   'L'
   };	/* end of blr string for request isc_274 */

static short
   isc_278l = 168;
static char
   isc_278 [] = {
   4,2,4,0,4,0,9,0,40,32,0,7,0,7,0,2,7,'C',1,'J',14,'R','D','B',
   '$','G','E','N','E','R','A','T','O','R','S',0,'G',57,61,23,0,
   15,'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G',
   48,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L',
   'A','G',21,8,0,1,0,0,0,-1,14,0,2,1,23,0,15,'R','D','B','$','D',
   'E','S','C','R','I','P','T','I','O','N',41,0,0,0,3,0,1,23,0,
   18,'R','D','B','$','G','E','N','E','R','A','T','O','R','_','N',
   'A','M','E',25,0,1,0,1,21,8,0,1,0,0,0,25,0,2,0,-1,14,0,1,21,
   8,0,0,0,0,0,25,0,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_278 */

static short
   isc_284l = 172;
static char
   isc_284 [] = {
   4,2,4,1,3,0,7,0,7,0,7,0,4,0,2,0,40,32,0,7,0,12,0,2,7,'C',1,'J',
   22,'R','D','B','$','F','U','N','C','T','I','O','N','_','A','R',
   'G','U','M','E','N','T','S',0,'G',58,47,23,0,17,'R','D','B',
   '$','F','U','N','C','T','I','O','N','_','N','A','M','E',25,0,
   0,0,47,23,0,21,'R','D','B','$','A','R','G','U','M','E','N','T',
   '_','P','O','S','I','T','I','O','N',25,0,1,0,-1,14,1,2,1,21,
   8,0,1,0,0,0,25,1,0,0,1,23,0,20,'R','D','B','$','C','H','A','R',
   'A','C','T','E','R','_','S','E','T','_','I','D',41,1,2,0,1,0,
   -1,14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_284 */

static short
   isc_292l = 291;
static char
   isc_292 [] = {
   4,2,4,1,8,0,40,32,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,4,0,1,0,40,32,
   0,12,0,2,7,'C',1,'J',22,'R','D','B','$','F','U','N','C','T',
   'I','O','N','_','A','R','G','U','M','E','N','T','S',0,'G',47,
   23,0,17,'R','D','B','$','F','U','N','C','T','I','O','N','_',
   'N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,17,'R','D','B','$',
   'F','U','N','C','T','I','O','N','_','N','A','M','E',25,1,0,0,
   1,21,8,0,1,0,0,0,25,1,1,0,1,23,0,18,'R','D','B','$','F','I',
   'E','L','D','_','S','U','B','_','T','Y','P','E',25,1,2,0,1,23,
   0,16,'R','D','B','$','F','I','E','L','D','_','L','E','N','G',
   'T','H',25,1,3,0,1,23,0,15,'R','D','B','$','F','I','E','L','D',
   '_','S','C','A','L','E',25,1,4,0,1,23,0,14,'R','D','B','$','F',
   'I','E','L','D','_','T','Y','P','E',25,1,5,0,1,23,0,13,'R','D',
   'B','$','M','E','C','H','A','N','I','S','M',25,1,6,0,1,23,0,
   21,'R','D','B','$','A','R','G','U','M','E','N','T','_','P','O',
   'S','I','T','I','O','N',25,1,7,0,-1,14,1,1,21,8,0,0,0,0,0,25,
   1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_292 */

static short
   isc_304l = 358;
static char
   isc_304 [] = {
   4,2,4,1,12,0,40,32,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,
   7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',22,'R','D','B','$','F',
   'U','N','C','T','I','O','N','_','A','R','G','U','M','E','N',
   'T','S',0,'G',47,23,0,17,'R','D','B','$','F','U','N','C','T',
   'I','O','N','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,17,
   'R','D','B','$','F','U','N','C','T','I','O','N','_','N','A',
   'M','E',25,1,0,0,1,21,8,0,1,0,0,0,25,1,1,0,1,23,0,19,'R','D',
   'B','$','F','I','E','L','D','_','P','R','E','C','I','S','I',
   'O','N',41,1,3,0,2,0,1,23,0,20,'R','D','B','$','C','H','A','R',
   'A','C','T','E','R','_','S','E','T','_','I','D',41,1,5,0,4,0,
   1,23,0,18,'R','D','B','$','F','I','E','L','D','_','S','U','B',
   '_','T','Y','P','E',25,1,6,0,1,23,0,16,'R','D','B','$','F','I',
   'E','L','D','_','L','E','N','G','T','H',25,1,7,0,1,23,0,15,'R',
   'D','B','$','F','I','E','L','D','_','S','C','A','L','E',25,1,
   8,0,1,23,0,14,'R','D','B','$','F','I','E','L','D','_','T','Y',
   'P','E',25,1,9,0,1,23,0,13,'R','D','B','$','M','E','C','H','A',
   'N','I','S','M',25,1,10,0,1,23,0,21,'R','D','B','$','A','R',
   'G','U','M','E','N','T','_','P','O','S','I','T','I','O','N',
   25,1,11,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_304 */

static short
   isc_320l = 294;
static char
   isc_320 [] = {
   4,2,4,0,8,0,40,32,0,40,32,0,9,0,40,32,0,7,0,7,0,7,0,40,-2,0,
   2,7,'C',1,'J',13,'R','D','B','$','F','U','N','C','T','I','O',
   'N','S',0,'G',57,61,23,0,15,'R','D','B','$','S','Y','S','T',
   'E','M','_','F','L','A','G',48,23,0,15,'R','D','B','$','S','Y',
   'S','T','E','M','_','F','L','A','G',21,8,0,1,0,0,0,-1,14,0,2,
   1,23,0,14,'R','D','B','$','Q','U','E','R','Y','_','N','A','M',
   'E',25,0,0,0,1,23,0,14,'R','D','B','$','E','N','T','R','Y','P',
   'O','I','N','T',25,0,1,0,1,23,0,15,'R','D','B','$','D','E','S',
   'C','R','I','P','T','I','O','N',25,0,2,0,1,23,0,17,'R','D','B',
   '$','F','U','N','C','T','I','O','N','_','N','A','M','E',25,0,
   3,0,1,21,8,0,1,0,0,0,25,0,4,0,1,23,0,17,'R','D','B','$','F',
   'U','N','C','T','I','O','N','_','T','Y','P','E',25,0,5,0,1,23,
   0,19,'R','D','B','$','R','E','T','U','R','N','_','A','R','G',
   'U','M','E','N','T',25,0,6,0,1,23,0,15,'R','D','B','$','M','O',
   'D','U','L','E','_','N','A','M','E',25,0,7,0,-1,14,0,1,21,8,
   0,0,0,0,0,25,0,4,0,-1,-1,'L'
   };	/* end of blr string for request isc_320 */

static short
   isc_330l = 268;
static char
   isc_330 [] = {
   4,2,4,0,7,0,40,32,0,9,0,40,32,0,7,0,7,0,7,0,40,-2,0,2,7,'C',
   1,'J',11,'R','D','B','$','F','I','L','T','E','R','S',0,'G',57,
   61,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L',
   'A','G',48,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_',
   'F','L','A','G',21,8,0,1,0,0,0,-1,14,0,2,1,23,0,14,'R','D','B',
   '$','E','N','T','R','Y','P','O','I','N','T',25,0,0,0,1,23,0,
   15,'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N',
   25,0,1,0,1,23,0,17,'R','D','B','$','F','U','N','C','T','I','O',
   'N','_','N','A','M','E',25,0,2,0,1,21,8,0,1,0,0,0,25,0,3,0,1,
   23,0,19,'R','D','B','$','O','U','T','P','U','T','_','S','U',
   'B','_','T','Y','P','E',25,0,4,0,1,23,0,18,'R','D','B','$','I',
   'N','P','U','T','_','S','U','B','_','T','Y','P','E',25,0,5,0,
   1,23,0,15,'R','D','B','$','M','O','D','U','L','E','_','N','A',
   'M','E',25,0,6,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,3,0,-1,-1,'L'
   
   };	/* end of blr string for request isc_330 */

static short
   isc_339l = 167;
static char
   isc_339 [] = {
   4,2,4,0,5,0,40,32,0,8,0,8,0,7,0,7,0,2,7,'C',1,'J',20,'R','D',
   'B','$','F','I','E','L','D','_','D','I','M','E','N','S','I',
   'O','N','S',0,-1,14,0,2,1,23,0,14,'R','D','B','$','F','I','E',
   'L','D','_','N','A','M','E',25,0,0,0,1,23,0,15,'R','D','B','$',
   'U','P','P','E','R','_','B','O','U','N','D',25,0,1,0,1,23,0,
   15,'R','D','B','$','L','O','W','E','R','_','B','O','U','N','D',
   25,0,2,0,1,21,8,0,1,0,0,0,25,0,3,0,1,23,0,13,'R','D','B','$',
   'D','I','M','E','N','S','I','O','N',25,0,4,0,-1,14,0,1,21,8,
   0,0,0,0,0,25,0,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_339 */

static short
   isc_346l = 186;
static char
   isc_346 [] = {
   4,2,4,0,4,0,9,0,40,32,0,7,0,40,-2,3,2,7,'C',1,'J',14,'R','D',
   'B','$','E','X','C','E','P','T','I','O','N','S',0,'G',57,61,
   23,0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L',
   'A','G',48,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_',
   'F','L','A','G',21,8,0,1,0,0,0,-1,14,0,2,1,23,0,15,'R','D','B',
   '$','D','E','S','C','R','I','P','T','I','O','N',25,0,0,0,1,23,
   0,18,'R','D','B','$','E','X','C','E','P','T','I','O','N','_',
   'N','A','M','E',25,0,1,0,1,21,8,0,1,0,0,0,25,0,2,0,1,23,0,11,
   'R','D','B','$','M','E','S','S','A','G','E',25,0,3,0,-1,14,0,
   1,21,8,0,0,0,0,0,25,0,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_346 */

static short
   isc_352l = 98;
static char
   isc_352 [] = {
   4,2,4,0,3,0,40,32,0,7,0,7,0,2,7,'C',1,'J',12,'R','D','B','$',
   'D','A','T','A','B','A','S','E',0,-1,14,0,2,1,23,0,22,'R','D',
   'B','$','C','H','A','R','A','C','T','E','R','_','S','E','T',
   '_','N','A','M','E',41,0,0,0,2,0,1,21,8,0,1,0,0,0,25,0,1,0,-1,
   14,0,1,21,8,0,0,0,0,0,25,0,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_352 */

static short
   isc_357l = 86;
static char
   isc_357 [] = {
   4,2,4,0,2,0,9,0,7,0,2,7,'C',1,'J',12,'R','D','B','$','D','A',
   'T','A','B','A','S','E',0,-1,14,0,2,1,23,0,15,'R','D','B','$',
   'D','E','S','C','R','I','P','T','I','O','N',25,0,0,0,1,21,8,
   0,1,0,0,0,25,0,1,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,1,0,-1,-1,'L'
   
   };	/* end of blr string for request isc_357 */

static short
   isc_361l = 94;
static char
   isc_361 [] = {
   4,2,4,0,3,0,40,32,0,7,0,7,0,2,7,'C',1,'J',12,'R','D','B','$',
   'D','A','T','A','B','A','S','E',0,-1,14,0,2,1,23,0,18,'R','D',
   'B','$','S','E','C','U','R','I','T','Y','_','C','L','A','S',
   'S',41,0,0,0,2,0,1,21,8,0,1,0,0,0,25,0,1,0,-1,14,0,1,21,8,0,
   0,0,0,0,25,0,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_361 */

static short
   isc_366l = 156;
static char
   isc_366 [] = {
   4,2,4,0,6,0,40,32,0,9,0,40,32,0,7,0,7,0,7,0,2,7,'C',1,'J',12,
   'R','D','B','$','D','A','T','A','B','A','S','E',0,-1,14,0,2,
   1,23,0,22,'R','D','B','$','C','H','A','R','A','C','T','E','R',
   '_','S','E','T','_','N','A','M','E',41,0,0,0,4,0,1,23,0,15,'R',
   'D','B','$','D','E','S','C','R','I','P','T','I','O','N',25,0,
   1,0,1,23,0,18,'R','D','B','$','S','E','C','U','R','I','T','Y',
   '_','C','L','A','S','S',41,0,2,0,5,0,1,21,8,0,1,0,0,0,25,0,3,
   0,-1,14,0,1,21,8,0,0,0,0,0,25,0,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_366 */

static short
   isc_374l = 315;
static char
   isc_374 [] = {
   4,2,4,0,10,0,40,32,0,9,0,40,32,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,
   2,7,'C',1,'J',14,'R','D','B','$','C','O','L','L','A','T','I',
   'O','N','S',0,'G',57,61,23,0,15,'R','D','B','$','S','Y','S',
   'T','E','M','_','F','L','A','G',48,23,0,15,'R','D','B','$','S',
   'Y','S','T','E','M','_','F','L','A','G',21,8,0,1,0,0,0,-1,14,
   0,2,1,23,0,17,'R','D','B','$','F','U','N','C','T','I','O','N',
   '_','N','A','M','E',41,0,0,0,4,0,1,23,0,15,'R','D','B','$','D',
   'E','S','C','R','I','P','T','I','O','N',41,0,1,0,5,0,1,23,0,
   18,'R','D','B','$','C','O','L','L','A','T','I','O','N','_','N',
   'A','M','E',25,0,2,0,1,21,8,0,1,0,0,0,25,0,3,0,1,23,0,15,'R',
   'D','B','$','S','Y','S','T','E','M','_','F','L','A','G',25,0,
   6,0,1,23,0,24,'R','D','B','$','C','O','L','L','A','T','I','O',
   'N','_','A','T','T','R','I','B','U','T','E','S',25,0,7,0,1,23,
   0,20,'R','D','B','$','C','H','A','R','A','C','T','E','R','_',
   'S','E','T','_','I','D',25,0,8,0,1,23,0,16,'R','D','B','$','C',
   'O','L','L','A','T','I','O','N','_','I','D',25,0,9,0,-1,14,0,
   1,21,8,0,0,0,0,0,25,0,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_374 */

static short
   isc_386l = 390;
static char
   isc_386 [] = {
   4,2,4,0,14,0,9,0,40,32,0,40,32,0,9,0,40,32,0,7,0,7,0,7,0,7,0,
   7,0,7,0,7,0,7,0,7,0,2,7,'C',1,'J',14,'R','D','B','$','C','O',
   'L','L','A','T','I','O','N','S',0,'G',57,61,23,0,15,'R','D',
   'B','$','S','Y','S','T','E','M','_','F','L','A','G',48,23,0,
   15,'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G',
   21,8,0,1,0,0,0,-1,14,0,2,1,23,0,23,'R','D','B','$','S','P','E',
   'C','I','F','I','C','_','A','T','T','R','I','B','U','T','E',
   'S',41,0,0,0,6,0,1,23,0,23,'R','D','B','$','B','A','S','E','_',
   'C','O','L','L','A','T','I','O','N','_','N','A','M','E',41,0,
   1,0,7,0,1,23,0,17,'R','D','B','$','F','U','N','C','T','I','O',
   'N','_','N','A','M','E',41,0,2,0,8,0,1,23,0,15,'R','D','B','$',
   'D','E','S','C','R','I','P','T','I','O','N',41,0,3,0,9,0,1,23,
   0,18,'R','D','B','$','C','O','L','L','A','T','I','O','N','_',
   'N','A','M','E',25,0,4,0,1,21,8,0,1,0,0,0,25,0,5,0,1,23,0,15,
   'R','D','B','$','S','Y','S','T','E','M','_','F','L','A','G',
   25,0,10,0,1,23,0,24,'R','D','B','$','C','O','L','L','A','T',
   'I','O','N','_','A','T','T','R','I','B','U','T','E','S',25,0,
   11,0,1,23,0,20,'R','D','B','$','C','H','A','R','A','C','T','E',
   'R','_','S','E','T','_','I','D',25,0,12,0,1,23,0,16,'R','D',
   'B','$','C','O','L','L','A','T','I','O','N','_','I','D',25,0,
   13,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,5,0,-1,-1,'L'
   };	/* end of blr string for request isc_386 */

static short
   isc_402l = 131;
static char
   isc_402 [] = {
   4,2,4,0,4,0,40,32,0,40,32,0,7,0,7,0,2,7,'C',1,'J',21,'R','D',
   'B','$','C','H','E','C','K','_','C','O','N','S','T','R','A',
   'I','N','T','S',0,-1,14,0,2,1,23,0,16,'R','D','B','$','T','R',
   'I','G','G','E','R','_','N','A','M','E',41,0,0,0,3,0,1,23,0,
   19,'R','D','B','$','C','O','N','S','T','R','A','I','N','T','_',
   'N','A','M','E',25,0,1,0,1,21,8,0,1,0,0,0,25,0,2,0,-1,14,0,1,
   21,8,0,0,0,0,0,25,0,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_402 */

static short
   isc_408l = 399;
static char
   isc_408 [] = {
   4,2,4,0,14,0,40,32,0,9,0,40,32,0,40,32,0,40,32,0,8,0,7,0,7,0,
   7,0,7,0,7,0,7,0,7,0,7,0,2,7,'C',1,'J',18,'R','D','B','$','C',
   'H','A','R','A','C','T','E','R','_','S','E','T','S',0,'G',57,
   61,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L',
   'A','G',48,23,0,15,'R','D','B','$','S','Y','S','T','E','M','_',
   'F','L','A','G',21,8,0,1,0,0,0,-1,14,0,2,1,23,0,17,'R','D','B',
   '$','F','U','N','C','T','I','O','N','_','N','A','M','E',41,0,
   0,0,8,0,1,23,0,15,'R','D','B','$','D','E','S','C','R','I','P',
   'T','I','O','N',41,0,1,0,9,0,1,23,0,24,'R','D','B','$','D','E',
   'F','A','U','L','T','_','C','O','L','L','A','T','E','_','N',
   'A','M','E',25,0,2,0,1,23,0,15,'R','D','B','$','F','O','R','M',
   '_','O','F','_','U','S','E',41,0,3,0,13,0,1,23,0,22,'R','D',
   'B','$','C','H','A','R','A','C','T','E','R','_','S','E','T',
   '_','N','A','M','E',25,0,4,0,1,23,0,24,'R','D','B','$','N','U',
   'M','B','E','R','_','O','F','_','C','H','A','R','A','C','T',
   'E','R','S',41,0,5,0,12,0,1,21,8,0,1,0,0,0,25,0,6,0,1,23,0,23,
   'R','D','B','$','B','Y','T','E','S','_','P','E','R','_','C',
   'H','A','R','A','C','T','E','R',25,0,7,0,1,23,0,15,'R','D','B',
   '$','S','Y','S','T','E','M','_','F','L','A','G',25,0,10,0,1,
   23,0,20,'R','D','B','$','C','H','A','R','A','C','T','E','R',
   '_','S','E','T','_','I','D',25,0,11,0,-1,14,0,1,21,8,0,0,0,0,
   0,25,0,6,0,-1,-1,'L'
   };	/* end of blr string for request isc_408 */

static short
   isc_424l = 129;
static char
   isc_424 [] = {
   4,2,4,1,1,0,7,0,4,0,2,0,40,32,0,40,32,0,12,0,2,7,'C',1,'J',19,
   'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I',
   'E','L','D','S',0,'G',58,47,23,0,17,'R','D','B','$','R','E',
   'L','A','T','I','O','N','_','N','A','M','E',25,0,1,0,47,23,0,
   14,'R','D','B','$','F','I','E','L','D','_','N','A','M','E',25,
   0,0,0,-1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,-1,14,1,1,21,8,0,0,
   0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_424 */

static short
   isc_430l = 152;
static char
   isc_430 [] = {
   4,2,4,1,3,0,40,32,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',
   18,'R','D','B','$','V','I','E','W','_','R','E','L','A','T','I',
   'O','N','S',0,'G',47,23,0,13,'R','D','B','$','V','I','E','W',
   '_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,17,'R','D','B',
   '$','R','E','L','A','T','I','O','N','_','N','A','M','E',25,1,
   0,0,1,21,8,0,1,0,0,0,25,1,1,0,1,23,0,16,'R','D','B','$','V',
   'I','E','W','_','C','O','N','T','E','X','T',25,1,2,0,-1,14,1,
   1,21,8,0,0,0,0,0,25,1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_430 */

static short
   isc_437l = 179;
static char
   isc_437 [] = {
   4,2,4,1,4,0,40,32,0,40,32,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,
   'C',1,'J',18,'R','D','B','$','V','I','E','W','_','R','E','L',
   'A','T','I','O','N','S',0,'G',47,23,0,13,'R','D','B','$','V',
   'I','E','W','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,16,
   'R','D','B','$','C','O','N','T','E','X','T','_','N','A','M',
   'E',25,1,0,0,1,23,0,17,'R','D','B','$','R','E','L','A','T','I',
   'O','N','_','N','A','M','E',25,1,1,0,1,21,8,0,1,0,0,0,25,1,2,
   0,1,23,0,16,'R','D','B','$','V','I','E','W','_','C','O','N',
   'T','E','X','T',25,1,3,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,2,0,-1,
   -1,'L'
   };	/* end of blr string for request isc_437 */

static short
   isc_445l = 189;
static char
   isc_445 [] = {
   4,2,4,1,7,0,40,32,0,9,0,9,0,7,0,7,0,7,0,7,0,4,0,1,0,40,32,0,
   12,0,2,7,'C',1,'J',11,'R','D','B','$','I','N','D','I','C','E',
   'S',0,'G',47,23,0,14,'R','D','B','$','I','N','D','E','X','_',
   'N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,15,'R','D','B','$',
   'F','O','R','E','I','G','N','_','K','E','Y',41,1,0,0,4,0,1,23,
   0,18,'R','D','B','$','E','X','P','R','E','S','S','I','O','N',
   '_','B','L','R',41,1,1,0,5,0,1,23,0,21,'R','D','B','$','E','X',
   'P','R','E','S','S','I','O','N','_','S','O','U','R','C','E',
   41,1,2,0,6,0,1,21,8,0,1,0,0,0,25,1,3,0,-1,14,1,1,21,8,0,0,0,
   0,0,25,1,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_445 */

static short
   isc_456l = 116;
static char
   isc_456 [] = {
   4,2,4,1,2,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',11,'R',
   'D','B','$','I','N','D','I','C','E','S',0,'G',47,23,0,14,'R',
   'D','B','$','I','N','D','E','X','_','N','A','M','E',25,0,0,0,
   -1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,14,'R','D','B','$',
   'I','N','D','E','X','_','T','Y','P','E',25,1,1,0,-1,14,1,1,21,
   8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_456 */

static short
   isc_462l = 148;
static char
   isc_462 [] = {
   4,2,4,1,2,0,40,32,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',18,
   'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E',
   'N','T','S',0,'G',47,23,0,14,'R','D','B','$','I','N','D','E',
   'X','_','N','A','M','E',25,0,0,0,'F',1,'H',23,0,18,'R','D','B',
   '$','F','I','E','L','D','_','P','O','S','I','T','I','O','N',
   -1,14,1,2,1,23,0,14,'R','D','B','$','F','I','E','L','D','_',
   'N','A','M','E',25,1,0,0,1,21,8,0,1,0,0,0,25,1,1,0,-1,14,1,1,
   21,8,0,0,0,0,0,25,1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_462 */

static short
   isc_468l = 120;
static char
   isc_468 [] = {
   4,2,4,1,2,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',11,'R',
   'D','B','$','I','N','D','I','C','E','S',0,'G',47,23,0,14,'R',
   'D','B','$','I','N','D','E','X','_','N','A','M','E',25,0,0,0,
   -1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,18,'R','D','B','$',
   'I','N','D','E','X','_','I','N','A','C','T','I','V','E',25,1,
   1,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_468 */

static short
   isc_474l = 129;
static char
   isc_474 [] = {
   4,2,4,1,1,0,7,0,4,0,2,0,40,32,0,40,32,0,12,0,2,7,'C',1,'J',19,
   'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I',
   'E','L','D','S',0,'G',58,47,25,0,1,0,23,0,14,'R','D','B','$',
   'F','I','E','L','D','_','N','A','M','E',47,23,0,17,'R','D','B',
   '$','R','E','L','A','T','I','O','N','_','N','A','M','E',25,0,
   0,0,-1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,-1,14,1,1,21,8,0,0,0,
   0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_474 */

static short
   isc_480l = 124;
static char
   isc_480 [] = {
   4,2,4,1,2,0,40,32,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',18,
   'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E',
   'N','T','S',0,'G',47,23,0,14,'R','D','B','$','I','N','D','E',
   'X','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,14,'R','D',
   'B','$','F','I','E','L','D','_','N','A','M','E',25,1,0,0,1,21,
   8,0,1,0,0,0,25,1,1,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,1,0,-1,-1,
   'L'
   };	/* end of blr string for request isc_480 */

static short
   isc_486l = 197;
static char
   isc_486 [] = {
   4,2,4,1,5,0,9,0,40,32,0,7,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,
   'C',1,'J',11,'R','D','B','$','I','N','D','I','C','E','S',0,'G',
   47,23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,15,'R','D','B','$',
   'D','E','S','C','R','I','P','T','I','O','N',25,1,0,0,1,23,0,
   14,'R','D','B','$','I','N','D','E','X','_','N','A','M','E',25,
   1,1,0,1,21,8,0,1,0,0,0,25,1,2,0,1,23,0,15,'R','D','B','$','U',
   'N','I','Q','U','E','_','F','L','A','G',25,1,3,0,1,23,0,17,'R',
   'D','B','$','S','E','G','M','E','N','T','_','C','O','U','N',
   'T',25,1,4,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_486 */

static short
   isc_495l = 148;
static char
   isc_495 [] = {
   4,2,4,1,2,0,40,32,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',18,
   'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E',
   'N','T','S',0,'G',47,23,0,14,'R','D','B','$','I','N','D','E',
   'X','_','N','A','M','E',25,0,0,0,'F',1,'H',23,0,18,'R','D','B',
   '$','F','I','E','L','D','_','P','O','S','I','T','I','O','N',
   -1,14,1,2,1,23,0,14,'R','D','B','$','F','I','E','L','D','_',
   'N','A','M','E',25,1,0,0,1,21,8,0,1,0,0,0,25,1,1,0,-1,14,1,1,
   21,8,0,0,0,0,0,25,1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_495 */

static short
   isc_501l = 186;
static char
   isc_501 [] = {
   4,2,4,1,1,0,7,0,4,0,2,0,40,32,0,40,32,0,12,0,2,7,'C',2,'J',18,
   'R','D','B','$','I','N','D','E','X','_','S','E','G','M','E',
   'N','T','S',0,'J',19,'R','D','B','$','R','E','L','A','T','I',
   'O','N','_','F','I','E','L','D','S',1,'G',58,47,23,0,14,'R',
   'D','B','$','F','I','E','L','D','_','N','A','M','E',23,1,14,
   'R','D','B','$','F','I','E','L','D','_','N','A','M','E',58,47,
   23,0,14,'R','D','B','$','I','N','D','E','X','_','N','A','M',
   'E',25,0,1,0,47,23,1,17,'R','D','B','$','R','E','L','A','T',
   'I','O','N','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,21,8,0,
   1,0,0,0,25,1,0,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   
   };	/* end of blr string for request isc_501 */

static short
   isc_507l = 346;
static char
   isc_507 [] = {
   4,2,4,1,13,0,40,32,0,9,0,9,0,9,0,40,32,0,7,0,7,0,7,0,7,0,7,0,
   7,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',11,'R','D','B',
   '$','I','N','D','I','C','E','S',0,'G',47,23,0,17,'R','D','B',
   '$','R','E','L','A','T','I','O','N','_','N','A','M','E',25,0,
   0,0,-1,14,1,2,1,23,0,15,'R','D','B','$','F','O','R','E','I',
   'G','N','_','K','E','Y',41,1,0,0,6,0,1,23,0,18,'R','D','B','$',
   'E','X','P','R','E','S','S','I','O','N','_','B','L','R',41,1,
   1,0,7,0,1,23,0,21,'R','D','B','$','E','X','P','R','E','S','S',
   'I','O','N','_','S','O','U','R','C','E',41,1,2,0,8,0,1,23,0,
   15,'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N',
   25,1,3,0,1,23,0,14,'R','D','B','$','I','N','D','E','X','_','N',
   'A','M','E',25,1,4,0,1,21,8,0,1,0,0,0,25,1,5,0,1,23,0,14,'R',
   'D','B','$','I','N','D','E','X','_','T','Y','P','E',25,1,9,0,
   1,23,0,15,'R','D','B','$','U','N','I','Q','U','E','_','F','L',
   'A','G',25,1,10,0,1,23,0,18,'R','D','B','$','I','N','D','E',
   'X','_','I','N','A','C','T','I','V','E',25,1,11,0,1,23,0,17,
   'R','D','B','$','S','E','G','M','E','N','T','_','C','O','U',
   'N','T',25,1,12,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,5,0,-1,-1,'L'
   
   };	/* end of blr string for request isc_507 */

static short
   isc_524l = 193;
static char
   isc_524 [] = {
   4,2,4,1,4,0,8,0,8,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',
   20,'R','D','B','$','F','I','E','L','D','_','D','I','M','E','N',
   'S','I','O','N','S',0,'G',47,23,0,14,'R','D','B','$','F','I',
   'E','L','D','_','N','A','M','E',25,0,0,0,'F',1,'H',23,0,13,'R',
   'D','B','$','D','I','M','E','N','S','I','O','N',-1,14,1,2,1,
   23,0,15,'R','D','B','$','U','P','P','E','R','_','B','O','U',
   'N','D',25,1,0,0,1,23,0,15,'R','D','B','$','L','O','W','E','R',
   '_','B','O','U','N','D',25,1,1,0,1,21,8,0,1,0,0,0,25,1,2,0,1,
   23,0,13,'R','D','B','$','D','I','M','E','N','S','I','O','N',
   25,1,3,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_524 */

static short
   isc_532l = 334;
static char
   isc_532 [] = {
   4,2,4,1,11,0,9,0,9,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,4,0,
   2,0,40,32,0,40,32,0,12,0,2,7,'C',2,'J',19,'R','D','B','$','R',
   'E','L','A','T','I','O','N','_','F','I','E','L','D','S',0,'J',
   10,'R','D','B','$','F','I','E','L','D','S',1,'G',58,47,23,0,
   14,'R','D','B','$','F','I','E','L','D','_','N','A','M','E',25,
   0,1,0,58,47,23,0,17,'R','D','B','$','R','E','L','A','T','I',
   'O','N','_','N','A','M','E',25,0,0,0,47,23,0,16,'R','D','B',
   '$','F','I','E','L','D','_','S','O','U','R','C','E',23,1,14,
   'R','D','B','$','F','I','E','L','D','_','N','A','M','E',-1,14,
   1,2,1,23,0,18,'R','D','B','$','D','E','F','A','U','L','T','_',
   'S','O','U','R','C','E',41,1,0,0,7,0,1,23,0,17,'R','D','B','$',
   'D','E','F','A','U','L','T','_','V','A','L','U','E',41,1,1,0,
   8,0,1,21,8,0,1,0,0,0,25,1,2,0,1,23,0,16,'R','D','B','$','C',
   'O','L','L','A','T','I','O','N','_','I','D',41,1,4,0,3,0,1,23,
   1,20,'R','D','B','$','C','H','A','R','A','C','T','E','R','_',
   'S','E','T','_','I','D',41,1,6,0,5,0,1,23,0,13,'R','D','B','$',
   'N','U','L','L','_','F','L','A','G',41,1,10,0,9,0,-1,14,1,1,
   21,8,0,0,0,0,0,25,1,2,0,-1,-1,'L'
   };	/* end of blr string for request isc_532 */

static short
   isc_548l = 115;
static char
   isc_548 [] = {
   4,2,4,1,2,0,7,0,7,0,4,0,1,0,40,32,0,12,0,2,7,'C',1,'J',10,'R',
   'D','B','$','F','I','E','L','D','S',0,'G',47,23,0,14,'R','D',
   'B','$','F','I','E','L','D','_','N','A','M','E',25,0,0,0,-1,
   14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,14,'R','D','B','$','D',
   'I','M','E','N','S','I','O','N','S',25,1,1,0,-1,14,1,1,21,8,
   0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_548 */

static short
   isc_554l = 158;
static char
   isc_554 [] = {
   4,2,4,1,2,0,40,32,0,7,0,4,0,2,0,40,32,0,40,32,0,12,0,2,7,'C',
   1,'J',19,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'F','I','E','L','D','S',0,'G',58,47,23,0,17,'R','D','B','$',
   'R','E','L','A','T','I','O','N','_','N','A','M','E',25,0,1,0,
   47,23,0,14,'R','D','B','$','F','I','E','L','D','_','N','A','M',
   'E',25,0,0,0,-1,14,1,2,1,23,0,18,'R','D','B','$','S','E','C',
   'U','R','I','T','Y','_','C','L','A','S','S',25,1,0,0,1,21,8,
   0,1,0,0,0,25,1,1,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,1,0,-1,-1,'L'
   
   };	/* end of blr string for request isc_554 */

static short
   isc_561l = 154;
static char
   isc_561 [] = {
   4,2,4,1,2,0,7,0,7,0,4,0,2,0,40,32,0,40,32,0,12,0,2,7,'C',1,'J',
   19,'R','D','B','$','R','E','L','A','T','I','O','N','_','F','I',
   'E','L','D','S',0,'G',58,47,23,0,17,'R','D','B','$','R','E',
   'L','A','T','I','O','N','_','N','A','M','E',25,0,1,0,47,23,0,
   14,'R','D','B','$','F','I','E','L','D','_','N','A','M','E',25,
   0,0,0,-1,14,1,2,1,21,8,0,1,0,0,0,25,1,0,0,1,23,0,15,'R','D',
   'B','$','S','Y','S','T','E','M','_','F','L','A','G',25,1,1,0,
   -1,14,1,1,21,8,0,0,0,0,0,25,1,0,0,-1,-1,'L'
   };	/* end of blr string for request isc_561 */

static short
   isc_568l = 156;
static char
   isc_568 [] = {
   4,2,4,1,2,0,40,32,0,7,0,4,0,2,0,40,32,0,40,32,0,12,0,2,7,'C',
   1,'J',19,'R','D','B','$','R','E','L','A','T','I','O','N','_',
   'F','I','E','L','D','S',0,'G',58,47,23,0,14,'R','D','B','$',
   'F','I','E','L','D','_','N','A','M','E',25,0,1,0,47,23,0,17,
   'R','D','B','$','R','E','L','A','T','I','O','N','_','N','A',
   'M','E',25,0,0,0,-1,14,1,2,1,23,0,16,'R','D','B','$','C','O',
   'M','P','L','E','X','_','N','A','M','E',25,1,0,0,1,21,8,0,1,
   0,0,0,25,1,1,0,-1,14,1,1,21,8,0,0,0,0,0,25,1,1,0,-1,-1,'L'
   };	/* end of blr string for request isc_568 */

static short
   isc_575l = 607;
static char
   isc_575 [] = {
   4,2,4,1,22,0,9,0,40,32,0,40,32,0,40,32,0,40,32,0,40,32,0,9,0,
   9,0,7,0,40,126,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,
   7,0,4,0,1,0,40,32,0,12,0,2,7,'C',2,'J',19,'R','D','B','$','R',
   'E','L','A','T','I','O','N','_','F','I','E','L','D','S',0,'J',
   10,'R','D','B','$','F','I','E','L','D','S',1,'G',58,47,23,0,
   16,'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C',
   'E',23,1,14,'R','D','B','$','F','I','E','L','D','_','N','A',
   'M','E',47,23,0,17,'R','D','B','$','R','E','L','A','T','I','O',
   'N','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,1,16,'R','D',
   'B','$','C','O','M','P','U','T','E','D','_','B','L','R',25,1,
   0,0,1,23,0,17,'R','D','B','$','R','E','L','A','T','I','O','N',
   '_','N','A','M','E',25,1,1,0,1,23,0,14,'R','D','B','$','Q','U',
   'E','R','Y','_','N','A','M','E',25,1,2,0,1,23,0,14,'R','D','B',
   '$','B','A','S','E','_','F','I','E','L','D',25,1,3,0,1,23,0,
   16,'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C',
   'E',25,1,4,0,1,23,0,14,'R','D','B','$','F','I','E','L','D','_',
   'N','A','M','E',25,1,5,0,1,23,0,16,'R','D','B','$','Q','U','E',
   'R','Y','_','H','E','A','D','E','R',41,1,6,0,15,0,1,23,0,15,
   'R','D','B','$','D','E','S','C','R','I','P','T','I','O','N',
   41,1,7,0,16,0,1,21,8,0,1,0,0,0,25,1,8,0,1,23,0,15,'R','D','B',
   '$','E','D','I','T','_','S','T','R','I','N','G',25,1,9,0,1,23,
   0,15,'R','D','B','$','U','P','D','A','T','E','_','F','L','A',
   'G',41,1,11,0,10,0,1,23,0,16,'R','D','B','$','V','I','E','W',
   '_','C','O','N','T','E','X','T',25,1,12,0,1,23,0,18,'R','D',
   'B','$','F','I','E','L','D','_','P','O','S','I','T','I','O',
   'N',41,1,14,0,13,0,1,23,0,12,'R','D','B','$','F','I','E','L',
   'D','_','I','D',25,1,17,0,1,23,1,15,'R','D','B','$','F','I',
   'E','L','D','_','S','C','A','L','E',25,1,18,0,1,23,1,16,'R',
   'D','B','$','F','I','E','L','D','_','L','E','N','G','T','H',
   25,1,19,0,1,23,1,18,'R','D','B','$','F','I','E','L','D','_',
   'S','U','B','_','T','Y','P','E',25,1,20,0,1,23,1,14,'R','D',
   'B','$','F','I','E','L','D','_','T','Y','P','E',25,1,21,0,-1,
   14,1,1,21,8,0,0,0,0,0,25,1,8,0,-1,-1,'L'
   };	/* end of blr string for request isc_575 */

static short
   isc_601l = 838;
static char
   isc_601 [] = {
   4,2,4,1,35,0,9,0,9,0,40,32,0,9,0,40,32,0,40,32,0,40,32,0,40,
   32,0,40,32,0,9,0,9,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,
   7,0,40,126,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,7,0,
   4,0,1,0,40,32,0,12,0,2,7,'C',2,'J',19,'R','D','B','$','R','E',
   'L','A','T','I','O','N','_','F','I','E','L','D','S',0,'J',10,
   'R','D','B','$','F','I','E','L','D','S',1,'G',58,47,23,0,16,
   'R','D','B','$','F','I','E','L','D','_','S','O','U','R','C',
   'E',23,1,14,'R','D','B','$','F','I','E','L','D','_','N','A',
   'M','E',47,23,0,17,'R','D','B','$','R','E','L','A','T','I','O',
   'N','_','N','A','M','E',25,0,0,0,-1,14,1,2,1,23,0,18,'R','D',
   'B','$','D','E','F','A','U','L','T','_','S','O','U','R','C',
   'E',41,1,0,0,16,0,1,23,0,17,'R','D','B','$','D','E','F','A',
   'U','L','T','_','V','A','L','U','E',41,1,1,0,17,0,1,23,0,18,
   'R','D','B','$','S','E','C','U','R','I','T','Y','_','C','L',
   'A','S','S',25,1,2,0,1,23,1,16,'R','D','B','$','C','O','M','P',
   'U','T','E','D','_','B','L','R',25,1,3,0,1,23,0,16,'R','D','B',
   '$','C','O','M','P','L','E','X','_','N','A','M','E',25,1,4,0,
   1,23,0,14,'R','D','B','$','Q','U','E','R','Y','_','N','A','M',
   'E',25,1,5,0,1,23,0,14,'R','D','B','$','B','A','S','E','_','F',
   'I','E','L','D',25,1,6,0,1,23,0,16,'R','D','B','$','F','I','E',
   'L','D','_','S','O','U','R','C','E',25,1,7,0,1,23,0,14,'R','D',
   'B','$','F','I','E','L','D','_','N','A','M','E',25,1,8,0,1,23,
   0,16,'R','D','B','$','Q','U','E','R','Y','_','H','E','A','D',
   'E','R',41,1,9,0,28,0,1,23,0,15,'R','D','B','$','D','E','S',
   'C','R','I','P','T','I','O','N',41,1,10,0,29,0,1,21,8,0,1,0,
   0,0,25,1,11,0,1,23,0,16,'R','D','B','$','C','O','L','L','A',
   'T','I','O','N','_','I','D',41,1,13,0,12,0,1,23,1,20,'R','D',
   'B','$','C','H','A','R','A','C','T','E','R','_','S','E','T',
   '_','I','D',41,1,15,0,14,0,1,23,0,13,'R','D','B','$','N','U',
   'L','L','_','F','L','A','G',41,1,19,0,18,0,1,23,1,14,'R','D',
   'B','$','D','I','M','E','N','S','I','O','N','S',25,1,20,0,1,
   23,0,15,'R','D','B','$','S','Y','S','T','E','M','_','F','L',
   'A','G',25,1,21,0,1,23,0,15,'R','D','B','$','E','D','I','T',
   '_','S','T','R','I','N','G',25,1,22,0,1,23,0,15,'R','D','B',
   '$','U','P','D','A','T','E','_','F','L','A','G',41,1,24,0,23,
   0,1,23,0,16,'R','D','B','$','V','I','E','W','_','C','O','N',
   'T','E','X','T',25,1,25,0,1,23,0,18,'R','D','B','$','F','I',
   'E','L','D','_','P','O','S','I','T','I','O','N',41,1,27,0,26,
   0,1,23,0,12,'R','D','B','$','F','I','E','L','D','_','I','D',
   25,1,30,0,1,23,1,15,'R','D','B','$','F','I','E','L','D','_',
   'S','C','A','L','E',25,1,31,0,1,23,1,16,'R','D','B','$','F',
   'I','E','L','D','_','L','E','N','G','T','H',25,1,32,0,1,23,1,
   18,'R','D','B','$','F','I','E','L','D','_','S','U','B','_','T',
   'Y','P','E',25,1,33,0,1,23,1,14,'R','D','B','$','F','I','E',
   'L','D','_','T','Y','P','E',25,1,34,0,-1,14,1,1,21,8,0,0,0,0,
   0,25,1,11,0,-1,-1,'L'
   };	/* end of blr string for request isc_601 */

static short
   isc_640l = 172;
static char
   isc_640 [] = {
   4,2,4,0,4,0,9,0,9,0,40,32,0,7,0,2,7,'C',1,'J',20,'R','D','B',
   '$','S','E','C','U','R','I','T','Y','_','C','L','A','S','S',
   'E','S',0,'G',59,55,23,0,18,'R','D','B','$','S','E','C','U',
   'R','I','T','Y','_','C','L','A','S','S',21,14,4,0,'S','Q','L',
   '$',-1,14,0,2,1,23,0,15,'R','D','B','$','D','E','S','C','R',
   'I','P','T','I','O','N',25,0,0,0,1,23,0,7,'R','D','B','$','A',
   'C','L',25,0,1,0,1,23,0,18,'R','D','B','$','S','E','C','U','R',
   'I','T','Y','_','C','L','A','S','S',25,0,2,0,1,21,8,0,1,0,0,
   0,25,0,3,0,-1,14,0,1,21,8,0,0,0,0,0,25,0,3,0,-1,-1,'L'
   };	/* end of blr string for request isc_640 */


#define gds_blob_null	isc_blob_null	/* compatibility symbols */
#define gds_status	isc_status
#define gds_status2	isc_status2
#define gds_array_length	isc_array_length
#define gds_count	isc_count
#define gds_slack	isc_slack
#define gds_utility	isc_utility	/* end of compatibility symbols */

#ifndef isc_version4
    Generate a compile-time error.
    Picking up a V3 include file after preprocessing with V4 GPRE.
#endif

/**** end of GPRE definitions ****/


#define DB			tdgbl->db_handle
#define gds_trans	tdgbl->tr_handle
#define isc_status	tdgbl->status

namespace // unnamed, private
{

// VERBOSE INTERVAL WHEN BACKING RECORDS
const ULONG BACKUP_VERBOSE_INTERVAL = 20000;

#define PUT_MESSAGE(attribute, message)	put_message ((attribute), (message), sizeof(message))
#define PUT_TEXT(attribute, text)	put_text ((attribute), (text), sizeof(text))
#define COPY(source, target)       copy ((source), (target), sizeof(target))

inline void put(BurpGlobals* tdgbl, UCHAR c)
{
	if (--(tdgbl->io_cnt) >= 0)
		*(tdgbl->io_ptr)++ = c;
	else
		MVOL_write(c, &tdgbl->io_cnt, &tdgbl->io_ptr);
}
 
inline const UCHAR* put_block(BurpGlobals* tdgbl, const UCHAR* p, ULONG n)
{
	return MVOL_write_block (tdgbl, p, n);
}


void compress(const UCHAR*, ULONG);
int copy(const TEXT *, TEXT *, ULONG);
burp_fld* get_fields(burp_rel*);
SINT64 get_gen_id(const TEXT *, SSHORT);
void get_ranges(burp_fld*);
void put_array(burp_fld*, burp_rel*, ISC_QUAD *);
void put_asciz(const SCHAR, const TEXT*);
void put_blob(burp_fld*, ISC_QUAD *, ULONG);
bool put_blr_blob(SCHAR, ISC_QUAD *);
void put_data(burp_rel*);
void put_index(burp_rel*);
int put_message(SCHAR, const TEXT *, ULONG);
void put_numeric(SCHAR, SLONG);
void put_relation(burp_rel*);
bool put_source_blob(SCHAR, SCHAR, ISC_QUAD *);
int put_text(SCHAR, const TEXT *, SSHORT);
void set_capabilities(void);
void write_character_sets(void);
void write_check_constraints(void);
void write_collations(void);
void write_database(const TEXT*);
void write_exceptions(void);
void write_field_dimensions(void);
void write_filters(void);
void write_functions(void);
void write_function_args(GDS_NAME);
void write_generators(void);
void write_sql_roles(void);
void write_global_fields(void);
void write_procedures(void);
void write_procedure_prms(GDS_NAME);
void write_ref_constraints(void);
void write_rel_constraints(void);
void write_relations(void);
void write_shadow_files(void);
void write_triggers(void);
void write_trigger_messages(void);
void write_types(void);
void write_user_privileges(void);
void general_on_error(void);

enum backup_capabilities
{
	BCK_security		= 1,
	BCK_files			= 2,
	BCK_external		= 4,
	BCK_idx_inactive	= 8,
	BCK_triggers		= 16,	// Obsolete - 1996-Aug-05
	BCK_context_name	= 32,
	BCK_db_description	= 64,
	BCK_ffmptt			= 128,	// rdb$functions, rdb$filters, rdb$trigger_messages,
								// rdb$user_privileges, rdb$triggers, rdb$types
	BCK_attributes_v3	= 256,	// attributes in various system relations new to v3
	BCK_rfr_sys_flag	= 512,	// system flag is missing from Rdb/VMS V3 RFR relation
	BCK_ods6			= 1024,	// rdb$field_dimensions and shadow files
	BCK_ods8			= 2048,	// stored procedures & exceptions & constraints
	BCK_ods9			= 4096,	// SQL roles
	BCK_ods10			= 8192,	// FIELD_PRECISION
	BCK_ods11           = 16384 // rdb$description in rdb$roles and rdb$generators
								// rdb$base_collation_name and rdb$specific_attributes in rdb$collations
};

#ifdef DEBUG
UCHAR debug_on = 0;		// able to turn this on in debug mode 
#endif


/*  
   table used to determine capabilities, checking for specific 
   fields in system relations 
*/

struct rfr_tab_t
{
	const TEXT* relation;
	const TEXT* field;
	// Let's be compatible with BurpGlobals.BCK_capabilities, although we could follow
	// the enumeration backup_capabilities but the enum then should be defined
	// in burp.h instead so BCK_capabilities isn't anymore a simple SLONG.
	SLONG bit_mask;
};

const rfr_tab_t rfr_table[] =
{
	{"RDB$INDICES", "RDB$INDEX_INACTIVE", BCK_idx_inactive},
/* Backup of V2 triggers no longer supported 1996-Aug-05 David Schnepper  
	{"RDB$RELATIONS",	"RDB$STORE_TRIGGER",	BCK_triggers}, 
*/
	{"RDB$RELATIONS", "RDB$EXTERNAL_FILE", BCK_external},
	{"RDB$SECURITY_CLASSES", "RDB$SECURITY_CLASS", BCK_security},
	{"RDB$FILES", "RDB$FILE_NAME", BCK_files},
	{"RDB$VIEW_RELATIONS", "RDB$CONTEXT_NAME", BCK_context_name},
	{"RDB$DATABASE", "RDB$DESCRIPTION", BCK_db_description},
	{"RDB$FUNCTIONS", "RDB$FUNCTION_NAME", BCK_ffmptt},
	{"RDB$FIELDS", "RDB$EXTERNAL_LENGTH", BCK_attributes_v3},
	{"RDB$RELATION_FIELDS", "RDB$SYSTEM_FLAG", BCK_rfr_sys_flag},
	{"RDB$FIELD_DIMENSIONS", "RDB$DIMENSION", BCK_ods6},
	{"RDB$PROCEDURES", "RDB$PROCEDURE_NAME", BCK_ods8},
	{"RDB$ROLES", "RDB$ROLE_NAME", BCK_ods9},
	{"RDB$FIELDS", "RDB$FIELD_PRECISION", BCK_ods10},
	{"RDB$ROLES", "RDB$DESCRIPTION", BCK_ods11},
	{"RDB$COLLATIONS", "RDB$BASE_COLLATION_NAME", BCK_ods11},
	{"RDB$COLLATIONS", "RDB$SPECIFIC_ATTRIBUTES", BCK_ods11},
	{0, 0, 0}
};

const SCHAR blob_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_num_segments,
	isc_info_blob_type,
	isc_info_blob_total_length
};
const SCHAR blr_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_total_length
};
const SCHAR source_items[] =
{
	isc_info_blob_max_segment,
	isc_info_blob_total_length,
	isc_info_blob_num_segments
};
const SCHAR db_info_items[] =
{
	isc_info_db_sql_dialect,
	isc_info_page_size,
	isc_info_sweep_interval,
	isc_info_forced_writes,
	isc_info_no_reserve,
	isc_info_set_page_buffers,
	isc_info_db_read_only,
	isc_info_end
};
const SCHAR limbo_tpb[] =
{
	isc_tpb_version1,
	isc_tpb_ignore_limbo
};
const SCHAR limbo_nau_tpb[] =
{
	isc_tpb_version1,
	isc_tpb_ignore_limbo,
	isc_tpb_no_auto_undo
};

} // namespace


int BACKUP_backup(const TEXT* dbb_file, const TEXT* file_name)
{
   struct {
          ISC_QUAD isc_642;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_643;	/* RDB$ACL */
          char  isc_644 [32];	/* RDB$SECURITY_CLASS */
          short isc_645;	/* isc_utility */
   } isc_641;
/**************************************
 *
 *	B A C K U P _ b a c k u p
 *
 **************************************
 *
 * Functional description
 *	Backup a database.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	tdgbl->gbl_database_file_name = dbb_file;

	tdgbl->io_ptr = NULL;
	tdgbl->io_cnt = 0;
	tdgbl->relations = NULL;
	tdgbl->BCK_capabilities = 0;

	gds_trans = 0;

	BURP_verbose(130, NULL, NULL, NULL, NULL, NULL);
	// msg 130 starting transaction 

	if (tdgbl->gbl_sw_ignore_limbo)
	{
		if (isc_start_transaction(status_vector, &gds_trans, 1, &DB,
								  sizeof(limbo_nau_tpb), limbo_nau_tpb))
		{
			isc_start_transaction(status_vector, &gds_trans, 1, &DB,
								  sizeof(limbo_tpb), limbo_tpb);
		}
	}
	else
	{
		/*EXEC SQL SET TRANSACTION NO_AUTO_UNDO;*/
		{
		isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 5, isc_tpb_0);
		SQLCODE = isc_sqlcode(isc_status);
		}
		if (isc_status[1])
			/*EXEC SQL SET TRANSACTION;*/
			{
			isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 4, isc_tpb_1);
			SQLCODE = isc_sqlcode(isc_status);
			}
	}

	if (!gds_trans)
	{
		/*EXEC SQL SET TRANSACTION NAME gds_trans NO_AUTO_UNDO;*/
		{
		isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 5, isc_tpb_2);
		SQLCODE = isc_sqlcode(isc_status);
		}
		if (isc_status[1])
			/*EXEC SQL SET TRANSACTION NAME gds_trans;*/
			{
			isc_start_transaction (isc_status, (FB_API_HANDLE*) &gds_trans, (short) 1, &DB, (short) 4, isc_tpb_3);
			SQLCODE = isc_sqlcode(isc_status);
			}
	}




// decide what type of database we've got 

	set_capabilities();

// Write burp record first with other valuable information 
// In case of split operation, write a 'split' header first to all the files 

	if (tdgbl->action->act_action == ACT_backup_split)
	{
		for (burp_fil* fil = tdgbl->gbl_sw_files; fil; fil = fil->fil_next)
		{
			tdgbl->action->act_file = fil;
			if (MVOL_split_hdr_write() == FALSE)
			{
				BURP_error(269, true, tdgbl->action->act_file->fil_name, 0, 0, 0, 0);
				// msg 269 can't write a header record to file %s 
			}
		}
		tdgbl->action->act_file = tdgbl->gbl_sw_files;
	}

	MVOL_init_write(dbb_file, file_name, &tdgbl->io_cnt, &tdgbl->io_ptr);

// Write database record 

	write_database(dbb_file);

// Write global fields 

	BURP_verbose(150, NULL, NULL, NULL, NULL, NULL);
	// msg 150  writing global fields 
	write_global_fields();

	if (tdgbl->BCK_capabilities & BCK_ods6)
	{
		write_field_dimensions();

		BURP_verbose(162, NULL, NULL, NULL, NULL, NULL);
		// msg 162  writing shadow files 
		write_shadow_files();
	}

// Write relations 

	BURP_verbose(154, NULL, NULL, NULL, NULL, NULL);
	// msg 154 writing relations 

	write_relations();

	if (tdgbl->BCK_capabilities & BCK_ffmptt)
	{
		// Write functions 
		BURP_verbose(148, NULL, NULL, NULL, NULL, NULL);
		// msg 148 writing functions 
		write_functions();

		// Write types 
		BURP_verbose(161, NULL, NULL, NULL, NULL, NULL);
		// msg 161  writing types 
		write_types();

		// Write filters 
		BURP_verbose(146, NULL, NULL, NULL, NULL, NULL);
		// msg 146 writing filters 
		write_filters();

		// Write generators 

		BURP_verbose(164, NULL, NULL, NULL, NULL, NULL);
		// msg 164  writing id generators 
		write_generators();
	}

	if (tdgbl->BCK_capabilities & BCK_ods8)
	{
		// Write procedures 
		BURP_verbose(192, NULL, NULL, NULL, NULL, NULL);
		// msg 192 writing stored procedures 
		write_procedures();

		// Write exceptions 
		BURP_verbose(197, NULL, NULL, NULL, NULL, NULL);
		// msg 197 writing exceptions 
		write_exceptions();

		// Write Character Sets 
		BURP_verbose(msgVerbose_write_charsets, NULL, NULL, NULL, NULL, NULL);
		write_character_sets();

		// Write Collations 
		BURP_verbose(msgVerbose_write_collations, NULL, NULL, NULL, NULL,
					 NULL);
		write_collations();

	}

// Now go back and write all data 

	for (burp_rel* relation = tdgbl->relations; relation; relation = relation->rel_next) {
		put(tdgbl, (UCHAR) (rec_relation_data));
		PUT_TEXT(att_relation_name, relation->rel_name);
		put(tdgbl, (UCHAR) (att_end));

		if (!(relation->rel_flags & REL_view) && 
			!(relation->rel_flags & REL_external))
		{
			
			put_index(relation);
			if (!tdgbl->gbl_sw_meta)
				put_data(relation);
		}

		put(tdgbl, (UCHAR) (rec_relation_end));
	}

// now for the new triggers in rdb$triggers 
	if (tdgbl->BCK_capabilities & BCK_ffmptt) {
		BURP_verbose(159, NULL, NULL, NULL, NULL, NULL);
		// msg 159  writing triggers 
		write_triggers();
		BURP_verbose(158, NULL, NULL, NULL, NULL, NULL);
		// msg 158 writing trigger messages 
		write_trigger_messages();
		write_user_privileges();
	}

// Last, but not least, go back and add any access control lists 

	if (tdgbl->BCK_capabilities & BCK_security)
	{
		isc_req_handle req_handle1 = 0;
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$SECURITY_CLASSES WITH X.RDB$SECURITY_CLASS NOT STARTING "SQL$"*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_640), (char *) isc_640);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 50, &isc_641, (short) 0);
		   if (!isc_641.isc_645 || isc_status [1]) break;
			put(tdgbl, rec_security_class);
			const ULONG l = PUT_TEXT (att_class_security_class, /*X.RDB$SECURITY_CLASS*/
									    isc_641.isc_644);
			MISC_terminate (/*X.RDB$SECURITY_CLASS*/
					isc_641.isc_644, temp, l, sizeof(temp));
			BURP_verbose (155, temp, NULL, NULL, NULL, NULL);
			// msg 155 writing security class %s 
			put_blr_blob (att_class_acl, &/*X.RDB$ACL*/
						      isc_641.isc_643);
			put_source_blob (att_class_description2, att_class_description,
							 &/*X.RDB$DESCRIPTION*/
							  isc_641.isc_642);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}

		MISC_release_request_silent(req_handle1);
	}

	if (tdgbl->BCK_capabilities & BCK_ods8)
	{
		// Write relation constraints  
		BURP_verbose(206, NULL, NULL, NULL, NULL, NULL);
		// msg 206 writing relation constraints 
		write_rel_constraints();

		// Write referential constraints  
		BURP_verbose(209, NULL, NULL, NULL, NULL, NULL);
		// msg 209 writing referential constraints 
		write_ref_constraints();

		// Write check constraints  
		BURP_verbose(210, NULL, NULL, NULL, NULL, NULL);
		// msg 210 writing check constraints 
		write_check_constraints();

	}

	if (tdgbl->BCK_capabilities & BCK_ods9)
	{
		// Write SQL roles  
		BURP_verbose(248, NULL, NULL, NULL, NULL, NULL);
		// msg 248 writing SQL roles 
		write_sql_roles();
	}

// Finish up 

	put(tdgbl, (UCHAR) (rec_end));
	
	UINT64 cumul_count = MVOL_fini_write(&tdgbl->io_cnt, &tdgbl->io_ptr);
	if (cumul_count <= MAX_SLONG) {
		SLONG tempcount = cumul_count;
		BURP_verbose(176, (void*) (IPTR)tempcount, NULL, NULL, NULL, NULL);
		// msg 176 closing file, committing, and finishing.  %ld bytes written 
	}
	else {
		char psz[64];
		sprintf(psz, "%" QUADFORMAT "d", cumul_count);
		BURP_verbose(283, psz, NULL, NULL, NULL, NULL);
		// msg 283 closing file, committing, and finishing.  %s bytes written 
	}
	/*COMMIT;*/
	{
	isc_commit_transaction (isc_status, (FB_API_HANDLE*) &gds_trans);;
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (gds_trans)
		/*COMMIT gds_trans;*/
		{
		isc_commit_transaction (isc_status, (FB_API_HANDLE*) &gds_trans);;
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	/*FINISH*/
	{
	if (DB)
	   isc_detach_database (isc_status, &DB);;
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	return FINI_OK;
}

namespace // unnamed, private
{
   struct {
          char  isc_6 [32];	/* RDB$FIELD_NAME */
          char  isc_7 [32];	/* RDB$RELATION_NAME */
          char  isc_8 [32];	/* RDB$GRANTOR */
          char  isc_9 [32];	/* RDB$USER */
          short isc_10;	/* isc_utility */
          short isc_11;	/* gds__null_flag */
          short isc_12;	/* RDB$GRANT_OPTION */
          char  isc_13 [7];	/* RDB$PRIVILEGE */
   } isc_5;
   struct {
          char  isc_16 [32];	/* RDB$FIELD_NAME */
          char  isc_17 [32];	/* RDB$RELATION_NAME */
          char  isc_18 [32];	/* RDB$GRANTOR */
          char  isc_19 [32];	/* RDB$USER */
          short isc_20;	/* isc_utility */
          short isc_21;	/* RDB$OBJECT_TYPE */
          short isc_22;	/* RDB$USER_TYPE */
          short isc_23;	/* gds__null_flag */
          short isc_24;	/* RDB$GRANT_OPTION */
          char  isc_25 [7];	/* RDB$PRIVILEGE */
   } isc_15;
   struct {
          ISC_QUAD isc_28;	/* RDB$DESCRIPTION */
          char  isc_29 [32];	/* RDB$FIELD_NAME */
          char  isc_30 [32];	/* RDB$TYPE_NAME */
          short isc_31;	/* isc_utility */
          short isc_32;	/* RDB$SYSTEM_FLAG */
          short isc_33;	/* RDB$TYPE */
   } isc_27;
   struct {
          char  isc_36 [32];	/* RDB$TRIGGER_NAME */
          short isc_37;	/* isc_utility */
          char  isc_38 [1022];	/* RDB$MESSAGE */
          short isc_39;	/* RDB$MESSAGE_NUMBER */
   } isc_35;
   struct {
          short isc_44;	/* isc_utility */
          short isc_45;	/* gds__null_flag */
          short isc_46;	/* RDB$FLAGS */
   } isc_43;
   struct {
          char  isc_42 [32];	/* RDB$TRIGGER_NAME */
   } isc_41;
   struct {
          ISC_QUAD isc_49;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_50;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_51;	/* RDB$TRIGGER_BLR */
          char  isc_52 [32];	/* RDB$RELATION_NAME */
          char  isc_53 [32];	/* RDB$TRIGGER_NAME */
          short isc_54;	/* isc_utility */
          short isc_55;	/* RDB$TRIGGER_INACTIVE */
          short isc_56;	/* RDB$SYSTEM_FLAG */
          short isc_57;	/* RDB$TRIGGER_TYPE */
          short isc_58;	/* RDB$TRIGGER_SEQUENCE */
   } isc_48;
   struct {
          ISC_QUAD isc_61;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_62;	/* RDB$TRIGGER_SOURCE */
          ISC_QUAD isc_63;	/* RDB$TRIGGER_BLR */
          char  isc_64 [32];	/* RDB$RELATION_NAME */
          char  isc_65 [32];	/* RDB$TRIGGER_NAME */
          short isc_66;	/* isc_utility */
          short isc_67;	/* gds__null_flag */
          short isc_68;	/* RDB$FLAGS */
          short isc_69;	/* RDB$TRIGGER_INACTIVE */
          short isc_70;	/* RDB$SYSTEM_FLAG */
          short isc_71;	/* RDB$TRIGGER_TYPE */
          short isc_72;	/* RDB$TRIGGER_SEQUENCE */
   } isc_60;
   struct {
          char  isc_75 [32];	/* RDB$OWNER_NAME */
          char  isc_76 [32];	/* RDB$ROLE_NAME */
          short isc_77;	/* isc_utility */
   } isc_74;
   struct {
          ISC_QUAD isc_80;	/* RDB$DESCRIPTION */
          char  isc_81 [32];	/* RDB$OWNER_NAME */
          char  isc_82 [32];	/* RDB$ROLE_NAME */
          short isc_83;	/* isc_utility */
          short isc_84;	/* gds__null_flag */
   } isc_79;
   struct {
          ISC_LONG isc_87;	/* RDB$FILE_LENGTH */
          ISC_LONG isc_88;	/* RDB$FILE_START */
          short isc_89;	/* isc_utility */
          short isc_90;	/* RDB$SHADOW_NUMBER */
          short isc_91;	/* RDB$FILE_FLAGS */
          short isc_92;	/* RDB$FILE_SEQUENCE */
          char  isc_93 [254];	/* RDB$FILE_NAME */
   } isc_86;
   struct {
          char  isc_98 [32];	/* RDB$OWNER_NAME */
          ISC_QUAD isc_99;	/* RDB$EXTERNAL_DESCRIPTION */
          short isc_100;	/* isc_utility */
          short isc_101;	/* gds__null_flag */
          char  isc_102 [254];	/* RDB$EXTERNAL_FILE */
   } isc_97;
   struct {
          char  isc_96 [32];	/* RDB$RELATION_NAME */
   } isc_95;
   struct {
          char  isc_107 [32];	/* RDB$SECURITY_CLASS */
          short isc_108;	/* isc_utility */
          short isc_109;	/* gds__null_flag */
   } isc_106;
   struct {
          char  isc_105 [32];	/* RDB$RELATION_NAME */
   } isc_104;
   struct {
          short isc_114;	/* isc_utility */
          short isc_115;	/* gds__null_flag */
          short isc_116;	/* RDB$FLAGS */
   } isc_113;
   struct {
          char  isc_112 [32];	/* RDB$RELATION_NAME */
   } isc_111;
   struct {
          ISC_QUAD isc_119;	/* RDB$VIEW_SOURCE */
          ISC_QUAD isc_120;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_121;	/* RDB$VIEW_BLR */
          char  isc_122 [32];	/* RDB$RELATION_NAME */
          short isc_123;	/* isc_utility */
          short isc_124;	/* RDB$RELATION_ID */
          short isc_125;	/* RDB$SYSTEM_FLAG */
   } isc_118;
   struct {
          char  isc_128 [32];	/* RDB$OWNER_NAME */
          ISC_QUAD isc_129;	/* RDB$EXTERNAL_DESCRIPTION */
          ISC_QUAD isc_130;	/* RDB$VIEW_SOURCE */
          ISC_QUAD isc_131;	/* RDB$DESCRIPTION */
          char  isc_132 [32];	/* RDB$SECURITY_CLASS */
          ISC_QUAD isc_133;	/* RDB$VIEW_BLR */
          char  isc_134 [32];	/* RDB$RELATION_NAME */
          short isc_135;	/* isc_utility */
          short isc_136;	/* RDB$RELATION_ID */
          short isc_137;	/* gds__null_flag */
          char  isc_138 [254];	/* RDB$EXTERNAL_FILE */
          short isc_139;	/* gds__null_flag */
          short isc_140;	/* gds__null_flag */
          short isc_141;	/* RDB$FLAGS */
          short isc_142;	/* RDB$SYSTEM_FLAG */
   } isc_127;
   struct {
          char  isc_145 [32];	/* RDB$INDEX_NAME */
          char  isc_146 [32];	/* RDB$RELATION_NAME */
          char  isc_147 [32];	/* RDB$CONSTRAINT_NAME */
          char  isc_148 [4];	/* RDB$INITIALLY_DEFERRED */
          char  isc_149 [4];	/* RDB$DEFERRABLE */
          char  isc_150 [12];	/* RDB$CONSTRAINT_TYPE */
          short isc_151;	/* isc_utility */
          short isc_152;	/* gds__null_flag */
   } isc_144;
   struct {
          char  isc_155 [8];	/* RDB$MATCH_OPTION */
          char  isc_156 [32];	/* RDB$CONST_NAME_UQ */
          char  isc_157 [32];	/* RDB$CONSTRAINT_NAME */
          char  isc_158 [12];	/* RDB$DELETE_RULE */
          char  isc_159 [12];	/* RDB$UPDATE_RULE */
          short isc_160;	/* isc_utility */
   } isc_154;
   struct {
          ISC_QUAD isc_165;	/* RDB$DESCRIPTION */
          char  isc_166 [32];	/* RDB$FIELD_SOURCE */
          char  isc_167 [32];	/* RDB$PARAMETER_NAME */
          short isc_168;	/* isc_utility */
          short isc_169;	/* RDB$PARAMETER_TYPE */
          short isc_170;	/* RDB$PARAMETER_NUMBER */
   } isc_164;
   struct {
          char  isc_163 [32];	/* RDB$PROCEDURE_NAME */
   } isc_162;
   struct {
          char  isc_173 [32];	/* RDB$OWNER_NAME */
          char  isc_174 [32];	/* RDB$SECURITY_CLASS */
          ISC_QUAD isc_175;	/* RDB$PROCEDURE_BLR */
          ISC_QUAD isc_176;	/* RDB$PROCEDURE_SOURCE */
          ISC_QUAD isc_177;	/* RDB$DESCRIPTION */
          char  isc_178 [32];	/* RDB$PROCEDURE_NAME */
          short isc_179;	/* isc_utility */
          short isc_180;	/* gds__null_flag */
          short isc_181;	/* RDB$PROCEDURE_OUTPUTS */
          short isc_182;	/* RDB$PROCEDURE_INPUTS */
   } isc_172;
   struct {
          short isc_187;	/* isc_utility */
          short isc_188;	/* gds__null_flag */
          short isc_189;	/* RDB$FIELD_PRECISION */
   } isc_186;
   struct {
          char  isc_185 [32];	/* RDB$FIELD_NAME */
   } isc_184;
   struct {
          ISC_QUAD isc_194;	/* RDB$MISSING_SOURCE */
          ISC_QUAD isc_195;	/* RDB$DEFAULT_SOURCE */
          short isc_196;	/* isc_utility */
          short isc_197;	/* gds__null_flag */
          short isc_198;	/* RDB$COLLATION_ID */
          short isc_199;	/* gds__null_flag */
          short isc_200;	/* RDB$CHARACTER_SET_ID */
          short isc_201;	/* gds__null_flag */
          short isc_202;	/* gds__null_flag */
          short isc_203;	/* gds__null_flag */
          short isc_204;	/* RDB$CHARACTER_LENGTH */
          short isc_205;	/* gds__null_flag */
          short isc_206;	/* RDB$NULL_FLAG */
   } isc_193;
   struct {
          char  isc_192 [32];	/* RDB$FIELD_NAME */
   } isc_191;
   struct {
          short isc_211;	/* isc_utility */
          short isc_212;	/* RDB$DIMENSIONS */
          short isc_213;	/* RDB$EXTERNAL_SCALE */
          short isc_214;	/* RDB$EXTERNAL_TYPE */
          short isc_215;	/* RDB$EXTERNAL_LENGTH */
   } isc_210;
   struct {
          char  isc_209 [32];	/* RDB$FIELD_NAME */
   } isc_208;
   struct {
          ISC_QUAD isc_218;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_219;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_220;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_221;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_222;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_223;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_224;	/* RDB$MISSING_VALUE */
          ISC_QUAD isc_225;	/* RDB$QUERY_HEADER */
          char  isc_226 [32];	/* RDB$QUERY_NAME */
          char  isc_227 [32];	/* RDB$FIELD_NAME */
          short isc_228;	/* isc_utility */
          short isc_229;	/* RDB$SYSTEM_FLAG */
          short isc_230;	/* RDB$SEGMENT_LENGTH */
          short isc_231;	/* RDB$FIELD_SCALE */
          short isc_232;	/* RDB$FIELD_SUB_TYPE */
          short isc_233;	/* RDB$FIELD_LENGTH */
          short isc_234;	/* RDB$FIELD_TYPE */
          char  isc_235 [126];	/* RDB$EDIT_STRING */
   } isc_217;
   struct {
          ISC_QUAD isc_238;	/* RDB$MISSING_SOURCE */
          ISC_QUAD isc_239;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_240;	/* RDB$DESCRIPTION */
          ISC_QUAD isc_241;	/* RDB$COMPUTED_SOURCE */
          ISC_QUAD isc_242;	/* RDB$COMPUTED_BLR */
          ISC_QUAD isc_243;	/* RDB$VALIDATION_SOURCE */
          ISC_QUAD isc_244;	/* RDB$VALIDATION_BLR */
          ISC_QUAD isc_245;	/* RDB$DEFAULT_VALUE */
          ISC_QUAD isc_246;	/* RDB$MISSING_VALUE */
          ISC_QUAD isc_247;	/* RDB$QUERY_HEADER */
          char  isc_248 [32];	/* RDB$QUERY_NAME */
          char  isc_249 [32];	/* RDB$FIELD_NAME */
          short isc_250;	/* isc_utility */
          short isc_251;	/* gds__null_flag */
          short isc_252;	/* RDB$FIELD_PRECISION */
          short isc_253;	/* gds__null_flag */
          short isc_254;	/* RDB$COLLATION_ID */
          short isc_255;	/* gds__null_flag */
          short isc_256;	/* RDB$CHARACTER_SET_ID */
          short isc_257;	/* gds__null_flag */
          short isc_258;	/* gds__null_flag */
          short isc_259;	/* gds__null_flag */
          short isc_260;	/* RDB$CHARACTER_LENGTH */
          short isc_261;	/* gds__null_flag */
          short isc_262;	/* RDB$NULL_FLAG */
          short isc_263;	/* RDB$DIMENSIONS */
          short isc_264;	/* RDB$EXTERNAL_SCALE */
          short isc_265;	/* RDB$EXTERNAL_TYPE */
          short isc_266;	/* RDB$EXTERNAL_LENGTH */
          short isc_267;	/* RDB$SYSTEM_FLAG */
          short isc_268;	/* RDB$SEGMENT_LENGTH */
          short isc_269;	/* RDB$FIELD_SCALE */
          short isc_270;	/* RDB$FIELD_SUB_TYPE */
          short isc_271;	/* RDB$FIELD_LENGTH */
          short isc_272;	/* RDB$FIELD_TYPE */
          char  isc_273 [126];	/* RDB$EDIT_STRING */
   } isc_237;
   struct {
          char  isc_276 [32];	/* RDB$GENERATOR_NAME */
          short isc_277;	/* isc_utility */
   } isc_275;
   struct {
          ISC_QUAD isc_280;	/* RDB$DESCRIPTION */
          char  isc_281 [32];	/* RDB$GENERATOR_NAME */
          short isc_282;	/* isc_utility */
          short isc_283;	/* gds__null_flag */
   } isc_279;
   struct {
          short isc_289;	/* isc_utility */
          short isc_290;	/* gds__null_flag */
          short isc_291;	/* RDB$CHARACTER_SET_ID */
   } isc_288;
   struct {
          char  isc_286 [32];	/* RDB$FUNCTION_NAME */
          short isc_287;	/* RDB$ARGUMENT_POSITION */
   } isc_285;
   struct {
          char  isc_296 [32];	/* RDB$FUNCTION_NAME */
          short isc_297;	/* isc_utility */
          short isc_298;	/* RDB$FIELD_SUB_TYPE */
          short isc_299;	/* RDB$FIELD_LENGTH */
          short isc_300;	/* RDB$FIELD_SCALE */
          short isc_301;	/* RDB$FIELD_TYPE */
          short isc_302;	/* RDB$MECHANISM */
          short isc_303;	/* RDB$ARGUMENT_POSITION */
   } isc_295;
   struct {
          char  isc_294 [32];	/* RDB$FUNCTION_NAME */
   } isc_293;
   struct {
          char  isc_308 [32];	/* RDB$FUNCTION_NAME */
          short isc_309;	/* isc_utility */
          short isc_310;	/* gds__null_flag */
          short isc_311;	/* RDB$FIELD_PRECISION */
          short isc_312;	/* gds__null_flag */
          short isc_313;	/* RDB$CHARACTER_SET_ID */
          short isc_314;	/* RDB$FIELD_SUB_TYPE */
          short isc_315;	/* RDB$FIELD_LENGTH */
          short isc_316;	/* RDB$FIELD_SCALE */
          short isc_317;	/* RDB$FIELD_TYPE */
          short isc_318;	/* RDB$MECHANISM */
          short isc_319;	/* RDB$ARGUMENT_POSITION */
   } isc_307;
   struct {
          char  isc_306 [32];	/* RDB$FUNCTION_NAME */
   } isc_305;
   struct {
          char  isc_322 [32];	/* RDB$QUERY_NAME */
          char  isc_323 [32];	/* RDB$ENTRYPOINT */
          ISC_QUAD isc_324;	/* RDB$DESCRIPTION */
          char  isc_325 [32];	/* RDB$FUNCTION_NAME */
          short isc_326;	/* isc_utility */
          short isc_327;	/* RDB$FUNCTION_TYPE */
          short isc_328;	/* RDB$RETURN_ARGUMENT */
          char  isc_329 [254];	/* RDB$MODULE_NAME */
   } isc_321;
   struct {
          char  isc_332 [32];	/* RDB$ENTRYPOINT */
          ISC_QUAD isc_333;	/* RDB$DESCRIPTION */
          char  isc_334 [32];	/* RDB$FUNCTION_NAME */
          short isc_335;	/* isc_utility */
          short isc_336;	/* RDB$OUTPUT_SUB_TYPE */
          short isc_337;	/* RDB$INPUT_SUB_TYPE */
          char  isc_338 [254];	/* RDB$MODULE_NAME */
   } isc_331;
   struct {
          char  isc_341 [32];	/* RDB$FIELD_NAME */
          ISC_LONG isc_342;	/* RDB$UPPER_BOUND */
          ISC_LONG isc_343;	/* RDB$LOWER_BOUND */
          short isc_344;	/* isc_utility */
          short isc_345;	/* RDB$DIMENSION */
   } isc_340;
   struct {
          ISC_QUAD isc_348;	/* RDB$DESCRIPTION */
          char  isc_349 [32];	/* RDB$EXCEPTION_NAME */
          short isc_350;	/* isc_utility */
          char  isc_351 [1022];	/* RDB$MESSAGE */
   } isc_347;
   struct {
          char  isc_354 [32];	/* RDB$CHARACTER_SET_NAME */
          short isc_355;	/* isc_utility */
          short isc_356;	/* gds__null_flag */
   } isc_353;
   struct {
          ISC_QUAD isc_359;	/* RDB$DESCRIPTION */
          short isc_360;	/* isc_utility */
   } isc_358;
   struct {
          char  isc_363 [32];	/* RDB$SECURITY_CLASS */
          short isc_364;	/* isc_utility */
          short isc_365;	/* gds__null_flag */
   } isc_362;
   struct {
          char  isc_368 [32];	/* RDB$CHARACTER_SET_NAME */
          ISC_QUAD isc_369;	/* RDB$DESCRIPTION */
          char  isc_370 [32];	/* RDB$SECURITY_CLASS */
          short isc_371;	/* isc_utility */
          short isc_372;	/* gds__null_flag */
          short isc_373;	/* gds__null_flag */
   } isc_367;
   struct {
          char  isc_376 [32];	/* RDB$FUNCTION_NAME */
          ISC_QUAD isc_377;	/* RDB$DESCRIPTION */
          char  isc_378 [32];	/* RDB$COLLATION_NAME */
          short isc_379;	/* isc_utility */
          short isc_380;	/* gds__null_flag */
          short isc_381;	/* gds__null_flag */
          short isc_382;	/* RDB$SYSTEM_FLAG */
          short isc_383;	/* RDB$COLLATION_ATTRIBUTES */
          short isc_384;	/* RDB$CHARACTER_SET_ID */
          short isc_385;	/* RDB$COLLATION_ID */
   } isc_375;
   struct {
          ISC_QUAD isc_388;	/* RDB$SPECIFIC_ATTRIBUTES */
          char  isc_389 [32];	/* RDB$BASE_COLLATION_NAME */
          char  isc_390 [32];	/* RDB$FUNCTION_NAME */
          ISC_QUAD isc_391;	/* RDB$DESCRIPTION */
          char  isc_392 [32];	/* RDB$COLLATION_NAME */
          short isc_393;	/* isc_utility */
          short isc_394;	/* gds__null_flag */
          short isc_395;	/* gds__null_flag */
          short isc_396;	/* gds__null_flag */
          short isc_397;	/* gds__null_flag */
          short isc_398;	/* RDB$SYSTEM_FLAG */
          short isc_399;	/* RDB$COLLATION_ATTRIBUTES */
          short isc_400;	/* RDB$CHARACTER_SET_ID */
          short isc_401;	/* RDB$COLLATION_ID */
   } isc_387;
   struct {
          char  isc_404 [32];	/* RDB$TRIGGER_NAME */
          char  isc_405 [32];	/* RDB$CONSTRAINT_NAME */
          short isc_406;	/* isc_utility */
          short isc_407;	/* gds__null_flag */
   } isc_403;
   struct {
          char  isc_410 [32];	/* RDB$FUNCTION_NAME */
          ISC_QUAD isc_411;	/* RDB$DESCRIPTION */
          char  isc_412 [32];	/* RDB$DEFAULT_COLLATE_NAME */
          char  isc_413 [32];	/* RDB$FORM_OF_USE */
          char  isc_414 [32];	/* RDB$CHARACTER_SET_NAME */
          ISC_LONG isc_415;	/* RDB$NUMBER_OF_CHARACTERS */
          short isc_416;	/* isc_utility */
          short isc_417;	/* RDB$BYTES_PER_CHARACTER */
          short isc_418;	/* gds__null_flag */
          short isc_419;	/* gds__null_flag */
          short isc_420;	/* RDB$SYSTEM_FLAG */
          short isc_421;	/* RDB$CHARACTER_SET_ID */
          short isc_422;	/* gds__null_flag */
          short isc_423;	/* gds__null_flag */
   } isc_409;
   struct {
          short isc_429;	/* isc_utility */
   } isc_428;
   struct {
          char  isc_426 [32];	/* RDB$FIELD_NAME */
          char  isc_427 [32];	/* RDB$RELATION_NAME */
   } isc_425;
   struct {
          char  isc_434 [32];	/* RDB$RELATION_NAME */
          short isc_435;	/* isc_utility */
          short isc_436;	/* RDB$VIEW_CONTEXT */
   } isc_433;
   struct {
          char  isc_432 [32];	/* RDB$VIEW_NAME */
   } isc_431;
   struct {
          char  isc_441 [32];	/* RDB$CONTEXT_NAME */
          char  isc_442 [32];	/* RDB$RELATION_NAME */
          short isc_443;	/* isc_utility */
          short isc_444;	/* RDB$VIEW_CONTEXT */
   } isc_440;
   struct {
          char  isc_439 [32];	/* RDB$VIEW_NAME */
   } isc_438;
   struct {
          char  isc_449 [32];	/* RDB$FOREIGN_KEY */
          ISC_QUAD isc_450;	/* RDB$EXPRESSION_BLR */
          ISC_QUAD isc_451;	/* RDB$EXPRESSION_SOURCE */
          short isc_452;	/* isc_utility */
          short isc_453;	/* gds__null_flag */
          short isc_454;	/* gds__null_flag */
          short isc_455;	/* gds__null_flag */
   } isc_448;
   struct {
          char  isc_447 [32];	/* RDB$INDEX_NAME */
   } isc_446;
   struct {
          short isc_460;	/* isc_utility */
          short isc_461;	/* RDB$INDEX_TYPE */
   } isc_459;
   struct {
          char  isc_458 [32];	/* RDB$INDEX_NAME */
   } isc_457;
   struct {
          char  isc_466 [32];	/* RDB$FIELD_NAME */
          short isc_467;	/* isc_utility */
   } isc_465;
   struct {
          char  isc_464 [32];	/* RDB$INDEX_NAME */
   } isc_463;
   struct {
          short isc_472;	/* isc_utility */
          short isc_473;	/* RDB$INDEX_INACTIVE */
   } isc_471;
   struct {
          char  isc_470 [32];	/* RDB$INDEX_NAME */
   } isc_469;
   struct {
          short isc_479;	/* isc_utility */
   } isc_478;
   struct {
          char  isc_476 [32];	/* RDB$RELATION_NAME */
          char  isc_477 [32];	/* RDB$FIELD_NAME */
   } isc_475;
   struct {
          char  isc_484 [32];	/* RDB$FIELD_NAME */
          short isc_485;	/* isc_utility */
   } isc_483;
   struct {
          char  isc_482 [32];	/* RDB$INDEX_NAME */
   } isc_481;
   struct {
          ISC_QUAD isc_490;	/* RDB$DESCRIPTION */
          char  isc_491 [32];	/* RDB$INDEX_NAME */
          short isc_492;	/* isc_utility */
          short isc_493;	/* RDB$UNIQUE_FLAG */
          short isc_494;	/* RDB$SEGMENT_COUNT */
   } isc_489;
   struct {
          char  isc_488 [32];	/* RDB$RELATION_NAME */
   } isc_487;
   struct {
          char  isc_499 [32];	/* RDB$FIELD_NAME */
          short isc_500;	/* isc_utility */
   } isc_498;
   struct {
          char  isc_497 [32];	/* RDB$INDEX_NAME */
   } isc_496;
   struct {
          short isc_506;	/* isc_utility */
   } isc_505;
   struct {
          char  isc_503 [32];	/* RDB$RELATION_NAME */
          char  isc_504 [32];	/* RDB$INDEX_NAME */
   } isc_502;
   struct {
          char  isc_511 [32];	/* RDB$FOREIGN_KEY */
          ISC_QUAD isc_512;	/* RDB$EXPRESSION_BLR */
          ISC_QUAD isc_513;	/* RDB$EXPRESSION_SOURCE */
          ISC_QUAD isc_514;	/* RDB$DESCRIPTION */
          char  isc_515 [32];	/* RDB$INDEX_NAME */
          short isc_516;	/* isc_utility */
          short isc_517;	/* gds__null_flag */
          short isc_518;	/* gds__null_flag */
          short isc_519;	/* gds__null_flag */
          short isc_520;	/* RDB$INDEX_TYPE */
          short isc_521;	/* RDB$UNIQUE_FLAG */
          short isc_522;	/* RDB$INDEX_INACTIVE */
          short isc_523;	/* RDB$SEGMENT_COUNT */
   } isc_510;
   struct {
          char  isc_509 [32];	/* RDB$RELATION_NAME */
   } isc_508;
   struct {
          ISC_LONG isc_528;	/* RDB$UPPER_BOUND */
          ISC_LONG isc_529;	/* RDB$LOWER_BOUND */
          short isc_530;	/* isc_utility */
          short isc_531;	/* RDB$DIMENSION */
   } isc_527;
   struct {
          char  isc_526 [32];	/* RDB$FIELD_NAME */
   } isc_525;
   struct {
          ISC_QUAD isc_537;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_538;	/* RDB$DEFAULT_VALUE */
          short isc_539;	/* isc_utility */
          short isc_540;	/* gds__null_flag */
          short isc_541;	/* RDB$COLLATION_ID */
          short isc_542;	/* gds__null_flag */
          short isc_543;	/* RDB$CHARACTER_SET_ID */
          short isc_544;	/* gds__null_flag */
          short isc_545;	/* gds__null_flag */
          short isc_546;	/* gds__null_flag */
          short isc_547;	/* RDB$NULL_FLAG */
   } isc_536;
   struct {
          char  isc_534 [32];	/* RDB$RELATION_NAME */
          char  isc_535 [32];	/* RDB$FIELD_NAME */
   } isc_533;
   struct {
          short isc_552;	/* isc_utility */
          short isc_553;	/* RDB$DIMENSIONS */
   } isc_551;
   struct {
          char  isc_550 [32];	/* RDB$FIELD_SOURCE */
   } isc_549;
   struct {
          char  isc_559 [32];	/* RDB$SECURITY_CLASS */
          short isc_560;	/* isc_utility */
   } isc_558;
   struct {
          char  isc_556 [32];	/* RDB$FIELD_NAME */
          char  isc_557 [32];	/* RDB$RELATION_NAME */
   } isc_555;
   struct {
          short isc_566;	/* isc_utility */
          short isc_567;	/* RDB$SYSTEM_FLAG */
   } isc_565;
   struct {
          char  isc_563 [32];	/* RDB$FIELD_NAME */
          char  isc_564 [32];	/* RDB$RELATION_NAME */
   } isc_562;
   struct {
          char  isc_573 [32];	/* RDB$COMPLEX_NAME */
          short isc_574;	/* isc_utility */
   } isc_572;
   struct {
          char  isc_570 [32];	/* RDB$RELATION_NAME */
          char  isc_571 [32];	/* RDB$FIELD_NAME */
   } isc_569;
   struct {
          ISC_QUAD isc_579;	/* RDB$COMPUTED_BLR */
          char  isc_580 [32];	/* RDB$RELATION_NAME */
          char  isc_581 [32];	/* RDB$QUERY_NAME */
          char  isc_582 [32];	/* RDB$BASE_FIELD */
          char  isc_583 [32];	/* RDB$FIELD_SOURCE */
          char  isc_584 [32];	/* RDB$FIELD_NAME */
          ISC_QUAD isc_585;	/* RDB$QUERY_HEADER */
          ISC_QUAD isc_586;	/* RDB$DESCRIPTION */
          short isc_587;	/* isc_utility */
          char  isc_588 [126];	/* RDB$EDIT_STRING */
          short isc_589;	/* gds__null_flag */
          short isc_590;	/* RDB$UPDATE_FLAG */
          short isc_591;	/* RDB$VIEW_CONTEXT */
          short isc_592;	/* gds__null_flag */
          short isc_593;	/* RDB$FIELD_POSITION */
          short isc_594;	/* gds__null_flag */
          short isc_595;	/* gds__null_flag */
          short isc_596;	/* RDB$FIELD_ID */
          short isc_597;	/* RDB$FIELD_SCALE */
          short isc_598;	/* RDB$FIELD_LENGTH */
          short isc_599;	/* RDB$FIELD_SUB_TYPE */
          short isc_600;	/* RDB$FIELD_TYPE */
   } isc_578;
   struct {
          char  isc_577 [32];	/* RDB$RELATION_NAME */
   } isc_576;
   struct {
          ISC_QUAD isc_605;	/* RDB$DEFAULT_SOURCE */
          ISC_QUAD isc_606;	/* RDB$DEFAULT_VALUE */
          char  isc_607 [32];	/* RDB$SECURITY_CLASS */
          ISC_QUAD isc_608;	/* RDB$COMPUTED_BLR */
          char  isc_609 [32];	/* RDB$COMPLEX_NAME */
          char  isc_610 [32];	/* RDB$QUERY_NAME */
          char  isc_611 [32];	/* RDB$BASE_FIELD */
          char  isc_612 [32];	/* RDB$FIELD_SOURCE */
          char  isc_613 [32];	/* RDB$FIELD_NAME */
          ISC_QUAD isc_614;	/* RDB$QUERY_HEADER */
          ISC_QUAD isc_615;	/* RDB$DESCRIPTION */
          short isc_616;	/* isc_utility */
          short isc_617;	/* gds__null_flag */
          short isc_618;	/* RDB$COLLATION_ID */
          short isc_619;	/* gds__null_flag */
          short isc_620;	/* RDB$CHARACTER_SET_ID */
          short isc_621;	/* gds__null_flag */
          short isc_622;	/* gds__null_flag */
          short isc_623;	/* gds__null_flag */
          short isc_624;	/* RDB$NULL_FLAG */
          short isc_625;	/* RDB$DIMENSIONS */
          short isc_626;	/* RDB$SYSTEM_FLAG */
          char  isc_627 [126];	/* RDB$EDIT_STRING */
          short isc_628;	/* gds__null_flag */
          short isc_629;	/* RDB$UPDATE_FLAG */
          short isc_630;	/* RDB$VIEW_CONTEXT */
          short isc_631;	/* gds__null_flag */
          short isc_632;	/* RDB$FIELD_POSITION */
          short isc_633;	/* gds__null_flag */
          short isc_634;	/* gds__null_flag */
          short isc_635;	/* RDB$FIELD_ID */
          short isc_636;	/* RDB$FIELD_SCALE */
          short isc_637;	/* RDB$FIELD_LENGTH */
          short isc_638;	/* RDB$FIELD_SUB_TYPE */
          short isc_639;	/* RDB$FIELD_TYPE */
   } isc_604;
   struct {
          char  isc_603 [32];	/* RDB$RELATION_NAME */
   } isc_602;

void compress(const UCHAR* data, ULONG length)
{
/**************************************
 *
 *	c o m p r e s s
 *
 **************************************
 *
 * Functional description
 *	Write out data in compressed form.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const UCHAR* p = data;
	const UCHAR* end = p + length;
	const UCHAR* q = NULL;

	while (p < end)
	{
		for (q = p + 2; q < end && (q[-2] != q[-1] || q[-1] != q[0]); q++)
			;
		USHORT run = (q < end) ? q - p - 2 : end - p;
		if (run)
		{
			for (; run > 127; run -= 127)
			{
				USHORT l = 127;
				put(tdgbl, (UCHAR) (l));
				p = put_block(tdgbl, p, l);
			}
			if (run)
			{
				put(tdgbl, (UCHAR) (run));
				p = put_block(tdgbl, p, run);
			}
		}
		for (q = p; q < end && *q == *p; q++)
			;
		if ((run = q - p) != 0)
		{
			for (; run > 127; run -= 127)
			{
				put(tdgbl, (UCHAR) (-127));
				put(tdgbl, (UCHAR) (*p));
			}
			if (run)
			{
				put(tdgbl, (UCHAR) (-run));
				put(tdgbl, (UCHAR) (*p));
			}
			p = q;
		}
	}
}


int copy( const TEXT* from, TEXT* to, ULONG size_len)
{
/**************************************
 *
 *	c o p y
 *
 **************************************
 *
 * Functional description
 *	Copy a blank or null terminated string into a null terminated
 *	string. It assumes there's enough room in the target.
 *
 **************************************/

	const ULONG l = (ULONG) MISC_symbol_length(from, size_len);

	MOVE_FAST(from, to, l);
	*(to + l) = '\0';

	return (int) l;
}


void general_on_error(void)
{
/**************************************
 *
 *	g e n e r a l _ o n _ e r r o r
 *
 **************************************
 *
 * Functional description
 *	Handle any general ON_ERROR clause during backup.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	BURP_print_status(isc_status);
	BURP_abort();
}


burp_fld* get_fields( burp_rel* relation)
{
/**************************************
 *
 *	g e t _ f i e l d s
 *
 **************************************
 *
 * Functional description
 *	Get fields for a relation.  Test
 *	capabilities and get system specific
 *
 **************************************/
	burp_fld* field;
	ISC_QUAD* blob_id;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	USHORT count = 1;
	burp_fld* fields = NULL;

/* if we have all capabilities, use the first request to get the 
   most performance out of the latest engine; if we don't 
   have one of the capabilities we must use the second set of 
   requests--this requires more code but it is well worth it 
   for the performance benefits, especially remotely--deej */

	if ((tdgbl->BCK_capabilities & BCK_attributes_v3) &&
		(tdgbl->BCK_capabilities & BCK_ods8) &&
		(tdgbl->BCK_capabilities & BCK_rfr_sys_flag) &&
		(tdgbl->BCK_capabilities & BCK_security))
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle1)
			X IN RDB$RELATION_FIELDS CROSS
			Y IN RDB$FIELDS WITH
			X.RDB$FIELD_SOURCE = Y.RDB$FIELD_NAME AND
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
                if (!tdgbl->handles_get_fields_req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) sizeof (isc_601), (char *) isc_601);
		isc_vtov ((char*)relation->rel_name, (char*)isc_602.isc_603, 32);
		if (tdgbl->handles_get_fields_req_handle1)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_602, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) 1, (short) 404, &isc_604, (short) 0);
		   if (!isc_604.isc_616 || isc_status [1]) break;
	
			field = (burp_fld*) BURP_alloc_zero(sizeof(burp_fld));
			field->fld_number = count++;
			field->fld_type = /*Y.RDB$FIELD_TYPE*/
					  isc_604.isc_639;
			field->fld_sub_type = /*Y.RDB$FIELD_SUB_TYPE*/
					      isc_604.isc_638;
			field->fld_length = /*Y.RDB$FIELD_LENGTH*/
					    isc_604.isc_637;
			field->fld_scale = /*Y.RDB$FIELD_SCALE*/
					   isc_604.isc_636;
			field->fld_id = /*X.RDB$FIELD_ID*/
					isc_604.isc_635;
	
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_604.isc_634)
			{
				blob_id = &/*X.RDB$DESCRIPTION*/
					   isc_604.isc_615;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_description = /*X.RDB$DESCRIPTION*/
								 isc_604.isc_615;
			}
	
			if (!/*X.RDB$QUERY_HEADER.NULL*/
			     isc_604.isc_633)
			{
				blob_id = &/*X.RDB$QUERY_HEADER*/
					   isc_604.isc_614;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_query_header = /*X.RDB$QUERY_HEADER*/
								  isc_604.isc_614;
			}

			if (/*X.RDB$FIELD_POSITION.NULL*/
			    isc_604.isc_631)
				field->fld_flags |= FLD_position_missing;
			else
				field->fld_position = /*X.RDB$FIELD_POSITION*/
						      isc_604.isc_632;
			field->fld_view_context = /*X.RDB$VIEW_CONTEXT*/
						  isc_604.isc_630;
			if (/*X.RDB$UPDATE_FLAG.NULL*/
			    isc_604.isc_628)
				field->fld_flags |= FLD_update_missing;
			else
				field->fld_update_flag = /*X.RDB$UPDATE_FLAG*/
							 isc_604.isc_629;

			COPY (/*X.RDB$FIELD_NAME*/
			      isc_604.isc_613, field->fld_name);
			COPY (/*X.RDB$FIELD_SOURCE*/
			      isc_604.isc_612, field->fld_source);
			COPY (/*X.RDB$BASE_FIELD*/
			      isc_604.isc_611, field->fld_base);
			COPY (/*X.RDB$QUERY_NAME*/
			      isc_604.isc_610, field->fld_query_name);
			COPY (/*X.RDB$EDIT_STRING*/
			      isc_604.isc_627, field->fld_edit_string);
			COPY (/*X.RDB$COMPLEX_NAME*/
			      isc_604.isc_609, field->fld_complex_name);

			blob_id = &/*Y.RDB$COMPUTED_BLR*/
				   isc_604.isc_608;

			if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
				field->fld_flags |= FLD_computed;
			}

			field->fld_system_flag = /*X.RDB$SYSTEM_FLAG*/
						 isc_604.isc_626;

			COPY (/*X.RDB$SECURITY_CLASS*/
			      isc_604.isc_607, field->fld_security_class);

			// use the fld_flags to mark the field as an array and
			// to differentiate it from other blobs

			if (/*Y.RDB$DIMENSIONS*/
			    isc_604.isc_625) {
				field->fld_flags |= FLD_array;
				field->fld_dimensions = /*Y.RDB$DIMENSIONS*/
							isc_604.isc_625;
				if (field->fld_dimensions < 0) {
					BURP_error_redirect (NULL, 52, field->fld_name, NULL);
				}
				// msg 52 array dimension for field %s is invalid
				get_ranges (field);
			}

			if (!/*X.RDB$NULL_FLAG.NULL*/
			     isc_604.isc_623) {
				field->fld_null_flag = /*X.RDB$NULL_FLAG*/
						       isc_604.isc_624;
				field->fld_flags |= FLD_null_flag;
			}

			if (!/*X.RDB$DEFAULT_VALUE.NULL*/
			     isc_604.isc_622) {
				blob_id = &/*X.RDB$DEFAULT_VALUE*/
					   isc_604.isc_606;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_value = /*X.RDB$DEFAULT_VALUE*/
								   isc_604.isc_606;
				}
			}

			if (!/*X.RDB$DEFAULT_SOURCE.NULL*/
			     isc_604.isc_621) {
				blob_id = &/*X.RDB$DEFAULT_SOURCE*/
					   isc_604.isc_605;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high) {
					field->fld_default_source = /*X.RDB$DEFAULT_SOURCE*/
								    isc_604.isc_605;
				}
			}

			if (!(/*Y.RDB$CHARACTER_SET_ID.NULL*/
			      isc_604.isc_619)) {
				field->fld_character_set_id = /*Y.RDB$CHARACTER_SET_ID*/
							      isc_604.isc_620;
				field->fld_flags |= FLD_charset_flag;
			}

			if (!/*X.RDB$COLLATION_ID.NULL*/
			     isc_604.isc_617) {
				field->fld_collation_id = /*X.RDB$COLLATION_ID*/
							  isc_604.isc_618;
				field->fld_flags |= FLD_collate_flag;
			}
	
			field->fld_next = fields;
			fields = field;
	
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else {
		/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle1)
			X IN RDB$RELATION_FIELDS CROSS Y IN RDB$FIELDS
			WITH X.RDB$FIELD_SOURCE = Y.RDB$FIELD_NAME AND
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
                if (!tdgbl->handles_get_fields_req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) sizeof (isc_575), (char *) isc_575);
		isc_vtov ((char*)relation->rel_name, (char*)isc_576.isc_577, 32);
		if (tdgbl->handles_get_fields_req_handle1)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_576, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle1, (short) 1, (short) 336, &isc_578, (short) 0);
		   if (!isc_578.isc_587 || isc_status [1]) break;

			field = (burp_fld*) BURP_alloc_zero (sizeof(burp_fld));
			field->fld_number = count++;
			field->fld_type = /*Y.RDB$FIELD_TYPE*/
					  isc_578.isc_600;
			field->fld_sub_type = /*Y.RDB$FIELD_SUB_TYPE*/
					      isc_578.isc_599;
			field->fld_length = /*Y.RDB$FIELD_LENGTH*/
					    isc_578.isc_598;
			field->fld_scale = /*Y.RDB$FIELD_SCALE*/
					   isc_578.isc_597;
			field->fld_id = /*X.RDB$FIELD_ID*/
					isc_578.isc_596;
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_578.isc_595) {
				blob_id = &/*X.RDB$DESCRIPTION*/
					   isc_578.isc_586;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_description = /*X.RDB$DESCRIPTION*/
								 isc_578.isc_586;
			}
			if (!/*X.RDB$QUERY_HEADER.NULL*/
			     isc_578.isc_594) {
				blob_id = &/*X.RDB$QUERY_HEADER*/
					   isc_578.isc_585;
				if (blob_id->gds_quad_low || blob_id->gds_quad_high)
					field->fld_query_header = /*X.RDB$QUERY_HEADER*/
								  isc_578.isc_585;
			}
			if (/*X.RDB$FIELD_POSITION.NULL*/
			    isc_578.isc_592)
				field->fld_flags |= FLD_position_missing;
			else
				field->fld_position = /*X.RDB$FIELD_POSITION*/
						      isc_578.isc_593;
			field->fld_view_context = /*X.RDB$VIEW_CONTEXT*/
						  isc_578.isc_591;
			if (/*X.RDB$UPDATE_FLAG.NULL*/
			    isc_578.isc_589)
				field->fld_flags |= FLD_update_missing;
			else
				field->fld_update_flag = /*X.RDB$UPDATE_FLAG*/
							 isc_578.isc_590;
			COPY (/*X.RDB$FIELD_NAME*/
			      isc_578.isc_584, field->fld_name);
			COPY (/*X.RDB$FIELD_SOURCE*/
			      isc_578.isc_583, field->fld_source);
			COPY (/*X.RDB$BASE_FIELD*/
			      isc_578.isc_582, field->fld_base);
			COPY (/*X.RDB$QUERY_NAME*/
			      isc_578.isc_581, field->fld_query_name);
			COPY (/*X.RDB$EDIT_STRING*/
			      isc_578.isc_588, field->fld_edit_string);
			if (tdgbl->BCK_capabilities & BCK_attributes_v3)
			{
				/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle2)
					RFR IN RDB$RELATION_FIELDS WITH RFR.RDB$FIELD_NAME = X.RDB$FIELD_NAME AND
					RFR.RDB$RELATION_NAME = X.RDB$RELATION_NAME*/
				{
                                if (!tdgbl->handles_get_fields_req_handle2)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle2, (short) sizeof (isc_568), (char *) isc_568);
				isc_vtov ((char*)isc_578.isc_580, (char*)isc_569.isc_570, 32);
				isc_vtov ((char*)isc_578.isc_584, (char*)isc_569.isc_571, 32);
				if (tdgbl->handles_get_fields_req_handle2)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_569, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle2, (short) 1, (short) 34, &isc_572, (short) 0);
				   if (!isc_572.isc_574 || isc_status [1]) break;
					COPY (/*RFR.RDB$COMPLEX_NAME*/
					      isc_572.isc_573, field->fld_complex_name);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			blob_id = &/*Y.RDB$COMPUTED_BLR*/
				   isc_578.isc_579;
			if (blob_id->gds_quad_low || blob_id->gds_quad_high)
				field->fld_flags |= FLD_computed;
			if (tdgbl->BCK_capabilities & BCK_rfr_sys_flag)
			{
				/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle3)
					RFR IN RDB$RELATION_FIELDS WITH
					RFR.RDB$RELATION_NAME = relation->rel_name
					AND RFR.RDB$FIELD_NAME = X.RDB$FIELD_NAME*/
				{
                                if (!tdgbl->handles_get_fields_req_handle3)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle3, (short) sizeof (isc_561), (char *) isc_561);
				isc_vtov ((char*)isc_578.isc_584, (char*)isc_562.isc_563, 32);
				isc_vtov ((char*)relation->rel_name, (char*)isc_562.isc_564, 32);
				if (tdgbl->handles_get_fields_req_handle3)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle3, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_562, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle3, (short) 1, (short) 4, &isc_565, (short) 0);
				   if (!isc_565.isc_566 || isc_status [1]) break;
					field->fld_system_flag = /*RFR.RDB$SYSTEM_FLAG*/
								 isc_565.isc_567;
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			if (tdgbl->BCK_capabilities & BCK_security)
			{
				/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle4)
					RFR IN RDB$RELATION_FIELDS WITH
					RFR.RDB$RELATION_NAME = relation->rel_name
					AND RFR.RDB$FIELD_NAME = X.RDB$FIELD_NAME*/
				{
                                if (!tdgbl->handles_get_fields_req_handle4)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle4, (short) sizeof (isc_554), (char *) isc_554);
				isc_vtov ((char*)isc_578.isc_584, (char*)isc_555.isc_556, 32);
				isc_vtov ((char*)relation->rel_name, (char*)isc_555.isc_557, 32);
				if (tdgbl->handles_get_fields_req_handle4)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle4, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_555, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle4, (short) 1, (short) 34, &isc_558, (short) 0);
				   if (!isc_558.isc_560 || isc_status [1]) break;
					COPY (/*RFR.RDB$SECURITY_CLASS*/
					      isc_558.isc_559, field->fld_security_class);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			if (tdgbl->BCK_capabilities & BCK_attributes_v3)
			{
				/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle5)
					RF IN RDB$FIELDS WITH RF.RDB$FIELD_NAME = X.RDB$FIELD_SOURCE*/
				{
                                if (!tdgbl->handles_get_fields_req_handle5)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle5, (short) sizeof (isc_548), (char *) isc_548);
				isc_vtov ((char*)isc_578.isc_583, (char*)isc_549.isc_550, 32);
				if (tdgbl->handles_get_fields_req_handle5)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle5, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_549, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle5, (short) 1, (short) 4, &isc_551, (short) 0);
				   if (!isc_551.isc_552 || isc_status [1]) break;
					// use the fld_flags to mark the field as an array and
					// to differentiate it from other blobs
					if (/*RF.RDB$DIMENSIONS*/
					    isc_551.isc_553)
					{
						field->fld_flags |= FLD_array;
						field->fld_dimensions = /*RF.RDB$DIMENSIONS*/
									isc_551.isc_553;
						if (field->fld_dimensions < 0) {
							BURP_error_redirect (NULL, 52, field->fld_name, NULL);
						}
							// msg 52 array dimension for field %s is invalid
						get_ranges (field);
					}
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			if (tdgbl->BCK_capabilities & BCK_ods8)
			{
				/*FOR (REQUEST_HANDLE tdgbl->handles_get_fields_req_handle6)
					X2 IN RDB$RELATION_FIELDS CROSS F2 IN RDB$FIELDS
					WITH X2.RDB$FIELD_NAME = X.RDB$FIELD_NAME
					AND X2.RDB$RELATION_NAME EQ relation->rel_name
					AND X2.RDB$FIELD_SOURCE EQ F2.RDB$FIELD_NAME*/
				{
                                if (!tdgbl->handles_get_fields_req_handle6)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle6, (short) sizeof (isc_532), (char *) isc_532);
				isc_vtov ((char*)relation->rel_name, (char*)isc_533.isc_534, 32);
				isc_vtov ((char*)isc_578.isc_584, (char*)isc_533.isc_535, 32);
				if (tdgbl->handles_get_fields_req_handle6)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle6, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_533, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_fields_req_handle6, (short) 1, (short) 34, &isc_536, (short) 0);
				   if (!isc_536.isc_539 || isc_status [1]) break;

					if (!/*X2.RDB$NULL_FLAG.NULL*/
					     isc_536.isc_546)
					{
						field->fld_null_flag = /*X2.RDB$NULL_FLAG*/
								       isc_536.isc_547;
						field->fld_flags |= FLD_null_flag;
					}
					if (!/*X2.RDB$DEFAULT_VALUE.NULL*/
					     isc_536.isc_545)
					{
						blob_id = &/*X2.RDB$DEFAULT_VALUE*/
							   isc_536.isc_538;
						if (blob_id->gds_quad_low || blob_id->gds_quad_high)
							field->fld_default_value = /*X2.RDB$DEFAULT_VALUE*/
										   isc_536.isc_538;
					}
					if (!/*X2.RDB$DEFAULT_SOURCE.NULL*/
					     isc_536.isc_544)
					{
						blob_id = &/*X2.RDB$DEFAULT_SOURCE*/
							   isc_536.isc_537;
						if (blob_id->gds_quad_low || blob_id->gds_quad_high)
							field->fld_default_source = /*X2.RDB$DEFAULT_SOURCE*/
										    isc_536.isc_537;
					}
					if (!(/*F2.RDB$CHARACTER_SET_ID.NULL*/
					      isc_536.isc_542))
					{
						field->fld_character_set_id = /*F2.RDB$CHARACTER_SET_ID*/
									      isc_536.isc_543;
						field->fld_flags |= FLD_charset_flag;
					}
					if (!/*X2.RDB$COLLATION_ID.NULL*/
					     isc_536.isc_540)
					{
						field->fld_collation_id = /*X2.RDB$COLLATION_ID*/
									  isc_536.isc_541;
						field->fld_flags |= FLD_collate_flag;
					}
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
	
			field->fld_next = fields;
			fields = field;
	
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	return fields;
}


SINT64 get_gen_id( const TEXT* name, SSHORT name_len)
{
/**************************************
 *
 *	g e t _ g e n _ i d
 *
 **************************************
 *
 * Functional description
 *	Read id for a generator;
 *
 **************************************/
	UCHAR blr_buffer[100];	// enough to fit blr 

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	FB_API_HANDLE gen_id_reqh = 0;
	UCHAR* blr = blr_buffer;

/* If this is ODS 10 (IB version 6.0) or greater, build BLR to retrieve
   the 64-bit value of the generator.  If not, build BLR to retrieve the
   32-bit value, which we will cast to the expected INT64 format.
*/
	if (tdgbl->BCK_capabilities & BCK_ods10)
	{
		// build the blr with the right relation name and 64-bit results. 
		add_byte(blr, blr_version5);
		add_byte(blr, blr_begin);
		add_byte(blr, blr_message);
		add_byte(blr, 0);
		add_word(blr, 1);
		add_byte(blr, blr_int64);
		add_byte(blr, 0);
		add_byte(blr, blr_send);
		add_byte(blr, 0);
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_gen_id);
		add_byte(blr, name_len);
		while (name_len--)
		{
			const UCHAR c = *name++;
			add_byte(blr, c);
		}
		add_byte(blr, blr_literal);
		add_byte(blr, blr_long);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_parameter);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_end);
		add_byte(blr, blr_eoc);
	}
	else
	{
		// build the blr with the right relation name and 32-bit results 
		add_byte(blr, blr_version4);
		add_byte(blr, blr_begin);
		add_byte(blr, blr_message);
		add_byte(blr, 0);
		add_word(blr, 1);
		add_byte(blr, blr_long);
		add_byte(blr, 0);
		add_byte(blr, blr_send);
		add_byte(blr, 0);
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_gen_id);
		add_byte(blr, name_len);
		while (name_len--)
		{
			const UCHAR c = *name++;
			add_byte(blr, c);
		}
		add_byte(blr, blr_literal);
		add_byte(blr, blr_long);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_parameter);
		add_byte(blr, 0);
		add_word(blr, 0);
		add_byte(blr, blr_end);
		add_byte(blr, blr_eoc);
	}

#ifdef DEBUG
	if (debug_on)
		isc_print_blr((const char*)blr_buffer, NULL, NULL, 0);
#endif

	ISC_STATUS_ARRAY status_vector;
	const SSHORT blr_length = blr - blr_buffer;
	if (isc_compile_request(status_vector, &DB, &gen_id_reqh,
							blr_length, (const char*) blr_buffer))
	{
		// if there's no gen_id, never mind ... 
		return 0;
	}

	if (isc_start_request(status_vector, &gen_id_reqh,
						  &gds_trans, // use the same one generated by gpre
						  0))
	{
		BURP_error_redirect(status_vector, 25, NULL, NULL);
		// msg 25 Failed in put_blr_gen_id 
	}


	SINT64 read_msg1;
	if (tdgbl->BCK_capabilities & BCK_ods10)
	{
		if (isc_receive(status_vector, &gen_id_reqh, 0, sizeof(read_msg1),
						&read_msg1, 0))
		{
			BURP_error_redirect(status_vector, 25, NULL, NULL);
			// msg 25 Failed in put_blr_gen_id 
		}
	}
	else
	{
		SLONG read_msg0;
		if (isc_receive(status_vector, &gen_id_reqh, 0, sizeof(read_msg0),
						&read_msg0, 0))
		{
			BURP_error_redirect(status_vector, 25, NULL, NULL);
			// msg 25 Failed in put_blr_gen_id 
		}
		read_msg1 = (SINT64) read_msg0;
	}

	isc_release_request(status_vector, &gen_id_reqh);

	return read_msg1;
}


void get_ranges( burp_fld* field)
{
/**************************************
 *
 *	g e t _ r a n g e s
 *
 **************************************
 *
 * Functional description
 *	Fill in the range low and high bounds by reading 
 *      the ranges in rdb$field_dimensions.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	SLONG* rp = field->fld_ranges;
	USHORT count = 0;

// Get the array dimensions in the rdb$field_dimensions 

	/*FOR (REQUEST_HANDLE tdgbl->handles_get_ranges_req_handle1)
		X IN RDB$FIELD_DIMENSIONS 
		WITH X.RDB$FIELD_NAME EQ field->fld_source 
		SORTED BY X.RDB$DIMENSION*/
	{
        if (!tdgbl->handles_get_ranges_req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_get_ranges_req_handle1, (short) sizeof (isc_524), (char *) isc_524);
	isc_vtov ((char*)field->fld_source, (char*)isc_525.isc_526, 32);
	if (tdgbl->handles_get_ranges_req_handle1)
           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_ranges_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_525, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_get_ranges_req_handle1, (short) 1, (short) 12, &isc_527, (short) 0);
	   if (!isc_527.isc_530 || isc_status [1]) break; 
	
		if (count != /*X.RDB$DIMENSION*/
			     isc_527.isc_531)
			BURP_error_redirect (NULL, 52, field->fld_name, NULL);
			// msg 52 array dimension for field %s is invalid 
		*rp++ = /*X.RDB$LOWER_BOUND*/
			isc_527.isc_529;
		*rp++ = /*X.RDB$UPPER_BOUND*/
			isc_527.isc_528;
		count++;
	
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	if (count != field->fld_dimensions)
		BURP_error_redirect(NULL, 52, field->fld_name, NULL);
	// msg 52 array dimension for field %s is invalid 
}


void put_array( burp_fld* field, burp_rel* relation, ISC_QUAD* blob_id)
{
/**************************************
 *
 *	p u t _ a r r a y 
 *
 **************************************
 *
 * Functional description
 *	Write out an array.  If, however, it's null, don't even bother.
 *
 **************************************/
	SLONG range_buffer[16];	// enough for 16 dimensions
	UCHAR blr_buffer[200];		// enough for a sdl with 16 dimensions 

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

// If the array is null, don't store it.  It will be restored as null. 

	if (!blob_id->gds_quad_low && !blob_id->gds_quad_high)
		return;

	lstring xdr_buffer;
	xdr_buffer.lstr_allocated = 0;

	UCHAR* blr = blr_buffer;
	const SLONG* const end_ranges = field->fld_ranges + 2 * field->fld_dimensions;

	USHORT field_length = field->fld_length;
	if (tdgbl->gbl_sw_transportable)
		xdr_buffer.lstr_length = field_length + 3;

// build the sdl 

	add_byte(blr, isc_sdl_version1);

	add_byte(blr, isc_sdl_struct);
	add_byte(blr, 1);

	add_byte(blr, field->fld_type);

	if (field->fld_type == blr_short ||
		field->fld_type == blr_long ||
		field->fld_type == blr_quad ||
		field->fld_type == blr_int64)
	{
		add_byte(blr, field->fld_scale);
	}

	if (field->fld_type == blr_text || field->fld_type == blr_varying)
		add_word(blr, field->fld_length);

	if (field->fld_type == blr_varying)
		field_length += sizeof(USHORT);

	add_byte(blr, isc_sdl_rid);
	add_word(blr, relation->rel_id);
	add_byte(blr, isc_sdl_fid);
	add_word(blr, field->fld_id);

	USHORT count;
	const SLONG* range; // used in multiple loops.
	for (range = field->fld_ranges, count = 0; range < end_ranges;
		 range += 2, count++)
	{
		add_byte(blr, isc_sdl_do2);
		add_byte(blr, count);
		add_byte(blr, isc_sdl_long_integer);
		add_long(blr, range[0]);
		add_byte(blr, isc_sdl_long_integer);
		add_long(blr, range[1]);
	}

	add_byte(blr, isc_sdl_element);
	add_byte(blr, 1);
	add_byte(blr, isc_sdl_scalar);
	add_byte(blr, 0);
	add_byte(blr, field->fld_dimensions);

	for (count = 0; count < field->fld_dimensions; count++)
	{
		add_byte(blr, isc_sdl_variable);
		add_byte(blr, count);
	}

	add_byte(blr, isc_sdl_eoc);

#ifdef DEBUG
	if (debug_on)
		PRETTY_print_sdl(blr_buffer, NULL, NULL, 0);
#endif

	const USHORT blr_length = blr - blr_buffer;

// compute the range size for each dimension = high_range - low_range 

	ULONG slice_length = field_length;
	for (range = field->fld_ranges; range < end_ranges; range += 2)
	{
		slice_length *= (range[1] - range[0] + 1);
		if (tdgbl->gbl_sw_transportable)
			xdr_buffer.lstr_length *= (range[1] - range[0] + 1);
	}
	UCHAR* slice = BURP_alloc(slice_length);

// allocate space for the XDR representation 

	if (tdgbl->gbl_sw_transportable)
	{
		xdr_buffer.lstr_address = BURP_alloc(xdr_buffer.lstr_length);
		xdr_buffer.lstr_allocated = xdr_buffer.lstr_length;
	}

	ISC_STATUS_ARRAY status_vector;
	ULONG return_length = 0;
	if (isc_get_slice(status_vector, &DB, &gds_trans, blob_id,
					  blr_length, (const char*) blr_buffer,
					  0,	// param length for subset of an array handling
					  NULL,	// param for subset of an array handling
					  slice_length, slice, (SLONG*) &return_length))
	{
		BURP_print(81, field->fld_name, NULL, NULL, NULL, NULL);
		// msg 81 error accessing blob field %s -- continuing 
		BURP_print_status(status_vector);
#ifdef DEBUG
		PRETTY_print_sdl(blr_buffer, NULL, NULL, 0);
#endif
		// CVC: At this point I would expected calls to deallocate memory
		// See the end of this function.
		BURP_free(slice);
		if (xdr_buffer.lstr_allocated)
			BURP_free(xdr_buffer.lstr_address);
		return;
	}

	if (return_length != slice_length)
	{
		int i1, i3;
		/* Ugh.  The full array wasn't returned.  We must recompute the top
		   element to backup. */

		SLONG returned_elements = (return_length / field_length) - 1;

		SLONG* returned_range = range_buffer;
		for (i1 = 0, i3 = 0, range = end_ranges - 2;
			 range >= field->fld_ranges; range -= 2, returned_range++, i1++)
		{
			int divisor = 1;
			for (int i2 = (2 * (i1 + 1) + 1); i2 <= field->fld_dimensions * 2;
				 i2 += 2)
			{
				divisor *=
					(field->fld_ranges[i2] - field->fld_ranges[i2 - 1] + 1);
			}
			*returned_range =
				(returned_elements - 1) / divisor + field->fld_ranges[i3];
			returned_elements -=
				(*returned_range - field->fld_ranges[i3]) * divisor;
			i3 += 2;
		}
	}

	put(tdgbl, (UCHAR) (rec_array));
	put_numeric(att_blob_field_number, field->fld_number);
	put_numeric(att_array_dimensions, field->fld_dimensions);

	SLONG* returned_range = range_buffer;
	for (range = field->fld_ranges; range < end_ranges;
		 range += 2, returned_range++)
	{
		put_numeric(att_array_range_low, (int) range[0]);
		if (return_length == slice_length)
			put_numeric(att_array_range_high, (int) range[1]);
		else
			put_numeric(att_array_range_high, (int) *returned_range);
	}

	put(tdgbl, (UCHAR) (att_blob_data));
	put(tdgbl, (UCHAR) (return_length));
	put(tdgbl, (UCHAR) (return_length >> 8));
	put(tdgbl, (UCHAR) (return_length >> 16));
	put(tdgbl, (UCHAR) (return_length >> 24));

	if (return_length)
	{
		const UCHAR* p;
		if (tdgbl->gbl_sw_transportable)
		{
			lstring xdr_slice;
			xdr_slice.lstr_allocated = xdr_slice.lstr_length = return_length;
			xdr_slice.lstr_address = slice;
			return_length =
				CAN_slice(&xdr_buffer, &xdr_slice, TRUE, blr_length,
						  blr_buffer);
			put(tdgbl, (UCHAR) (att_xdr_array));
			put(tdgbl, (UCHAR) (return_length));
			put(tdgbl, (UCHAR) (return_length >> 8));
			put(tdgbl, (UCHAR) (return_length >> 16));
			put(tdgbl, (UCHAR) (return_length >> 24));
			p = xdr_buffer.lstr_address;
		}
		else
			p = slice;
		put_block(tdgbl, p, return_length);
	}

	BURP_free(slice);
	if (xdr_buffer.lstr_allocated)
		BURP_free(xdr_buffer.lstr_address);
}


void put_asciz( const SCHAR attribute, const TEXT* string)
{
/**************************************
 *
 *	p u t _ a s c i z
 *
 **************************************
 *
 * Functional description
 *	Write an attribute starting with a null terminated string.
 *	Currently it's only called by write_database with the db's name as param.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	ULONG l = strlen(string);
	// CVC: We'll have to ensure that length < MAX_FILE_NAME_SIZE.
	// For now, we'll truncate silently until we define a message.
	// We can't honor operating systems that allow longer file names.
	if (l >= MAX_FILE_NAME_SIZE)
	{
		//BURP_print(CREATE A MESSAGE, string, MAX_FILE_NAME_SIZE - 1, 0, 0, 0);
		// msg ZZZ: name %s too large, truncating to %d bytes.
		l = MAX_FILE_NAME_SIZE - 1;
	}

	put(tdgbl, (UCHAR) (attribute));
	put(tdgbl, (UCHAR) (l));
	if (l)
		put_block(tdgbl, (const UCHAR*) string, l);
}


void put_blob( burp_fld* field, ISC_QUAD* blob_id, ULONG count)
{
/**************************************
 *
 *	p u t _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a blob.  If, however, it's null, don't even bother.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	UCHAR  blob_info[32], static_buffer[1024];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

// If the blob is null, don't store it.  It will be restored as null. 

	if (!blob_id->gds_quad_high && !blob_id->gds_quad_low)
		return;

// Open the blob and get it's vital statistics 

	FB_API_HANDLE blob = 0;

	if (isc_open_blob(status_vector, &DB, &gds_trans, &blob, blob_id))
	{
		BURP_print(81, field->fld_name, NULL, NULL, NULL, NULL);
		// msg 81 error accessing blob field %s -- continuing 
		BURP_print_status(status_vector);
		return;
	}

	if (isc_blob_info(status_vector, &blob, sizeof(blob_items),
					  blob_items, sizeof(blob_info),
					  (char*) blob_info))
	{
		BURP_error_redirect(status_vector, 20, NULL, NULL);
		// msg 20 isc_blob_info failed 
	}

	put(tdgbl, (UCHAR) (rec_blob));
	put_numeric(att_blob_field_number, field->fld_number);

	ULONG segments = 0, total_length = 0;
	USHORT max_segment = 0;
	int blob_type = 0; // 0 - segmented, 1 - stream
	const UCHAR* p = blob_info;

	UCHAR item;
	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = isc_vax_integer((const char*) p, 2);
		p += 2;
		const ULONG n = isc_vax_integer((const char*) p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_type:
			blob_type = n;
			break;

		case isc_info_blob_num_segments:
			segments = n;
			break;

		case isc_info_blob_total_length:
			total_length = n;
			break;

		default:
			BURP_error_redirect(NULL, 21, (void*) (IPTR) item, NULL);
			// msg 21 don't understand blob info item %ld 
		}
	}

	// NS: Compute number of chunks we are going to write for stream blob based
	// on total blob length and maximum segment size. This way we tend to 
	// preserve maximum internal segment size over backup/restore. I'm not sure
	// this is beneficial, but let's do it for the moment instead of inventing
	// our own chunk size. Note, the number of segments returned by information
	// call for stream blob is always unreliable, even for zero-length blobs
	if (blob_type == 1) {
		if (total_length != 0)
			segments = (total_length + max_segment - 1) / max_segment;
		else
			segments = 0;
	}

	put_numeric(att_blob_max_segment, max_segment);
	put_numeric(att_blob_number_segments, segments);
	put_numeric(att_blob_type, blob_type);

	// Allocate a buffer large enough for the largest segment and start grinding. 
	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	put(tdgbl, (UCHAR) (att_blob_data));

	while (segments > 0)
	{
		USHORT segment_length;

		ISC_STATUS status =
			isc_get_segment(status_vector, &blob, &segment_length, max_segment,
							(char*) buffer);

		// Handle the errors. For stream blob isc_segment is not error here.
		if (status && (status != isc_segment || blob_type == 0))
		{
			BURP_error_redirect(status_vector, 22, NULL, NULL);
			// msg 22 isc_get_segment failed 
		}

		put(tdgbl, (UCHAR) (segment_length));
		put(tdgbl, (UCHAR) (segment_length >> 8));
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
		--segments;
	}

	if (isc_close_blob(status_vector, &blob))
		BURP_error_redirect(status_vector, 23, NULL, NULL);
	// msg 23 isc_close_blob failed 

	if (buffer != static_buffer)
		BURP_free(buffer);
}


bool put_blr_blob( SCHAR attribute, ISC_QUAD * blob_id)
{
/**************************************
 *
 *	p u t _ b l r _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a blr blob, if present.  Otherwise do nothing.
 *	Return true is there was the blob was present, false otherwise.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	UCHAR blob_info[32], static_buffer[1024];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

// If the blob is null, don't store it.  It will be restored as null. 

	if (!blob_id->gds_quad_high && !blob_id->gds_quad_low)
		return false;

// Open the blob and get it's vital statistics 

	FB_API_HANDLE blob = 0;

	if (isc_open_blob(status_vector, &DB, &gds_trans, &blob, blob_id))
	{
		BURP_error_redirect(status_vector, 24, NULL, NULL);
		// msg 24 isc_open_blob failed 
	}

	if (isc_blob_info(status_vector, &blob, sizeof(blr_items),
					  (SCHAR *) blr_items, sizeof(blob_info),
					  (char*) blob_info))
	{
		BURP_error_redirect(status_vector, 20, NULL, NULL);
		// msg 20 isc_blob_info failed 
	}

	ULONG length = 0;
	USHORT max_segment = 0;
	const UCHAR* p = blob_info;
	UCHAR item;

	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = isc_vax_integer((const char*) p, 2);
		p += 2;
		const ULONG n = isc_vax_integer((const char*) p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_total_length:
			length = n;
			break;

		default:
			BURP_print(79, (void *) (IPTR) item, NULL, NULL, NULL, NULL);
			// msg 79 don't understand blob info item %ld  
			return false;
		}
	}

	if (!length)
	{
		if (isc_close_blob(status_vector, &blob))
			BURP_error_redirect(status_vector, 23, NULL, NULL);
		// msg 23 isc_close_blob failed 
		return false;
	}

// Rdb sometimes gets the length messed up 

	if (length < max_segment)
		length = max_segment;

	put_numeric(attribute, (int) length);

// Allocate a buffer large enough for the largest segment and start grinding. 

	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	USHORT segment_length;
	while (!isc_get_segment(status_vector, &blob, &segment_length,
							(USHORT) max_segment, (char*) buffer))
	{
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
	}

	if (isc_close_blob(status_vector, &blob))
	{
		BURP_error_redirect(status_vector, 23, NULL, NULL);
	}
	// msg 23 isc_close_blob failed 

	if (buffer != static_buffer)
		BURP_free(buffer);

	return true;
}


void put_data(burp_rel* relation)
{
/**************************************
 *
 *	p u t _ d a t a
 *
 **************************************
 *
 * Functional description
 *	Write relation meta-data and data.
 *
 **************************************/
	burp_fld* field;
	ISC_STATUS_ARRAY status_vector;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	// CVC: A signed short isn't enough if the engine allows near 32K fields,
	// each being char(1) ASCII in the worst case. Looking at BLR generation
	// below, it's clear an extreme case won't compile => blr_length >= 32K.
	// However, SSHORT is the limit for request_length in isc_compile_request.
	SSHORT field_count = 1;

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (!(field->fld_flags & FLD_computed))
		{
			field_count += 2;
		}
	}
	fb_assert(field_count > 0 && field_count * 9 > 0 && field_count * 9 + 200 > 0);

/* Time to generate blr to fetch data.  Make sure we allocate a BLR buffer
   large enough to handle the per field overhead */
	UCHAR* const blr_buffer = BURP_alloc(200 + field_count * 9);
	UCHAR* blr = blr_buffer;
	add_byte(blr, blr_version4);
	add_byte(blr, blr_begin);
	add_byte(blr, blr_message);
	add_byte(blr, 0);						// Message number
	add_word(blr, field_count);		// Number of fields, counting eof

	RCRD_OFFSET offset = 0;
	SSHORT count = 0;   // This is param count.

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		SSHORT alignment = 4;
		FLD_LENGTH length = field->fld_length;
		SSHORT dtype = field->fld_type;
		if (field->fld_flags & FLD_array)
		{
			dtype = blr_blob;
			length = 8;
		}
		switch (dtype)
		{
		case blr_text:
			alignment = type_alignments[dtype_text];
			add_byte(blr, field->fld_type);
			add_word(blr, field->fld_length);
			break;

		case blr_varying:
			alignment = type_alignments[dtype_varying];
			add_byte(blr, field->fld_type);
			add_word(blr, field->fld_length);
			length += sizeof(USHORT);
			break;

		case blr_short:
			alignment = type_alignments[dtype_short];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_long:
			alignment = type_alignments[dtype_long];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_quad:
			alignment = type_alignments[dtype_quad];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_int64:
			alignment = type_alignments[dtype_int64];
			add_byte(blr, field->fld_type);
			add_byte(blr, field->fld_scale);
			break;

		case blr_double:
			alignment = type_alignments[dtype_double];
			add_byte(blr, field->fld_type);
			break;

		case blr_timestamp:
			alignment = type_alignments[dtype_timestamp];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_time:
			alignment = type_alignments[dtype_sql_time];
			add_byte(blr, field->fld_type);
			break;

		case blr_sql_date:
			alignment = type_alignments[dtype_sql_date];
			add_byte(blr, field->fld_type);
			break;

		case blr_float:
			alignment = type_alignments[dtype_real];
			add_byte(blr, field->fld_type);
			break;

		case blr_blob:
			alignment = type_alignments[dtype_blob];
			add_byte(blr, blr_quad);
			add_byte(blr, 0);
			break;

		default:
			BURP_error_redirect(NULL, 26, (void *) (IPTR) field->fld_type, NULL);
			// msg 26 datatype %ld not understood 
			break;
		}
		if (alignment)
			offset = FB_ALIGN(offset, alignment);
		field->fld_offset = offset;
		field->fld_parameter = count++;
		offset += length;
	}

// Next, build fields for null flags 

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		add_byte(blr, blr_short);
		add_byte(blr, 0);
		offset = FB_ALIGN(offset, sizeof(SSHORT));
		field->fld_missing_parameter = count++;
		offset += sizeof(SSHORT);
	}

// Finally, make up an EOF field 

	add_byte(blr, blr_short);			// eof field 
	add_byte(blr, 0);					// scale for eof field 
	SSHORT eof_parameter = count++;
	RCRD_OFFSET record_length = offset;
	RCRD_OFFSET eof_offset = FB_ALIGN(offset, sizeof(SSHORT));
	// To be used later for the buffer size to receive data
	const FLD_LENGTH length = (USHORT) (eof_offset + sizeof(SSHORT));

// Build FOR loop, body, and eof handler 

	add_byte(blr, blr_for);
	add_byte(blr, blr_rse);
	add_byte(blr, 1);					// count of relations 
	add_byte(blr, blr_rid);
	add_word(blr, relation->rel_id);
	add_byte(blr, 0);					// context variable 
	add_byte(blr, blr_end);

	add_byte(blr, blr_send);
	add_byte(blr, 0);
	add_byte(blr, blr_begin);
	add_byte(blr, blr_assignment);
	add_byte(blr, blr_literal);
	add_byte(blr, blr_short);
	add_byte(blr, 0);
	add_word(blr, 1);
	add_byte(blr, blr_parameter);
	add_byte(blr, 0);
	add_word(blr, eof_parameter);

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		if (field->fld_flags & FLD_computed)
			continue;
		add_byte(blr, blr_assignment);
		add_byte(blr, blr_fid);
		add_byte(blr, 0);
		add_word(blr, field->fld_id);
		add_byte(blr, blr_parameter2);
		add_byte(blr, 0);
		add_word(blr, field->fld_parameter);
		add_word(blr, field->fld_missing_parameter);
	}

	add_byte(blr, blr_end);

	add_byte(blr, blr_send);
	add_byte(blr, 0);
	add_byte(blr, blr_assignment);
	add_byte(blr, blr_literal);
	add_byte(blr, blr_short);
	add_byte(blr, 0);
	add_word(blr, 0);
	add_byte(blr, blr_parameter);
	add_byte(blr, 0);
	add_word(blr, eof_parameter);

	add_byte(blr, blr_end);
	add_byte(blr, blr_eoc);

#ifdef DEBUG
	if (debug_on)
		isc_print_blr((const char*)blr_buffer, NULL, NULL, 0);
#endif


// Compile request 

	FB_API_HANDLE request = 0;
	SSHORT blr_length = blr - blr_buffer;
	if (isc_compile_request(status_vector, &DB, &request,
							blr_length, (const SCHAR*) blr_buffer))
	{
		BURP_error_redirect(status_vector, 27, NULL, NULL);
		// msg 27 isc_compile_request failed 
		isc_print_blr((const char*) blr_buffer, NULL, NULL, 0);
	}

	BURP_free(blr_buffer);
	
	BURP_verbose(142, relation->rel_name, NULL, NULL, NULL, NULL);
	// msg 142  writing data for relation %s 

	if (isc_start_request(status_vector, &request, &gds_trans, 0))
	{
		BURP_error_redirect(status_vector, 28, NULL, NULL);
		// msg 28 isc_start_request failed
	}

/* Here is the crux of the problem -- writing data.  All this work
   for the following small loop. */

	UCHAR* buffer = BURP_alloc(length);
	SSHORT* eof = (SSHORT *) (buffer + eof_offset);

// the XDR representation may be even fluffier
	lstring xdr_buffer;
	if (tdgbl->gbl_sw_transportable)
	{
		xdr_buffer.lstr_length = xdr_buffer.lstr_allocated =
			length + count * 3;
		xdr_buffer.lstr_address = BURP_alloc(xdr_buffer.lstr_length);
	}
	else
		xdr_buffer.lstr_address = NULL;

	ULONG records = 0;
	while (true)
	{
		if (isc_receive(status_vector, &request, 0, length, buffer, 0))
		{
			BURP_error_redirect(status_vector, 29, NULL, NULL);
			// msg 29 isc_receive failed 
		}
		if (!*eof)
			break;
		records++;
		// Verbose records 
		if ((records % BACKUP_VERBOSE_INTERVAL) == 0)
			BURP_verbose(108, (void *) (IPTR) records, NULL, NULL, NULL, NULL);

		put(tdgbl, (UCHAR) (rec_data));
		put_numeric(att_data_length, record_length);
		const UCHAR* p;
		if (tdgbl->gbl_sw_transportable)
		{
			record_length =
				CAN_encode_decode(relation, &xdr_buffer, buffer, TRUE);
			put_numeric(att_xdr_length, record_length);
			p = xdr_buffer.lstr_address;
		}
		else
			p = buffer;
		put(tdgbl, (UCHAR) (att_data_data));
		if (tdgbl->gbl_sw_compress)
			compress(p, record_length);
		else if (record_length)
			put_block(tdgbl, p, record_length);

		// Look for any blobs to write 

		for (field = relation->rel_fields; field; field = field->fld_next)
		{
			if (field->fld_type == blr_blob &&
				!(field->fld_flags & FLD_computed) &&
				!(field->fld_flags & FLD_array))
			{
				put_blob(field,
						 (ISC_QUAD*) (buffer + field-> fld_offset),
						 records);
			}
		}

		// Look for any array to write 
		// we got back the blob_id for the array from isc_receive in the second param. 
		for (field = relation->rel_fields; field; field = field->fld_next)
		{
			if (field->fld_flags & FLD_array)
			{
				put_array(field, relation,
						  (ISC_QUAD *) (buffer + field->fld_offset));
			}
		}
	}

	BURP_free(buffer);

	if (xdr_buffer.lstr_address)
		BURP_free(xdr_buffer.lstr_address);

	BURP_verbose(108, (void *) (IPTR) records, NULL, NULL, NULL, NULL);
// msg 108 %ld records written 

	if (isc_release_request(status_vector, &request))
		BURP_error_redirect(status_vector, 30, NULL, NULL);
	// msg 30 isc_release_request failed 
}


void put_index( burp_rel* relation)
{
/**************************************
 *
 *	p u t _ i n d e x
 *
 **************************************
 *
 * Functional description
 *	Write information about an index.  First
 *	check that all the segments of the
 *	index exist.
 *
 **************************************/
	ULONG count;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

/* if we have all capabilities, use the first request to get the 
   most performance out of the latest engine; if we don't 
   have one of the capabilities we must use the second set of 
   requests--this requires more code but it is well worth it 
   for the performance benefits, especially remotely--deej */

	if ((tdgbl->BCK_capabilities & BCK_idx_inactive) &&
		(tdgbl->BCK_capabilities & BCK_attributes_v3) &&
		(tdgbl->BCK_capabilities & BCK_ods8))
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle1)
			X IN RDB$INDICES WITH 
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
                if (!tdgbl->handles_put_index_req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (short) sizeof (isc_507), (char *) isc_507);
		isc_vtov ((char*)relation->rel_name, (char*)isc_508.isc_509, 32);
		if (tdgbl->handles_put_index_req_handle1)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_508, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (short) 1, (short) 104, &isc_510, (short) 0);
		   if (!isc_510.isc_516 || isc_status [1]) break;
	
			count = 0;
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle2)
				I_S IN RDB$INDEX_SEGMENTS CROSS 
				RFR IN RDB$RELATION_FIELDS WITH 
				I_S.RDB$FIELD_NAME = RFR.RDB$FIELD_NAME AND 
				I_S.RDB$INDEX_NAME = X.RDB$INDEX_NAME AND 
				RFR.RDB$RELATION_NAME = relation->rel_name*/
			{
                        if (!tdgbl->handles_put_index_req_handle2)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (short) sizeof (isc_501), (char *) isc_501);
			isc_vtov ((char*)relation->rel_name, (char*)isc_502.isc_503, 32);
			isc_vtov ((char*)isc_510.isc_515, (char*)isc_502.isc_504, 32);
			if (tdgbl->handles_put_index_req_handle2)
                           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_502, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (short) 1, (short) 2, &isc_505, (short) 0);
			   if (!isc_505.isc_506 || isc_status [1]) break; 
	
				count++;
	
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
	
			if (count != (ULONG) /*X.RDB$SEGMENT_COUNT*/
					     isc_510.isc_523) 
			{
				BURP_print(180, /*X.RDB$INDEX_NAME*/
						isc_510.isc_515, (void*)(IPTR)count,
							(void*)(IPTR)/*X.RDB$SEGMENT_COUNT*/
								     isc_510.isc_523, NULL, NULL);
				continue;
			}
	
			put(tdgbl, rec_index);
			const ULONG l = PUT_TEXT (att_index_name, /*X.RDB$INDEX_NAME*/
								  isc_510.isc_515);
			MISC_terminate (/*X.RDB$INDEX_NAME*/
					isc_510.isc_515, temp, l, sizeof(temp));
			BURP_verbose (151, temp, NULL, NULL, NULL, NULL);
			// msg 151 writing index %s 
			put_numeric (att_segment_count, /*X.RDB$SEGMENT_COUNT*/
							isc_510.isc_523);
			put_numeric (att_index_inactive, /*X.RDB$INDEX_INACTIVE*/
							 isc_510.isc_522);
			put_numeric (att_index_unique_flag, /*X.RDB$UNIQUE_FLAG*/
							    isc_510.isc_521);
	
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle5)
				Y IN RDB$INDEX_SEGMENTS WITH 
				Y.RDB$INDEX_NAME EQ X.RDB$INDEX_NAME
				SORTED BY Y.RDB$FIELD_POSITION*/
			{
                        if (!tdgbl->handles_put_index_req_handle5)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (short) sizeof (isc_495), (char *) isc_495);
			isc_vtov ((char*)isc_510.isc_515, (char*)isc_496.isc_497, 32);
			if (tdgbl->handles_put_index_req_handle5)
                           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_496, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (short) 1, (short) 34, &isc_498, (short) 0);
			   if (!isc_498.isc_500 || isc_status [1]) break;
	
				PUT_TEXT (att_index_field_name, /*Y.RDB$FIELD_NAME*/
								isc_498.isc_499);
	
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
	
			put_source_blob (att_index_description2, att_index_description, &/*X.RDB$DESCRIPTION*/
											 isc_510.isc_514);
			put_numeric (att_index_type, /*X.RDB$INDEX_TYPE*/
						     isc_510.isc_520);
	
			if (!/*X.RDB$EXPRESSION_SOURCE.NULL*/
			     isc_510.isc_519)
				put_source_blob (att_index_expression_source,
								 att_index_expression_source,
								 &/*X.RDB$EXPRESSION_SOURCE*/
								  isc_510.isc_513);
			if (!/*X.RDB$EXPRESSION_BLR.NULL*/
			     isc_510.isc_518)
				put_blr_blob (att_index_expression_blr,
							  &/*X.RDB$EXPRESSION_BLR*/
							   isc_510.isc_512);
			if (!/*X.RDB$FOREIGN_KEY.NULL*/
			     isc_510.isc_517)
				PUT_TEXT (att_index_foreign_key, /*X.RDB$FOREIGN_KEY*/
								 isc_510.isc_511);
			put(tdgbl, att_end);
	
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle1)
			X IN RDB$INDICES WITH 
			X.RDB$RELATION_NAME EQ relation->rel_name*/
		{
                if (!tdgbl->handles_put_index_req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (short) sizeof (isc_486), (char *) isc_486);
		isc_vtov ((char*)relation->rel_name, (char*)isc_487.isc_488, 32);
		if (tdgbl->handles_put_index_req_handle1)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_487, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle1, (short) 1, (short) 46, &isc_489, (short) 0);
		   if (!isc_489.isc_492 || isc_status [1]) break;
	
			count = 0;
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle2)
				I_S IN RDB$INDEX_SEGMENTS WITH 
				I_S.RDB$INDEX_NAME = X.RDB$INDEX_NAME*/
			{
                        if (!tdgbl->handles_put_index_req_handle2)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (short) sizeof (isc_480), (char *) isc_480);
			isc_vtov ((char*)isc_489.isc_491, (char*)isc_481.isc_482, 32);
			if (tdgbl->handles_put_index_req_handle2)
                           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_481, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle2, (short) 1, (short) 34, &isc_483, (short) 0);
			   if (!isc_483.isc_485 || isc_status [1]) break;
				bool match = false;
	
				/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle3)
					RFR IN RDB$RELATION_FIELDS WITH 
					I_S.RDB$FIELD_NAME = RFR.RDB$FIELD_NAME AND
					RFR.RDB$RELATION_NAME = relation->rel_name*/
				{
                                if (!tdgbl->handles_put_index_req_handle3)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle3, (short) sizeof (isc_474), (char *) isc_474);
				isc_vtov ((char*)relation->rel_name, (char*)isc_475.isc_476, 32);
				isc_vtov ((char*)isc_483.isc_484, (char*)isc_475.isc_477, 32);
				if (tdgbl->handles_put_index_req_handle3)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle3, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_475, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle3, (short) 1, (short) 2, &isc_478, (short) 0);
				   if (!isc_478.isc_479 || isc_status [1]) break; 
					match = true;
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
				if (!match)
					BURP_print (179, /*I_S.RDB$FIELD_NAME*/
							 isc_483.isc_484, /*X.RDB$INDEX_NAME*/
  isc_489.isc_491, NULL, NULL, NULL); 
				else
					count++;
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
	
			if (count != (ULONG) /*X.RDB$SEGMENT_COUNT*/
					     isc_489.isc_494) 
			{
				BURP_print(180, /*X.RDB$INDEX_NAME*/
						isc_489.isc_491, (void*)(IPTR) count,
						   (void*)(IPTR) /*X.RDB$SEGMENT_COUNT*/
								 isc_489.isc_494, NULL, NULL);
				continue; 
			}
	
			put(tdgbl, rec_index);
			const ULONG l = PUT_TEXT (att_index_name, /*X.RDB$INDEX_NAME*/
								  isc_489.isc_491);
			MISC_terminate (/*X.RDB$INDEX_NAME*/
					isc_489.isc_491, temp, l, sizeof(temp));
			BURP_verbose (151, temp, NULL, NULL, NULL, NULL);
			// msg 151 writing index %s 
			put_numeric (att_segment_count, /*X.RDB$SEGMENT_COUNT*/
							isc_489.isc_494);
			if (tdgbl->BCK_capabilities & BCK_idx_inactive)
				/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle4)
					I IN RDB$INDICES WITH I.RDB$INDEX_NAME = X.RDB$INDEX_NAME*/
				{
                                if (!tdgbl->handles_put_index_req_handle4)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle4, (short) sizeof (isc_468), (char *) isc_468);
				isc_vtov ((char*)isc_489.isc_491, (char*)isc_469.isc_470, 32);
				if (tdgbl->handles_put_index_req_handle4)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle4, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_469, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle4, (short) 1, (short) 4, &isc_471, (short) 0);
				   if (!isc_471.isc_472 || isc_status [1]) break;
					put_numeric (att_index_inactive, /*I.RDB$INDEX_INACTIVE*/
									 isc_471.isc_473); 
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			put_numeric (att_index_unique_flag, /*X.RDB$UNIQUE_FLAG*/
							    isc_489.isc_493);
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle5)
				Y IN RDB$INDEX_SEGMENTS WITH Y.RDB$INDEX_NAME EQ X.RDB$INDEX_NAME
				SORTED BY Y.RDB$FIELD_POSITION*/
			{
                        if (!tdgbl->handles_put_index_req_handle5)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (short) sizeof (isc_462), (char *) isc_462);
			isc_vtov ((char*)isc_489.isc_491, (char*)isc_463.isc_464, 32);
			if (tdgbl->handles_put_index_req_handle5)
                           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_463, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle5, (short) 1, (short) 34, &isc_465, (short) 0);
			   if (!isc_465.isc_467 || isc_status [1]) break;
				PUT_TEXT (att_index_field_name, /*Y.RDB$FIELD_NAME*/
								isc_465.isc_466);
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
			put_source_blob (att_index_description2, att_index_description,
							 &/*X.RDB$DESCRIPTION*/
							  isc_489.isc_490);
			if (tdgbl->BCK_capabilities & BCK_attributes_v3)
				/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle6)
					I IN RDB$INDICES WITH I.RDB$INDEX_NAME = X.RDB$INDEX_NAME*/
				{
                                if (!tdgbl->handles_put_index_req_handle6)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle6, (short) sizeof (isc_456), (char *) isc_456);
				isc_vtov ((char*)isc_489.isc_491, (char*)isc_457.isc_458, 32);
				if (tdgbl->handles_put_index_req_handle6)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle6, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_457, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle6, (short) 1, (short) 4, &isc_459, (short) 0);
				   if (!isc_459.isc_460 || isc_status [1]) break;
					put_numeric (att_index_type, /*I.RDB$INDEX_TYPE*/
								     isc_459.isc_461);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			if (tdgbl->BCK_capabilities & BCK_ods8)
				/*FOR (REQUEST_HANDLE tdgbl->handles_put_index_req_handle7)
					I IN RDB$INDICES WITH I.RDB$INDEX_NAME = X.RDB$INDEX_NAME*/
				{
                                if (!tdgbl->handles_put_index_req_handle7)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle7, (short) sizeof (isc_445), (char *) isc_445);
				isc_vtov ((char*)isc_489.isc_491, (char*)isc_446.isc_447, 32);
				if (tdgbl->handles_put_index_req_handle7)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle7, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_446, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_index_req_handle7, (short) 1, (short) 56, &isc_448, (short) 0);
				   if (!isc_448.isc_452 || isc_status [1]) break;
					if (!/*I.RDB$EXPRESSION_SOURCE.NULL*/
					     isc_448.isc_455)
						put_source_blob (att_index_expression_source,
										 att_index_expression_source,
										 &/*I.RDB$EXPRESSION_SOURCE*/
										  isc_448.isc_451);
					if (!/*I.RDB$EXPRESSION_BLR.NULL*/
					     isc_448.isc_454)
						put_blr_blob (att_index_expression_blr,
									  &/*I.RDB$EXPRESSION_BLR*/
									   isc_448.isc_450);
					if (!/*I.RDB$FOREIGN_KEY.NULL*/
					     isc_448.isc_453)
						PUT_TEXT (att_index_foreign_key, /*I.RDB$FOREIGN_KEY*/
										 isc_448.isc_449);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			put(tdgbl, att_end);
	
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
}


int put_message( SCHAR attribute, const TEXT* text, ULONG length)
{
/**************************************
 *
 *	p u t _ m e s s a g e
 *
 **************************************
 *
 * Functional description
 *	Write a variable length text string, with embedded
 *      blanks.  Same as put_text but handles embedded blanks.
 * CVC: As v6 time, put_text handles embedded blanks, too!
 * The only difference is that put_text's length is SSHORT, so
 * in theory put_message can handle much longer input and it's
 * used for exception & trigger's messages (plus update/delete
 * rules for FKs and constraint types, where it's irrelevant
 * which function of the two you use).
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	ULONG l = 0;
	for (const TEXT* p = text; *p && l < length; p++)
		l++;

	l = length = MIN(l, length);
	put(tdgbl, (UCHAR) (attribute));
	put(tdgbl, (UCHAR) (l));
	if (l)
		put_block(tdgbl, reinterpret_cast<const UCHAR*>(text), l);

	return length;
}


void put_numeric( SCHAR attribute, SLONG value)
{
/**************************************
 *
 *	p u t _ n u m e r i c
 *
 **************************************
 *
 * Functional description
 *	Write a numeric value as an attribute.  The number is represented
 *	low byte first, high byte last, as in VAX.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const SLONG vax_value = (SLONG) isc_vax_integer((const char*) &value, sizeof(value));

	put(tdgbl, (UCHAR) (attribute));
	put(tdgbl, (UCHAR) sizeof(value));
	put_block(tdgbl, (const UCHAR*) &vax_value, sizeof(vax_value));
}


void put_int64( SCHAR attribute, SINT64 value)
{
/**************************************
 *
 *	p u t _ i n t 6 4
 *
 **************************************
 *
 * Functional description
 *	Write a 64-bit numeric value as an attribute.
 *      The number is represented low byte first, high byte last, as in VAX.
 *      This function is just like put_numeric, except that it handles an
 *      INT64 value, while put_numeric handles a 32-bit value.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const UINT64 le_value =
		(UINT64) isc_portable_integer((const UCHAR*) &value, sizeof(value));

	put(tdgbl, (UCHAR) (attribute));
	put(tdgbl, (UCHAR) (sizeof(value)));
	put_block(tdgbl, (const UCHAR*) &le_value, sizeof(le_value));
}


void put_relation( burp_rel* relation)
{
/**************************************
 *
 * 	p u t _ r e l a t i o n
 *
 **************************************
 *
 * Functional description
 *	Write relation meta-data and data.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

/* Write local field information.  This is made slightly more complicated
   by the requirement that computational fields be aligned. */

	burp_fld* aligned = NULL;
	burp_fld* unaligned = NULL;
	burp_fld* aligned4 = NULL;
	burp_fld* aligned8 = NULL;

	burp_fld* fields = get_fields(relation);

// sort the list of fields into three lists, depending on alignment
	burp_fld* field;
	for (field = fields; field = fields;)
	{
		fields = field->fld_next;
		USHORT l = field->fld_length;
		if (field->fld_type == blr_varying)
			l += sizeof(USHORT);
		if (!(l & 7))
		{
			field->fld_next = aligned8;
			aligned8 = field;
		}
		else if (!(l & 3))
		{
			field->fld_next = aligned4;
			aligned4 = field;
		}
		else if (l & 1)
		{
			field->fld_next = unaligned;
			unaligned = field;
		}
		else
		{
			field->fld_next = aligned;
			aligned = field;
		}
	}

/* Next, merge the aligned and unaligned sub-lists.  In the process,
   re-create (approximately) the original order of the fields.  This is
   not strictly required, but it certainly is polite. */

	while (field = unaligned)
	{
		unaligned = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned)
	{
		aligned = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned4)
	{
		aligned4 = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

	while (field = aligned8)
	{
		aligned8 = field->fld_next;
		field->fld_next = relation->rel_fields;
		relation->rel_fields = field;
	}

// Now write the fields in what will become physical backup order 

	for (field = relation->rel_fields; field; field = field->fld_next)
	{
		put(tdgbl, (UCHAR) (rec_field));
		const USHORT l = PUT_TEXT(att_field_name, field->fld_name);
		MISC_terminate(field->fld_name, temp, l, sizeof(temp));
		BURP_verbose(144, temp, NULL, NULL, NULL, NULL);
		// msg 144  writing field %s 
		PUT_TEXT(att_field_source, field->fld_source);
		if (field->fld_query_name[0])
			PUT_TEXT(att_field_query_name, field->fld_query_name);
		if (field->fld_complex_name[0])
			PUT_TEXT(att_field_complex_name, field->fld_complex_name);
		if (field->fld_edit_string[0])
			PUT_TEXT(att_field_edit_string, field->fld_edit_string);
		put_source_blob(att_field_description2, att_field_description,
						& field->fld_description);
		put_source_blob(att_field_query_header, att_field_query_header,
						& field->fld_query_header);
		if (field->fld_security_class[0])
			PUT_TEXT(att_field_security_class, field->fld_security_class);
		if (!(field->fld_flags & FLD_position_missing))
			put_numeric(att_field_position, field->fld_position);
		put_numeric(att_field_type, field->fld_type);
		put_numeric(att_field_length, field->fld_length);
		put_numeric(att_field_sub_type, field->fld_sub_type);
		put_numeric(att_field_scale, field->fld_scale);
		put_numeric(att_field_number, field->fld_number);
		put_numeric(att_field_system_flag, field->fld_system_flag);
		if (!(field->fld_flags & FLD_update_missing))
			put_numeric(att_field_update_flag, field->fld_update_flag);
		if (field->fld_flags & FLD_null_flag)
			put_numeric(att_field_null_flag, field->fld_null_flag);
		if (field->fld_flags & FLD_charset_flag)
			put_numeric(att_field_character_set, field->fld_character_set_id);
		if (field->fld_flags & FLD_collate_flag)
			put_numeric(att_field_collation_id, field->fld_collation_id);
		put_blr_blob(att_field_default_value,
					 & field->fld_default_value);
		put_source_blob(att_field_default_source, att_field_default_source,
						& field->fld_default_source);
		if (relation->rel_flags & REL_view)
		{
			put_numeric(att_view_context, field->fld_view_context);
			PUT_TEXT(att_base_field, field->fld_base);
		}
		if (field->fld_flags & FLD_computed)
			put_numeric(att_field_computed_flag, TRUE);
		if (field->fld_flags & FLD_array)
		{
			put_numeric(att_field_dimensions, field->fld_dimensions);
			const SLONG* rp = field->fld_ranges;
			for (USHORT n = field->fld_dimensions; n; rp += 2, n--)
			{
				put_numeric(att_field_range_low, *rp);
				put_numeric(att_field_range_high, *(rp + 1));
			}
		}
		put(tdgbl, (UCHAR) (att_end));
	}

// Write out view relations (if a view, of course) 

	if (relation->rel_flags & REL_view)
	{
		if (tdgbl->BCK_capabilities & BCK_context_name)
		{
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_relation_req_handle1)
				X IN RDB$VIEW_RELATIONS WITH X.RDB$VIEW_NAME EQ relation->rel_name*/
			{
                        if (!tdgbl->handles_put_relation_req_handle1)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (short) sizeof (isc_437), (char *) isc_437);
			isc_vtov ((char*)relation->rel_name, (char*)isc_438.isc_439, 32);
			if (tdgbl->handles_put_relation_req_handle1)
                           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_438, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle1, (short) 1, (short) 68, &isc_440, (short) 0);
			   if (!isc_440.isc_443 || isc_status [1]) break;
				put(tdgbl, rec_view);
				PUT_TEXT (att_view_relation_name, /*X.RDB$RELATION_NAME*/
								  isc_440.isc_442);
				put_numeric (att_view_context_id, /*X.RDB$VIEW_CONTEXT*/
								  isc_440.isc_444);
				PUT_TEXT (att_view_context_name, /*X.RDB$CONTEXT_NAME*/
								 isc_440.isc_441);
				put(tdgbl, att_end);
			/*END_FOR*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
		else
		{
			/*FOR (REQUEST_HANDLE tdgbl->handles_put_relation_req_handle2)
				X IN RDB$VIEW_RELATIONS WITH X.RDB$VIEW_NAME EQ relation->rel_name*/
			{
                        if (!tdgbl->handles_put_relation_req_handle2)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle2, (short) sizeof (isc_430), (char *) isc_430);
			isc_vtov ((char*)relation->rel_name, (char*)isc_431.isc_432, 32);
			if (tdgbl->handles_put_relation_req_handle2)
                           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_431, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_put_relation_req_handle2, (short) 1, (short) 36, &isc_433, (short) 0);
			   if (!isc_433.isc_435 || isc_status [1]) break;
				put(tdgbl, rec_view);
				PUT_TEXT (att_view_relation_name, /*X.RDB$RELATION_NAME*/
								  isc_433.isc_434);
				put_numeric (att_view_context_id, /*X.RDB$VIEW_CONTEXT*/
								  isc_433.isc_436);
				put(tdgbl, att_end);
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
	}
	put(tdgbl, (UCHAR) (rec_relation_end));
}


bool put_source_blob(SCHAR		attribute,
						   SCHAR		old_attribute,
						   ISC_QUAD*	blob_id)
{
/**************************************
 *
 *	p u t _ s o u r c e _ b l o b
 *
 **************************************
 *
 * Functional description
 *	Write out a source blob or query header if present.
 *	Return true is there was the blob was present, false otherwise.
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	UCHAR blob_info[48], static_buffer[1024];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

// If the blob is null, don't store it.  It will be restored as null.

	if (!blob_id->gds_quad_high && !blob_id->gds_quad_low)
		return false;

	if (tdgbl->gbl_sw_old_descriptions && attribute != att_field_query_header)
		return put_blr_blob(old_attribute, blob_id);

// Open the blob and get it's vital statistics

	FB_API_HANDLE blob = 0;

	if (isc_open_blob(status_vector, &DB, &gds_trans, &blob, blob_id))
	{
		BURP_error_redirect(status_vector, 24, NULL, NULL);
		// msg 24 isc_open_blob failed 
	}

	if (isc_blob_info(status_vector, &blob, sizeof(source_items),
					  (SCHAR *) source_items, sizeof(blob_info),
					  (SCHAR*) blob_info))
	{
		BURP_error_redirect(status_vector, 20, NULL, NULL);
		// msg 20 isc_blob_info failed 
	}

	SLONG length = 0;
	USHORT max_segment = 0, num_seg = 0;
	const UCHAR* p = blob_info;
	UCHAR item;

	while ((item = *p++) != isc_info_end)
	{
		const USHORT l = isc_vax_integer((const SCHAR*) p, 2);
		p += 2;
		const ULONG n = isc_vax_integer((const SCHAR*) p, l);
		p += l;
		switch (item)
		{
		case isc_info_blob_max_segment:
			max_segment = n;
			break;

		case isc_info_blob_total_length:
			length = n;
			break;

		case isc_info_blob_num_segments:
			num_seg = n;
			break;

		default:
			BURP_print(79, (void *)(IPTR) item, NULL, NULL, NULL, NULL);
			// msg 79 don't understand blob info item %ld  
			return false;
		}
	}

	if (!length)
	{
		if (isc_close_blob(status_vector, &blob))
		{
			BURP_error_redirect(status_vector, 23, NULL, NULL);
			// msg 23 isc_close_blob failed 
		}
		return false;
	}

// Rdb sometimes gets the length messed up 

	if (length < max_segment)
		length = max_segment;

	put_numeric(attribute, length + num_seg);

// Allocate a buffer large enough for the largest segment and start grinding. 

	UCHAR* buffer;
	if (!max_segment || max_segment <= sizeof(static_buffer))
		buffer = static_buffer;
	else
		buffer = BURP_alloc(max_segment);

	USHORT segment_length;
	while (!isc_get_segment(status_vector, &blob, &segment_length,
							max_segment, (SCHAR*) buffer))
	{
		if (segment_length)
		{
			put_block(tdgbl, buffer, segment_length);
		}
		put(tdgbl, (UCHAR) (NULL));
	}

	if (isc_close_blob(status_vector, &blob))
		BURP_error_redirect(status_vector, 23, NULL, NULL);
	// msg 23 isc_close_blob failed 

	if (buffer != static_buffer)
		BURP_free(buffer);

	return true;
}


int put_text( SCHAR attribute, const TEXT* text, SSHORT size_len)
{
/**************************************
 *
 *	p u t _ t e x t
 *
 **************************************
 *
 * Functional description
 * Write a variable length text string, with embedded spaces.
 * Truncate trailing spaces.
 * Now this routine does not truncate trailing spaces, 3-2002 MOD
 * transfering changes from fb1, I believe this is to do with problems
 * with quoted names and embedded spaces.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	const SSHORT l = (SSHORT) MISC_symbol_length(text, (ULONG) size_len);
 
	put(tdgbl, (UCHAR) (attribute));
	put(tdgbl, (UCHAR) (l));
	if (l)
		put_block(tdgbl, (const UCHAR*) text, l);

	return l;
}


void set_capabilities(void)
{
/**************************************
 *
 *	s e t _ c a p a b i l i t i e s
 *
 **************************************
 *
 * Functional description
 *	
 *	set the capabilities bits for the
 *	database being extracted to avoid
 *	unpleasantness later.
 *
 **************************************/
	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	FB_API_HANDLE req = 0;

// Look for desireable fields in system relations

	for (const rfr_tab_t* rel_field_table = rfr_table; rel_field_table->relation;
		 rel_field_table++)
	{
		const TEXT* field = rel_field_table->field;
		const TEXT* relation = rel_field_table->relation;
		/*FOR (REQUEST_HANDLE req) x IN RDB$RELATION_FIELDS
			WITH x.RDB$RELATION_NAME = relation
			AND x.RDB$FIELD_NAME = field*/
		{
                if (!req)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req, (short) sizeof (isc_424), (char *) isc_424);
		isc_vtov ((char*)field, (char*)isc_425.isc_426, 32);
		isc_vtov ((char*)relation, (char*)isc_425.isc_427, 32);
		if (req)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 64, &isc_425, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req, (short) 1, (short) 2, &isc_428, (short) 0);
		   if (!isc_428.isc_429 || isc_status [1]) break;
			tdgbl->BCK_capabilities |= rel_field_table->bit_mask;
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	isc_release_request(isc_status, &req);
}


void write_character_sets(void)
{
/**************************************
 *
 *	w r i t e _ c h a r a c t e r _ s e t s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user defined character set.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$CHARACTER_SETS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_408), (char *) isc_408);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 156, &isc_409, (short) 0);
	   if (!isc_409.isc_416 || isc_status [1]) break;
		put(tdgbl, rec_charset);
		PUT_TEXT (att_charset_name, /*X.RDB$CHARACTER_SET_NAME*/
					    isc_409.isc_414);
		if (!/*X.RDB$FORM_OF_USE.NULL*/
		     isc_409.isc_423)
			PUT_TEXT (att_charset_form, /*X.RDB$FORM_OF_USE*/
						    isc_409.isc_413);
		if (!/*X.RDB$NUMBER_OF_CHARACTERS.NULL*/
		     isc_409.isc_422)
			put_numeric (att_charset_numchar, /*X.RDB$NUMBER_OF_CHARACTERS*/
							  isc_409.isc_415);
		PUT_TEXT (att_charset_coll, /*X.RDB$DEFAULT_COLLATE_NAME*/
					    isc_409.isc_412);
		put_numeric (att_charset_id, /*X.RDB$CHARACTER_SET_ID*/
					     isc_409.isc_421);
		if (/*X.RDB$SYSTEM_FLAG*/
		    isc_409.isc_420)
			put_numeric (att_charset_sysflag, /*X.RDB$SYSTEM_FLAG*/
							  isc_409.isc_420);
		if (!/*X.RDB$DESCRIPTION.NULL*/
		     isc_409.isc_419)
			put_source_blob (att_charset_description, att_charset_description,
				&/*X.RDB$DESCRIPTION*/
				 isc_409.isc_411);
		if (!/*X.RDB$FUNCTION_NAME.NULL*/
		     isc_409.isc_418)
			PUT_TEXT (att_charset_funct, /*X.RDB$FUNCTION_NAME*/
						     isc_409.isc_410);
		put_numeric (att_charset_bytes_char, /*X.RDB$BYTES_PER_CHARACTER*/
						     isc_409.isc_417);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_check_constraints(void)
{
/**************************************
 *
 *	w r i t e _ c h e c k _ c o n s t r a i n t s 
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each check constraint. 
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$CHECK_CONSTRAINTS*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_402), (char *) isc_402);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 68, &isc_403, (short) 0);
	   if (!isc_403.isc_406 || isc_status [1]) break;
		put(tdgbl, rec_chk_constraint);
	
		PUT_TEXT (att_chk_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
						   isc_403.isc_405);
		if (!(/*X.RDB$TRIGGER_NAME.NULL*/
		      isc_403.isc_407))
			PUT_TEXT (att_chk_trigger_name, /*X.RDB$TRIGGER_NAME*/
							isc_403.isc_404);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}
	
	MISC_release_request_silent(req_handle1);
}


void write_collations(void)
{
/**************************************
 *
 *	w r i t e _ c o l l a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user defined collation
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->BCK_capabilities & BCK_ods11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_386), (char *) isc_386);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 130, &isc_387, (short) 0);
		   if (!isc_387.isc_393 || isc_status [1]) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 isc_387.isc_392);
			put_numeric (att_coll_id, /*X.RDB$COLLATION_ID*/
						  isc_387.isc_401);
			put_numeric (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						     isc_387.isc_400);
			put_numeric (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						    isc_387.isc_399);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_387.isc_398)
				put_numeric (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							       isc_387.isc_398);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_387.isc_397)
				put_source_blob (att_coll_description, att_coll_description, &/*X.RDB$DESCRIPTION*/
											      isc_387.isc_391);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     isc_387.isc_396)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  isc_387.isc_390);
			if (!/*X.RDB$BASE_COLLATION_NAME.NULL*/
			     isc_387.isc_395)
				PUT_TEXT(att_coll_base_collation_name, /*X.RDB$BASE_COLLATION_NAME*/
								       isc_387.isc_389);
			if (!/*X.RDB$SPECIFIC_ATTRIBUTES.NULL*/
			     isc_387.isc_394)
				put_source_blob (att_coll_specific_attr, att_coll_specific_attr, &/*X.RDB$SPECIFIC_ATTRIBUTES*/
												  isc_387.isc_388);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$COLLATIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_374), (char *) isc_374);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 86, &isc_375, (short) 0);
		   if (!isc_375.isc_379 || isc_status [1]) break;
			put(tdgbl, rec_collation);
			PUT_TEXT (att_coll_name, /*X.RDB$COLLATION_NAME*/
						 isc_375.isc_378);
			put_numeric (att_coll_id, /*X.RDB$COLLATION_ID*/
						  isc_375.isc_385);
			put_numeric (att_coll_cs_id, /*X.RDB$CHARACTER_SET_ID*/
						     isc_375.isc_384);
			put_numeric (att_coll_attr, /*X.RDB$COLLATION_ATTRIBUTES*/
						    isc_375.isc_383);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_375.isc_382)
				put_numeric (att_coll_sysflag, /*X.RDB$SYSTEM_FLAG*/
							       isc_375.isc_382);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_375.isc_381)
				put_source_blob (att_coll_description, att_coll_description, &/*X.RDB$DESCRIPTION*/
											      isc_375.isc_377);
			if (!/*X.RDB$FUNCTION_NAME.NULL*/
			     isc_375.isc_380)
				PUT_TEXT (att_coll_funct, /*X.RDB$FUNCTION_NAME*/
							  isc_375.isc_376);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}

void write_database( const TEXT* dbb_file)
{
/**************************************
 *
 *	w r i t e _ d a t a b a s e
 *
 **************************************
 *
 * Functional description
 * 	write a physical database record and a
 *	logical database record in the burp file for
 *	the database itself.  
 *
 **************************************/
	ISC_STATUS_ARRAY status_vector;
	SCHAR buffer[256];
	isc_req_handle req_handle1 = 0, req_handle2 = 0, req_handle3 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	put(tdgbl, (UCHAR) (rec_physical_db));

	if (isc_database_info(status_vector, &DB, sizeof(db_info_items),
						  db_info_items, sizeof(buffer), buffer))
	{
		BURP_error_redirect(status_vector, 31, NULL, NULL);
		// msg 31 isc_database_info failed 
	}

	USHORT page_size = 0, forced_writes, no_reserve,
		SQL_dialect, db_read_only;
 	ULONG sweep_interval, page_buffers;
 	USHORT length = 0;
	for (const SCHAR* d = buffer; *d != isc_info_end; d += length)
	{
		const SCHAR item = *d++;
		length = (USHORT) isc_vax_integer(d, 2);
		d += 2;
		switch (item)
		{
		case isc_info_end:
			break;

		case isc_info_page_size:
			page_size = (USHORT) isc_vax_integer(d, length);
			put_numeric(att_page_size, page_size);
			break;

		case isc_info_sweep_interval:
			sweep_interval = isc_vax_integer(d, length);
			put_numeric(att_sweep_interval, sweep_interval);
			break;

		case isc_info_forced_writes:
			forced_writes = (USHORT) isc_vax_integer(d, length);
			put_numeric(att_forced_writes, forced_writes);
			break;

		case isc_info_no_reserve:
			if (no_reserve = (USHORT) isc_vax_integer(d, length))
				put_numeric(att_no_reserve, no_reserve);
			break;

		case isc_info_set_page_buffers:
			if (page_buffers = isc_vax_integer(d, length))
				put_numeric(att_page_buffers, page_buffers);
			break;

		case isc_info_error:	// old server does not understand new isc_info 
			break;				// parameter and returns isc_info_error. skip it 

		case isc_info_db_sql_dialect:
			SQL_dialect = (USHORT) isc_vax_integer(d, length);
			put_numeric(att_SQL_dialect, SQL_dialect);
			break;

		case isc_info_db_read_only:
			if (db_read_only = (USHORT) isc_vax_integer(d, length))
				put_numeric(att_db_read_only, db_read_only);
			break;

		default:
			BURP_error_redirect(status_vector, 31, NULL, NULL);
			// msg 31 isc_database_info failed 
			break;
		}
	}

	put_asciz(att_file_name, dbb_file);

	BURP_verbose(77, dbb_file, (void *) (IPTR) page_size, NULL, NULL, NULL);
// msg 77 database %s has a page size of %ld bytes. 

	put(tdgbl, (UCHAR) (att_end));

	put(tdgbl, (UCHAR) (rec_database));

/* if we have all capabilities, use the first request to get the 
   most performance out of the latest engine; if we don't 
   have one of the capabilities we must use the second set of 
   requests--this requires more code but it is well worth it 
   for the performance benefits, especially remotely--deej */

	if ((tdgbl->BCK_capabilities & BCK_security) &&
		(tdgbl->BCK_capabilities & BCK_db_description) &&
		(tdgbl->BCK_capabilities & BCK_ods8))
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			D IN RDB$DATABASE*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_366), (char *) isc_366);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 78, &isc_367, (short) 0);
		   if (!isc_367.isc_371 || isc_status [1]) break;

			if (!/*D.RDB$SECURITY_CLASS.NULL*/
			     isc_367.isc_373)
				PUT_TEXT (att_database_security_class, /*D.RDB$SECURITY_CLASS*/
								       isc_367.isc_370);
			put_source_blob (att_database_description2, att_database_description,
				&/*D.RDB$DESCRIPTION*/
				 isc_367.isc_369);
			if (!/*D.RDB$CHARACTER_SET_NAME.NULL*/
			     isc_367.isc_372)
				PUT_TEXT (att_database_dfl_charset, /*D.RDB$CHARACTER_SET_NAME*/
								    isc_367.isc_368);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		if (tdgbl->BCK_capabilities & BCK_security)
		{
			/*FOR (REQUEST_HANDLE req_handle1)
				D IN RDB$DATABASE*/
			{
                        if (!req_handle1)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_361), (char *) isc_361);
			if (req_handle1)
                           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 36, &isc_362, (short) 0);
			   if (!isc_362.isc_364 || isc_status [1]) break;
				if (!/*D.RDB$SECURITY_CLASS.NULL*/
				     isc_362.isc_365)
					PUT_TEXT (att_database_security_class, /*D.RDB$SECURITY_CLASS*/
									       isc_362.isc_363);
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}

		if (tdgbl->BCK_capabilities & BCK_db_description)
		{
			/*FOR (REQUEST_HANDLE req_handle2)
				D IN RDB$DATABASE*/
			{
                        if (!req_handle2)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle2, (short) sizeof (isc_357), (char *) isc_357);
			if (req_handle2)
                           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle2, (short) 0, (short) 10, &isc_358, (short) 0);
			   if (!isc_358.isc_360 || isc_status [1]) break;
				put_source_blob (att_database_description2, att_database_description,
					&/*D.RDB$DESCRIPTION*/
					 isc_358.isc_359);
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}

		if (tdgbl->BCK_capabilities & BCK_ods8)
		{
			/*FOR (REQUEST_HANDLE req_handle3)
				D IN RDB$DATABASE*/
			{
                        if (!req_handle3)
                           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle3, (short) sizeof (isc_352), (char *) isc_352);
			if (req_handle3)
                           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle3, (FB_API_HANDLE*) &gds_trans, (short) 0);
			if (!isc_status [1]) {
			while (1)
			   {
                           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle3, (short) 0, (short) 36, &isc_353, (short) 0);
			   if (!isc_353.isc_355 || isc_status [1]) break;
				if (!/*D.RDB$CHARACTER_SET_NAME.NULL*/
				     isc_353.isc_356)
					PUT_TEXT (att_database_dfl_charset, /*D.RDB$CHARACTER_SET_NAME*/
									    isc_353.isc_354);
			/*END_FOR;*/
			   }
			   };
			/*ON_ERROR*/
			if (isc_status [1])
			   {
				general_on_error();
			/*END_ERROR;*/
			   }
			}
		}
	}

	MISC_release_request_silent(req_handle1);
	MISC_release_request_silent(req_handle2);
	MISC_release_request_silent(req_handle3);

	put(tdgbl, (UCHAR) (att_end));
}


void write_exceptions(void)
{
/**************************************
 *
 *	w r i t e _ e x c e p t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each exception.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$EXCEPTIONS
		WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_346), (char *) isc_346);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 1064, &isc_347, (short) 0);
	   if (!isc_347.isc_350 || isc_status [1]) break;
		put(tdgbl, rec_exception);
		const SSHORT l = PUT_TEXT (att_exception_name, /*X.RDB$EXCEPTION_NAME*/
							       isc_347.isc_349);
		MISC_terminate (/*X.RDB$EXCEPTION_NAME*/
				isc_347.isc_349, temp, l, sizeof(temp));
		BURP_verbose (198, temp, NULL, NULL, NULL, NULL);
		// msg 198 writing exception %s
		PUT_MESSAGE(att_exception_msg, /*X.RDB$MESSAGE*/
					       isc_347.isc_351);
		put_source_blob (att_exception_description2, att_procedure_description,
			&/*X.RDB$DESCRIPTION*/
			 isc_347.isc_348);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_field_dimensions(void)
{
/**************************************
 *
 *	w r i t e _ f i e l d _ d i m e n s i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each array field dimension.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FIELD_DIMENSIONS*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_339), (char *) isc_339);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 44, &isc_340, (short) 0);
	   if (!isc_340.isc_344 || isc_status [1]) break;
		put(tdgbl, rec_field_dimensions);
		PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
					  isc_340.isc_341);
		put_numeric (att_field_dimensions, /*X.RDB$DIMENSION*/
						   isc_340.isc_345);
		put_numeric (att_field_range_low, /*X.RDB$LOWER_BOUND*/
						  isc_340.isc_343);
		put_numeric (att_field_range_high, /*X.RDB$UPPER_BOUND*/
						   isc_340.isc_342);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
} 


void write_filters(void)
{
/**************************************
 *
 *	w r i t e _ f i l t e r s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each filter.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FILTERS
		WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_330), (char *) isc_330);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 332, &isc_331, (short) 0);
	   if (!isc_331.isc_335 || isc_status [1]) break;
		put(tdgbl, rec_filter);
		const SSHORT l = PUT_TEXT (att_filter_name, /*X.RDB$FUNCTION_NAME*/
							    isc_331.isc_334);
		MISC_terminate (/*X.RDB$FUNCTION_NAME*/
				isc_331.isc_334, temp, l, sizeof(temp));
		BURP_verbose (145, temp, NULL, NULL, NULL, NULL);
		// msg 145 writing filter %s
		put_source_blob (att_filter_description2, att_filter_description, &/*X.RDB$DESCRIPTION*/
										   isc_331.isc_333);
		PUT_TEXT (att_filter_module_name, /*X.RDB$MODULE_NAME*/
						  isc_331.isc_338);
		PUT_TEXT (att_filter_entrypoint, /*X.RDB$ENTRYPOINT*/
						 isc_331.isc_332);
		put_numeric (att_filter_input_sub_type, /*X.RDB$INPUT_SUB_TYPE*/
							isc_331.isc_337);
		put_numeric (att_filter_output_sub_type, /*X.RDB$OUTPUT_SUB_TYPE*/
							 isc_331.isc_336);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_functions(void)
{
/**************************************
 *                                                                   
 *	w r i t e _ f u n c t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each function.
 *
 **************************************/
	GDS_NAME func;
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FUNCTIONS WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_320), (char *) isc_320);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 364, &isc_321, (short) 0);
	   if (!isc_321.isc_326 || isc_status [1]) break;
		put(tdgbl, rec_function);
		const SSHORT l = PUT_TEXT (att_function_name, /*X.RDB$FUNCTION_NAME*/
							      isc_321.isc_325);
		MISC_terminate (/*X.RDB$FUNCTION_NAME*/
				isc_321.isc_325, temp, l, sizeof(temp));
		BURP_verbose (147, temp, NULL, NULL, NULL, NULL);
		/* msg 147 writing function %.*s */
		put_source_blob (att_function_description2, att_function_description, &/*X.RDB$DESCRIPTION*/
										       isc_321.isc_324);
		PUT_TEXT (att_function_module_name, /*X.RDB$MODULE_NAME*/
						    isc_321.isc_329);
		PUT_TEXT (att_function_entrypoint, /*X.RDB$ENTRYPOINT*/
						   isc_321.isc_323);
		put_numeric (att_function_return_arg, /*X.RDB$RETURN_ARGUMENT*/
						      isc_321.isc_328);
		put_numeric (att_function_type, /*X.RDB$FUNCTION_TYPE*/
						isc_321.isc_327);
		PUT_TEXT (att_function_query_name, /*X.RDB$QUERY_NAME*/
						   isc_321.isc_322);
		put(tdgbl, att_end);
		COPY (/*X.RDB$FUNCTION_NAME*/
		      isc_321.isc_325, func);
		write_function_args (func);
		put(tdgbl, rec_function_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
} 


void write_function_args( GDS_NAME funcptr)
{
/**************************************
 *
 *	w r i t e _ f u n c t i o n _ a r g s
 *
 **************************************
 *
 * Functional description
 * 	write all arguments for a function.
 *
 **************************************/ 
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/* if we have all capabilities, use the first request to get the 
	   most performance out of the latest engine; if we don't 
	   have one of the capabilities we must use the second set of 
	   requests--this requires more code but it is well worth it 
	   for the performance benefits, especially remotely--deej */

	if (tdgbl->BCK_capabilities & BCK_ods10)
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS WITH 
			X.RDB$FUNCTION_NAME EQ funcptr*/
		{
                if (!tdgbl->handles_write_function_args_req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) sizeof (isc_304), (char *) isc_304);
		isc_vtov ((char*)funcptr, (char*)isc_305.isc_306, 32);
		if (tdgbl->handles_write_function_args_req_handle1)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_305, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) 1, (short) 54, &isc_307, (short) 0);
		   if (!isc_307.isc_309 || isc_status [1]) break;

			put(tdgbl, rec_function_arg);
			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 isc_307.isc_308);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_307.isc_308, temp, l, sizeof(temp));
			BURP_verbose (141, temp, NULL, NULL, NULL, NULL);
			// msg 141 writing argument for function %s 
			put_numeric (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							       isc_307.isc_319);
			put_numeric (att_functionarg_mechanism, /*X.RDB$MECHANISM*/
								isc_307.isc_318);
			put_numeric (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
								 isc_307.isc_317);
			put_numeric (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								  isc_307.isc_316);
			put_numeric (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								   isc_307.isc_315);
			put_numeric (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								     isc_307.isc_314);
			if (!(/*X.RDB$CHARACTER_SET_ID.NULL*/
			      isc_307.isc_312))
				put_numeric (att_functionarg_character_set, /*X.RDB$CHARACTER_SET_ID*/
									    isc_307.isc_313);
			
			if (!(/*X.RDB$FIELD_PRECISION.NULL*/
			      isc_307.isc_310))
				put_numeric (att_functionarg_field_precision, /*X.RDB$FIELD_PRECISION*/
									      isc_307.isc_311);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle1)
			X IN RDB$FUNCTION_ARGUMENTS WITH 
			X.RDB$FUNCTION_NAME EQ funcptr*/
		{
                if (!tdgbl->handles_write_function_args_req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) sizeof (isc_292), (char *) isc_292);
		isc_vtov ((char*)funcptr, (char*)isc_293.isc_294, 32);
		if (tdgbl->handles_write_function_args_req_handle1)
                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_293, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle1, (short) 1, (short) 46, &isc_295, (short) 0);
		   if (!isc_295.isc_297 || isc_status [1]) break;

			put(tdgbl, rec_function_arg);
			const SSHORT l = PUT_TEXT (att_functionarg_name, /*X.RDB$FUNCTION_NAME*/
									 isc_295.isc_296);
			MISC_terminate (/*X.RDB$FUNCTION_NAME*/
					isc_295.isc_296, temp, l, sizeof(temp));
			BURP_verbose (141, temp, NULL, NULL, NULL, NULL);
			// msg 141 writing argument for function %s 
			put_numeric (att_functionarg_position, /*X.RDB$ARGUMENT_POSITION*/
							       isc_295.isc_303);
			put_numeric (att_functionarg_mechanism, /*X.RDB$MECHANISM*/
								isc_295.isc_302);
			put_numeric (att_functionarg_field_type, /*X.RDB$FIELD_TYPE*/
								 isc_295.isc_301);
			put_numeric (att_functionarg_field_scale, /*X.RDB$FIELD_SCALE*/
								  isc_295.isc_300);
			put_numeric (att_functionarg_field_length, /*X.RDB$FIELD_LENGTH*/
								   isc_295.isc_299);
			put_numeric (att_functionarg_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
								     isc_295.isc_298);
		
			if (tdgbl->BCK_capabilities & BCK_ods8)
			{
				/*FOR (REQUEST_HANDLE tdgbl->handles_write_function_args_req_handle2)
					X2 IN RDB$FUNCTION_ARGUMENTS WITH 
					X2.RDB$FUNCTION_NAME EQ funcptr AND 
					X2.RDB$ARGUMENT_POSITION = X.RDB$ARGUMENT_POSITION*/
				{
                                if (!tdgbl->handles_write_function_args_req_handle2)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle2, (short) sizeof (isc_284), (char *) isc_284);
				isc_vtov ((char*)funcptr, (char*)isc_285.isc_286, 32);
				isc_285.isc_287 = isc_295.isc_303;
				if (tdgbl->handles_write_function_args_req_handle2)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 34, &isc_285, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_function_args_req_handle2, (short) 1, (short) 6, &isc_288, (short) 0);
				   if (!isc_288.isc_289 || isc_status [1]) break;;

					if (!(/*X2.RDB$CHARACTER_SET_ID.NULL*/
					      isc_288.isc_290))
						put_numeric (att_functionarg_character_set, /*X2.RDB$CHARACTER_SET_ID*/
											    isc_288.isc_291);
				/* Note that BCK_ods10 canNOT be set if we're in this
				   "else" branch.  Hence there is no need to test that
				   bit and store the RDB$FIELD_PRECISION. */

				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
}


void write_generators(void)
{
/**************************************
 *
 *	w r i t e _ g e n e r a t o r s
 *
 **************************************
 *
 * Functional description
 *	Write any defined generators.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->BCK_capabilities & BCK_ods11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_278), (char *) isc_278);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 44, &isc_279, (short) 0);
		   if (!isc_279.isc_282 || isc_status [1]) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      isc_279.isc_281);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta) {
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    isc_279.isc_281, l);
				put_int64 (att_gen_value_int64, value);
			}
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_279.isc_283) {
				put_source_blob (att_gen_description, att_gen_description,
								 &/*X.RDB$DESCRIPTION*/
								  isc_279.isc_280);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					isc_279.isc_281, temp, l, sizeof(temp));
#pragma FB_COMPILER_MESSAGE("BRS: casting SINT64 to SLONG")
			BURP_verbose (165, temp, (void*) (IPTR) value, NULL, NULL, NULL);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$GENERATORS
			WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_274), (char *) isc_274);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 34, &isc_275, (short) 0);
		   if (!isc_275.isc_277 || isc_status [1]) break;
			put(tdgbl, rec_generator);
			const SSHORT l = PUT_TEXT (att_gen_generator, /*X.RDB$GENERATOR_NAME*/
								      isc_275.isc_276);
			SINT64 value = 0;
			if (!tdgbl->gbl_sw_meta) {
				value = get_gen_id (/*X.RDB$GENERATOR_NAME*/
						    isc_275.isc_276, l);
				put_int64 (att_gen_value_int64, value);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$GENERATOR_NAME*/
					isc_275.isc_276, temp, l, sizeof(temp));
#pragma FB_COMPILER_MESSAGE("BRS: casting SINT64 to SLONG")
			BURP_verbose (165, temp, (void*) (IPTR) value, NULL, NULL, NULL);
			// msg 165 writing generator %s value %ld
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
} 


void write_global_fields(void)
{
/**************************************
 *
 *	w r i t e _ g l o b a l _ f i e l d s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each global field. 
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0, req_handle2 = 0,
		req_handle3 = 0, req_handle4 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/* if we have all capabilities, use the first request to get the 
	   most performance out of the latest engine; if we don't 
	   have one of the capabilities we must use the second set of 
	   requests--this requires more code but it is well worth it 
	   for the performance benefits, especially remotely--deej */

	if ((tdgbl->BCK_capabilities & BCK_attributes_v3) &&
		(tdgbl->BCK_capabilities & BCK_ods8) &&
		(tdgbl->BCK_capabilities & BCK_ods10))
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH 
			X.RDB$SYSTEM_FLAG NE 1 OR 
			X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_236), (char *) isc_236);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 316, &isc_237, (short) 0);
		   if (!isc_237.isc_250 || isc_status [1]) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   isc_237.isc_249);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					isc_237.isc_249, temp, l, sizeof(temp));
			BURP_verbose (149, temp, NULL, NULL, NULL, NULL);
			/* msg 149  writing global field %.*s */
			if (/*X.RDB$QUERY_NAME*/
			    isc_237.isc_248 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								isc_237.isc_248);
			if (/*X.RDB$EDIT_STRING*/
			    isc_237.isc_273 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 isc_237.isc_273);
			put_source_blob (att_field_query_header, att_field_query_header, &/*X.RDB$QUERY_HEADER*/
											  isc_237.isc_247);
			put_numeric (att_field_type, /*X.RDB$FIELD_TYPE*/
						     isc_237.isc_272);
			put_numeric (att_field_length, /*X.RDB$FIELD_LENGTH*/
						       isc_237.isc_271);
			put_numeric (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
							 isc_237.isc_270);
			put_numeric (att_field_scale, /*X.RDB$FIELD_SCALE*/
						      isc_237.isc_269);
			put_blr_blob (att_field_missing_value, &/*X.RDB$MISSING_VALUE*/
								isc_237.isc_246);
			put_blr_blob (att_field_default_value, &/*X.RDB$DEFAULT_VALUE*/
								isc_237.isc_245);
			put_blr_blob (att_field_validation_blr, &/*X.RDB$VALIDATION_BLR*/
								 isc_237.isc_244);
			put_source_blob (att_field_validation_source2, att_field_validation_source,
				&/*X.RDB$VALIDATION_SOURCE*/
				 isc_237.isc_243);
			put_blr_blob (att_field_computed_blr, &/*X.RDB$COMPUTED_BLR*/
							       isc_237.isc_242);
			put_source_blob (att_field_computed_source2, att_field_computed_source,
				&/*X.RDB$COMPUTED_SOURCE*/
				 isc_237.isc_241);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    isc_237.isc_268)
				put_numeric (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								       isc_237.isc_268);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_237.isc_267)
				put_numeric (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								    isc_237.isc_267);
			put_source_blob (att_field_description2, att_field_description, &/*X.RDB$DESCRIPTION*/
											 isc_237.isc_240);
			
			if (/*X.RDB$EXTERNAL_LENGTH*/
			    isc_237.isc_266)
				put_numeric (att_field_external_length, /*X.RDB$EXTERNAL_LENGTH*/
									isc_237.isc_266);
			if (/*X.RDB$EXTERNAL_TYPE*/
			    isc_237.isc_265) 
				put_numeric (att_field_external_type, /*X.RDB$EXTERNAL_TYPE*/
								      isc_237.isc_265);
			if (/*X.RDB$EXTERNAL_SCALE*/
			    isc_237.isc_264)
				put_numeric (att_field_external_scale, /*X.RDB$EXTERNAL_SCALE*/
								       isc_237.isc_264);
			if (/*X.RDB$DIMENSIONS*/
			    isc_237.isc_263)
				put_numeric (att_field_dimensions, /*X.RDB$DIMENSIONS*/
								   isc_237.isc_263);
			if (!(/*X.RDB$NULL_FLAG.NULL*/
			      isc_237.isc_261))
				put_numeric (att_field_null_flag, /*X.RDB$NULL_FLAG*/
								  isc_237.isc_262);
			if (!(/*X.RDB$CHARACTER_LENGTH.NULL*/
			      isc_237.isc_259))
				put_numeric (att_field_character_length, /*X.RDB$CHARACTER_LENGTH*/
									 isc_237.isc_260);
			if (!(/*X.RDB$DEFAULT_SOURCE.NULL*/
			      isc_237.isc_258))
				put_source_blob (att_field_default_source, att_field_default_source,
					&/*X.RDB$DEFAULT_SOURCE*/
					 isc_237.isc_239);
			if (!(/*X.RDB$MISSING_SOURCE.NULL*/
			      isc_237.isc_257))
				put_source_blob (att_field_missing_source, att_field_missing_source,
					&/*X.RDB$MISSING_SOURCE*/
					 isc_237.isc_238);
			if (!(/*X.RDB$CHARACTER_SET_ID.NULL*/
			      isc_237.isc_255))
				put_numeric (att_field_character_set, /*X.RDB$CHARACTER_SET_ID*/
								      isc_237.isc_256);
			if (!(/*X.RDB$COLLATION_ID.NULL*/
			      isc_237.isc_253))
				put_numeric (att_field_collation_id, /*X.RDB$COLLATION_ID*/
								     isc_237.isc_254);
			
			if (!(/*X.RDB$FIELD_PRECISION.NULL*/
			      isc_237.isc_251))
				put_numeric (att_field_precision, /*X.RDB$FIELD_PRECISION*/
								  isc_237.isc_252);
			
			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$FIELDS WITH 
			X.RDB$SYSTEM_FLAG NE 1 OR 
			X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_216), (char *) isc_216);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 268, &isc_217, (short) 0);
		   if (!isc_217.isc_228 || isc_status [1]) break;

			put(tdgbl, rec_global_field);
			const SSHORT l = PUT_TEXT (att_field_name, /*X.RDB$FIELD_NAME*/
								   isc_217.isc_227);
			MISC_terminate (/*X.RDB$FIELD_NAME*/
					isc_217.isc_227, temp, l, sizeof(temp));
			BURP_verbose (149, temp, NULL, NULL, NULL, NULL);
			/* msg 149  writing global field %.*s */
			if (/*X.RDB$QUERY_NAME*/
			    isc_217.isc_226 [0] != ' ')
				PUT_TEXT (att_field_query_name, /*X.RDB$QUERY_NAME*/
								isc_217.isc_226);
			if (/*X.RDB$EDIT_STRING*/
			    isc_217.isc_235 [0] != ' ')
				PUT_TEXT (att_field_edit_string, /*X.RDB$EDIT_STRING*/
								 isc_217.isc_235);
			put_source_blob (att_field_query_header, att_field_query_header, &/*X.RDB$QUERY_HEADER*/
											  isc_217.isc_225);
			put_numeric (att_field_type, /*X.RDB$FIELD_TYPE*/
						     isc_217.isc_234);
			put_numeric (att_field_length, /*X.RDB$FIELD_LENGTH*/
						       isc_217.isc_233);
			put_numeric (att_field_sub_type, /*X.RDB$FIELD_SUB_TYPE*/
							 isc_217.isc_232);
			put_numeric (att_field_scale, /*X.RDB$FIELD_SCALE*/
						      isc_217.isc_231);
			put_blr_blob (att_field_missing_value, &/*X.RDB$MISSING_VALUE*/
								isc_217.isc_224);
			put_blr_blob (att_field_default_value, &/*X.RDB$DEFAULT_VALUE*/
								isc_217.isc_223);
			put_blr_blob (att_field_validation_blr, &/*X.RDB$VALIDATION_BLR*/
								 isc_217.isc_222);
			put_source_blob (att_field_validation_source2, att_field_validation_source,
				&/*X.RDB$VALIDATION_SOURCE*/
				 isc_217.isc_221);
			put_blr_blob (att_field_computed_blr, &/*X.RDB$COMPUTED_BLR*/
							       isc_217.isc_220);
			put_source_blob (att_field_computed_source2, att_field_computed_source,
				&/*X.RDB$COMPUTED_SOURCE*/
				 isc_217.isc_219);
			if (/*X.RDB$SEGMENT_LENGTH*/
			    isc_217.isc_230)
				put_numeric (att_field_segment_length, /*X.RDB$SEGMENT_LENGTH*/
								       isc_217.isc_230);
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_217.isc_229)
				put_numeric (att_field_system_flag, /*X.RDB$SYSTEM_FLAG*/
								    isc_217.isc_229);
			put_source_blob (att_field_description2, att_field_description,
				&/*X.RDB$DESCRIPTION*/
				 isc_217.isc_218);
			if (tdgbl->BCK_capabilities & BCK_attributes_v3)
			{
				/*FOR (REQUEST_HANDLE req_handle2)
					F IN RDB$FIELDS WITH F.RDB$FIELD_NAME = X.RDB$FIELD_NAME*/
				{
                                if (!req_handle2)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle2, (short) sizeof (isc_207), (char *) isc_207);
				isc_vtov ((char*)isc_217.isc_227, (char*)isc_208.isc_209, 32);
				if (req_handle2)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_208, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle2, (short) 1, (short) 10, &isc_210, (short) 0);
				   if (!isc_210.isc_211 || isc_status [1]) break;
					
					if (/*F.RDB$EXTERNAL_LENGTH*/
					    isc_210.isc_215)
						put_numeric (att_field_external_length, /*F.RDB$EXTERNAL_LENGTH*/
											isc_210.isc_215);
					if (/*F.RDB$EXTERNAL_TYPE*/
					    isc_210.isc_214) 
						put_numeric (att_field_external_type, /*F.RDB$EXTERNAL_TYPE*/
										      isc_210.isc_214);
					if (/*F.RDB$EXTERNAL_SCALE*/
					    isc_210.isc_213)
						put_numeric (att_field_external_scale, /*F.RDB$EXTERNAL_SCALE*/
										       isc_210.isc_213);
					if (/*F.RDB$DIMENSIONS*/
					    isc_210.isc_212)
						put_numeric (att_field_dimensions, /*F.RDB$DIMENSIONS*/
										   isc_210.isc_212);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			if (tdgbl->BCK_capabilities & BCK_ods8)
			{
				/*FOR (REQUEST_HANDLE req_handle3)
					F IN RDB$FIELDS WITH F.RDB$FIELD_NAME = X.RDB$FIELD_NAME*/
				{
                                if (!req_handle3)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle3, (short) sizeof (isc_190), (char *) isc_190);
				isc_vtov ((char*)isc_217.isc_227, (char*)isc_191.isc_192, 32);
				if (req_handle3)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle3, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_191, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle3, (short) 1, (short) 38, &isc_193, (short) 0);
				   if (!isc_193.isc_196 || isc_status [1]) break;
					if (!(/*F.RDB$NULL_FLAG.NULL*/
					      isc_193.isc_205))
						put_numeric (att_field_null_flag, /*F.RDB$NULL_FLAG*/
										  isc_193.isc_206);
					if (!(/*F.RDB$CHARACTER_LENGTH.NULL*/
					      isc_193.isc_203))
						put_numeric (att_field_character_length, /*F.RDB$CHARACTER_LENGTH*/
											 isc_193.isc_204);
					if (!(/*F.RDB$DEFAULT_SOURCE.NULL*/
					      isc_193.isc_202))
						put_source_blob (att_field_default_source, att_field_default_source,
							&/*F.RDB$DEFAULT_SOURCE*/
							 isc_193.isc_195);
					if (!(/*F.RDB$MISSING_SOURCE.NULL*/
					      isc_193.isc_201))
						put_source_blob (att_field_missing_source, att_field_missing_source,
							&/*F.RDB$MISSING_SOURCE*/
							 isc_193.isc_194);
					if (!(/*F.RDB$CHARACTER_SET_ID.NULL*/
					      isc_193.isc_199))
						put_numeric (att_field_character_set, /*F.RDB$CHARACTER_SET_ID*/
										      isc_193.isc_200);
					if (!(/*F.RDB$COLLATION_ID.NULL*/
					      isc_193.isc_197))
						put_numeric (att_field_collation_id, /*F.RDB$COLLATION_ID*/
										     isc_193.isc_198);

					if (tdgbl->BCK_capabilities & BCK_ods10)
					{
						/*FOR (REQUEST_HANDLE req_handle4)
							K IN RDB$FIELDS WITH K.RDB$FIELD_NAME = X.RDB$FIELD_NAME*/
						{
                                                if (!req_handle4)
                                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle4, (short) sizeof (isc_183), (char *) isc_183);
						isc_vtov ((char*)isc_217.isc_227, (char*)isc_184.isc_185, 32);
						if (req_handle4)
                                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle4, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_184, (short) 0);
						if (!isc_status [1]) {
						while (1)
						   {
                                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle4, (short) 1, (short) 6, &isc_186, (short) 0);
						   if (!isc_186.isc_187 || isc_status [1]) break;
							if (!(/*K.RDB$FIELD_PRECISION.NULL*/
							      isc_186.isc_188))
								put_numeric (att_field_precision, /*K.RDB$FIELD_PRECISION*/
												  isc_186.isc_189);
						/*END_FOR;*/
						   }
						   };
						/*ON_ERROR*/
						if (isc_status [1])
						   {
							general_on_error();
						/*END_ERROR;*/
						   }
						}
					}
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
	MISC_release_request_silent(req_handle2);
	MISC_release_request_silent(req_handle3);
	MISC_release_request_silent(req_handle4);
}


void write_procedures(void)
{
/**************************************
 *                                                                   
 *	w r i t e _ p r o c e d u r e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each stored procedure.
 *
 **************************************/
	GDS_NAME proc;
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$PROCEDURES
		WITH X.RDB$SYSTEM_FLAG MISSING OR X.RDB$SYSTEM_FLAG NE 1*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_171), (char *) isc_171);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 128, &isc_172, (short) 0);
	   if (!isc_172.isc_179 || isc_status [1]) break;
		put(tdgbl, rec_procedure);
		const SSHORT l = PUT_TEXT (att_procedure_name, /*X.RDB$PROCEDURE_NAME*/
							       isc_172.isc_178);
		MISC_terminate (/*X.RDB$PROCEDURE_NAME*/
				isc_172.isc_178, temp, l, sizeof(temp));
		BURP_verbose (193, temp, NULL, NULL, NULL, NULL);
		/* msg 193 writing stored procedure %.*s */
		put_numeric (att_procedure_inputs, /*X.RDB$PROCEDURE_INPUTS*/
						   isc_172.isc_182);
		put_numeric (att_procedure_outputs, /*X.RDB$PROCEDURE_OUTPUTS*/
						    isc_172.isc_181);
		put_source_blob (att_procedure_description2, att_procedure_description,
			&/*X.RDB$DESCRIPTION*/
			 isc_172.isc_177);
		put_source_blob (att_procedure_source2, att_procedure_source, &/*X.RDB$PROCEDURE_SOURCE*/
									       isc_172.isc_176);
		put_blr_blob (att_procedure_blr, &/*X.RDB$PROCEDURE_BLR*/
						  isc_172.isc_175);
		if (!/*X.RDB$SECURITY_CLASS.NULL*/
		     isc_172.isc_180)
			PUT_TEXT (att_procedure_security_class, /*X.RDB$SECURITY_CLASS*/
								isc_172.isc_174);
		if (!/*X.RDB$SECURITY_CLASS.NULL*/
		     isc_172.isc_180)
			PUT_TEXT (att_procedure_owner_name, /*X.RDB$OWNER_NAME*/
							    isc_172.isc_173);
		put(tdgbl, att_end);
		COPY(/*X.RDB$PROCEDURE_NAME*/
		     isc_172.isc_178, proc);
		write_procedure_prms (proc);
		put(tdgbl, rec_procedure_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
} 


void write_procedure_prms( GDS_NAME procptr)
{
/**************************************
 *
 *	w r i t e _ p r o c e d u r e _ p r m s
 *
 **************************************
 *
 * Functional description
 * 	write all parameters of a stored procedure.
 *
 **************************************/ 
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE tdgbl->handles_write_procedure_prms_req_handle1)
		X IN RDB$PROCEDURE_PARAMETERS WITH X.RDB$PROCEDURE_NAME EQ procptr*/
	{
        if (!tdgbl->handles_write_procedure_prms_req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (short) sizeof (isc_161), (char *) isc_161);
	isc_vtov ((char*)procptr, (char*)isc_162.isc_163, 32);
	if (tdgbl->handles_write_procedure_prms_req_handle1)
           isc_start_and_send (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_162, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &tdgbl->handles_write_procedure_prms_req_handle1, (short) 1, (short) 78, &isc_164, (short) 0);
	   if (!isc_164.isc_168 || isc_status [1]) break;
		put(tdgbl, rec_procedure_prm);
		const SSHORT l = PUT_TEXT (att_procedureprm_name, /*X.RDB$PARAMETER_NAME*/
								  isc_164.isc_167);
		MISC_terminate (/*X.RDB$PARAMETER_NAME*/
				isc_164.isc_167, temp, l, sizeof(temp));
		BURP_verbose (194, temp, NULL, NULL, NULL, NULL);
		// msg 194 writing parameter %s for stored procedure 
		put_numeric (att_procedureprm_number, /*X.RDB$PARAMETER_NUMBER*/
						      isc_164.isc_170);
		put_numeric (att_procedureprm_type, /*X.RDB$PARAMETER_type*/
						    isc_164.isc_169);
		PUT_TEXT (att_procedureprm_field_source, /*X.RDB$FIELD_SOURCE*/
							 isc_164.isc_166);
		put_source_blob (att_procedureprm_description2, att_procedureprm_description,
			&/*X.RDB$DESCRIPTION*/
			 isc_164.isc_165);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}
}


void write_ref_constraints(void)
{
/**************************************
 *
 *	w r i t e _ r e f _ c o n s t r a i n t s 
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each referential constraint. 
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$REF_CONSTRAINTS*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_153), (char *) isc_153);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 98, &isc_154, (short) 0);
	   if (!isc_154.isc_160 || isc_status [1]) break;
		put(tdgbl, rec_ref_constraint);
		PUT_TEXT (att_ref_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
						   isc_154.isc_157);
		PUT_TEXT (att_ref_unique_const_name, /*X.RDB$CONST_NAME_UQ*/
						     isc_154.isc_156);
		PUT_TEXT (att_ref_match_option, /*X.RDB$MATCH_OPTION*/
						isc_154.isc_155);
		PUT_MESSAGE (att_ref_update_rule, /*X.RDB$UPDATE_RULE*/
						  isc_154.isc_159);
		PUT_MESSAGE (att_ref_delete_rule, /*X.RDB$DELETE_RULE*/
						  isc_154.isc_158);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}

void write_rel_constraints(void)
{
/**************************************
 *
 *	w r i t e _ r e l _ c o n s t r a i n t s 
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each relation constraint. 
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$RELATION_CONSTRAINTS*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_143), (char *) isc_143);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 120, &isc_144, (short) 0);
	   if (!isc_144.isc_151 || isc_status [1]) break;
		put(tdgbl, rec_rel_constraint);
		const SSHORT l = PUT_TEXT (att_rel_constraint_name, /*X.RDB$CONSTRAINT_NAME*/
								    isc_144.isc_147);
		MISC_terminate (/*X.RDB$CONSTRAINT_NAME*/
				isc_144.isc_147, temp, l, sizeof(temp));
		BURP_verbose (207, temp, NULL, NULL, NULL, NULL);
		// msg 207 writing constraint %s 
		PUT_MESSAGE (att_rel_constraint_type, /*X.RDB$CONSTRAINT_TYPE*/
						      isc_144.isc_150);
		PUT_TEXT (att_rel_constraint_rel_name, /*X.RDB$RELATION_NAME*/
						       isc_144.isc_146);
		PUT_TEXT (att_rel_constraint_defer, /*X.RDB$DEFERRABLE*/
						    isc_144.isc_149);
		PUT_TEXT (att_rel_constraint_init, /*X.RDB$INITIALLY_DEFERRED*/
						   isc_144.isc_148);
		if (!(/*X.RDB$INDEX_NAME.NULL*/
		      isc_144.isc_152))
			PUT_TEXT (att_rel_constraint_index, /*X.RDB$INDEX_NAME*/
							    isc_144.isc_145);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}

void write_relations(void)
{
/**************************************
 *
 *	w r i t e _ r e l a t i o n s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each relation. 
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0, req_handle2 = 0, req_handle3 = 0, req_handle4 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/* if we have all capabilities, use the first request to get the 
	most performance out of the latest engine; if we don't 
	have one of the capabilities we must use the second set of 
	requests--this requires more code but it is well worth it 
	for the performance benefits, especially remotely--deej */

	if ((tdgbl->BCK_capabilities & BCK_ods8) &&
		(tdgbl->BCK_capabilities & BCK_security) &&
		(tdgbl->BCK_capabilities & BCK_attributes_v3))
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$RELATIONS WITH X.RDB$SYSTEM_FLAG NE 1 OR 
			X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_126), (char *) isc_126);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 396, &isc_127, (short) 0);
		   if (!isc_127.isc_135 || isc_status [1]) break;

			SSHORT flags = 0;
			put(tdgbl, rec_relation);
			const SSHORT l = PUT_TEXT (att_relation_name, /*X.RDB$RELATION_NAME*/
								      isc_127.isc_134);
			MISC_terminate (/*X.RDB$RELATION_NAME*/
					isc_127.isc_134, temp, l, sizeof(temp));
			BURP_verbose (153, temp, NULL, NULL, NULL, NULL);
		/* msg 153 writing relation %.*s */

		/* RDB$VIEW_BLR must be the first blob field in the backup file.
			 * RESTORE.EPP makes this assumption in get_relation().
			 */

			if (put_blr_blob (att_relation_view_blr, &/*X.RDB$VIEW_BLR*/
								  isc_127.isc_133))
				flags |= REL_view;
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_127.isc_142)
				put_numeric (att_relation_system_flag, /*X.RDB$SYSTEM_FLAG*/
								       isc_127.isc_142);
			if (!(/*X.RDB$FLAGS.NULL*/
			      isc_127.isc_140))
				put_numeric (att_relation_flags, /*X.RDB$FLAGS*/
								 isc_127.isc_141);
			if (!/*X.RDB$SECURITY_CLASS.NULL*/
			     isc_127.isc_139)
				PUT_TEXT (att_relation_security_class, /*X.RDB$SECURITY_CLASS*/
								       isc_127.isc_132);
			
			put_source_blob (att_relation_description2, att_relation_description,
				&/*X.RDB$DESCRIPTION*/
				 isc_127.isc_131);
			put_source_blob (att_relation_view_source2, att_relation_view_source,
				&/*X.RDB$VIEW_SOURCE*/
				 isc_127.isc_130);
			
			put_source_blob (att_relation_ext_description2, att_relation_ext_description,
				&/*X.RDB$EXTERNAL_DESCRIPTION*/
				 isc_127.isc_129);
			PUT_TEXT (att_relation_owner_name, /*X.RDB$OWNER_NAME*/
							   isc_127.isc_128);
			if (!/*X.RDB$EXTERNAL_FILE.NULL*/
			     isc_127.isc_137)
				if (!tdgbl->gbl_sw_convert_ext_tables)
				{
					PUT_TEXT(att_relation_ext_file_name, /*X.RDB$EXTERNAL_FILE*/
									     isc_127.isc_138); 
					flags |= REL_external;
				}

			put(tdgbl, att_end);
			burp_rel* relation = (burp_rel*) BURP_alloc_zero (sizeof(burp_rel));
			relation->rel_next = tdgbl->relations;
			tdgbl->relations = relation;
			relation->rel_id = /*X.RDB$RELATION_ID*/
					   isc_127.isc_136;
			relation->rel_name_length = COPY(/*X.RDB$RELATION_NAME*/
							 isc_127.isc_134, relation->rel_name);
			relation->rel_flags |= flags;
			put_relation (relation);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$RELATIONS WITH X.RDB$SYSTEM_FLAG NE 1 OR 
			X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_117), (char *) isc_117);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 62, &isc_118, (short) 0);
		   if (!isc_118.isc_123 || isc_status [1]) break;

			SSHORT flags = 0;
			put(tdgbl, rec_relation);
			const SSHORT l = PUT_TEXT(att_relation_name, /*X.RDB$RELATION_NAME*/
								     isc_118.isc_122);
			MISC_terminate (/*X.RDB$RELATION_NAME*/
					isc_118.isc_122, temp, l, sizeof(temp));
			BURP_verbose (153, temp, NULL, NULL, NULL, NULL);
			/* msg 153 writing relation %.*s */
			
			/* RDB$VIEW_BLR must be the first blob field in the backup file.
			 * RESTORE.E makes this assumption in get_relation().
			 */

			if (put_blr_blob (att_relation_view_blr, &/*X.RDB$VIEW_BLR*/
								  isc_118.isc_121))
				flags |= REL_view;
			if (/*X.RDB$SYSTEM_FLAG*/
			    isc_118.isc_125)
				put_numeric (att_relation_system_flag, /*X.RDB$SYSTEM_FLAG*/
								       isc_118.isc_125);
			if (tdgbl->BCK_capabilities & BCK_ods8)
			{
				/*FOR (REQUEST_HANDLE req_handle2)
					R IN RDB$RELATIONS WITH R.RDB$RELATION_NAME = X.RDB$RELATION_NAME*/
				{
                                if (!req_handle2)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle2, (short) sizeof (isc_110), (char *) isc_110);
				isc_vtov ((char*)isc_118.isc_122, (char*)isc_111.isc_112, 32);
				if (req_handle2)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_111, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle2, (short) 1, (short) 6, &isc_113, (short) 0);
				   if (!isc_113.isc_114 || isc_status [1]) break;
					if (!(/*R.RDB$FLAGS.NULL*/
					      isc_113.isc_115))
						put_numeric (att_relation_flags, /*R.RDB$FLAGS*/
										 isc_113.isc_116);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			if (tdgbl->BCK_capabilities & BCK_security)
			{
				/*FOR (REQUEST_HANDLE req_handle3)
					R IN RDB$RELATIONS WITH R.RDB$RELATION_NAME = X.RDB$RELATION_NAME*/
				{
                                if (!req_handle3)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle3, (short) sizeof (isc_103), (char *) isc_103);
				isc_vtov ((char*)isc_118.isc_122, (char*)isc_104.isc_105, 32);
				if (req_handle3)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle3, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_104, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle3, (short) 1, (short) 36, &isc_106, (short) 0);
				   if (!isc_106.isc_108 || isc_status [1]) break;
					if (!/*R.RDB$SECURITY_CLASS.NULL*/
					     isc_106.isc_109)
						PUT_TEXT(att_relation_security_class, /*R.RDB$SECURITY_CLASS*/
										      isc_106.isc_107);
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			put_source_blob (att_relation_description2, att_relation_description,
				&/*X.RDB$DESCRIPTION*/
				 isc_118.isc_120);
			put_source_blob (att_relation_view_source2, att_relation_view_source,
				&/*X.RDB$VIEW_SOURCE*/
				 isc_118.isc_119);
			if (tdgbl->BCK_capabilities & BCK_attributes_v3)
			{
				/*FOR (REQUEST_HANDLE req_handle4)
					R IN RDB$RELATIONS WITH R.RDB$RELATION_NAME = X.RDB$RELATION_NAME*/
				{
                                if (!req_handle4)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle4, (short) sizeof (isc_94), (char *) isc_94);
				isc_vtov ((char*)isc_118.isc_122, (char*)isc_95.isc_96, 32);
				if (req_handle4)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle4, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_95, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle4, (short) 1, (short) 298, &isc_97, (short) 0);
				   if (!isc_97.isc_100 || isc_status [1]) break;
					put_source_blob (att_relation_ext_description2, att_relation_ext_description,
						&/*R.RDB$EXTERNAL_DESCRIPTION*/
						 isc_97.isc_99);
					PUT_TEXT(att_relation_owner_name, /*R.RDB$OWNER_NAME*/
									  isc_97.isc_98);
					if (!/*R.RDB$EXTERNAL_FILE.NULL*/
					     isc_97.isc_101)
					{
						if (!tdgbl->gbl_sw_convert_ext_tables)
						{
							PUT_TEXT(att_relation_ext_file_name, /*R.RDB$EXTERNAL_FILE*/
											     isc_97.isc_102); 
							flags |= REL_external;
						}
					}
				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}
			put(tdgbl, att_end);
			burp_rel* relation = (burp_rel*) BURP_alloc_zero (sizeof(burp_rel));
			relation->rel_next = tdgbl->relations;
			tdgbl->relations = relation;
			relation->rel_id = /*X.RDB$RELATION_ID*/
					   isc_118.isc_124;
			relation->rel_name_length = COPY(/*X.RDB$RELATION_NAME*/
							 isc_118.isc_122, relation->rel_name);
			relation->rel_flags |= flags;
			put_relation (relation);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
	MISC_release_request_silent(req_handle2);
	MISC_release_request_silent(req_handle3);
	MISC_release_request_silent(req_handle4);
}


void write_shadow_files(void)
{
/**************************************
 *
 *	w r i t e _ s h a d o w _ f i l e s
 *
 **************************************
 *
 * Functional description
 *	Write out files to use as shadows.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$FILES 
		WITH X.RDB$SHADOW_NUMBER NOT MISSING
		AND X.RDB$SHADOW_NUMBER NE 0*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_85), (char *) isc_85);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 270, &isc_86, (short) 0);
	   if (!isc_86.isc_89 || isc_status [1]) break;
		put(tdgbl, rec_files);
		const SSHORT l = PUT_TEXT (att_file_filename, /*X.RDB$FILE_NAME*/
							      isc_86.isc_93);
		MISC_terminate (/*X.RDB$FILE_NAME*/
				isc_86.isc_93, temp, l, sizeof(temp));
		BURP_verbose (163, temp, NULL, NULL, NULL, NULL);
		// msg 163 writing shadow file %s
		put_numeric (att_file_sequence, /*X.RDB$FILE_SEQUENCE*/
						isc_86.isc_92);
		put_numeric (att_file_start, /*X.RDB$FILE_START*/
					     isc_86.isc_88);
		put_numeric (att_file_length, /*X.RDB$FILE_LENGTH*/
					      isc_86.isc_87);
		put_numeric (att_file_flags, /*X.RDB$FILE_FLAGS*/
					     isc_86.isc_91);
		put_numeric (att_shadow_number, /*X.RDB$SHADOW_NUMBER*/
						isc_86.isc_90);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}

void write_sql_roles(void)
{
/**************************************
 *
 *	w r i t e _ s q l _ r o l e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each SQL roles. 
 *
 **************************************/
	isc_req_handle req_handle1 = 0;
	TEXT temp[GDS_NAME_LEN];

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->BCK_capabilities & BCK_ods11)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$ROLES
			WITH X.RDB$SYSTEM_FLAG NE 1 OR X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_78), (char *) isc_78);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 76, &isc_79, (short) 0);
		   if (!isc_79.isc_83 || isc_status [1]) break;

			put(tdgbl, rec_sql_roles);
			const SSHORT l = PUT_TEXT(att_role_name, /*X.RDB$ROLE_NAME*/
								 isc_79.isc_82);
			PUT_TEXT (att_role_owner_name, /*X.RDB$OWNER_NAME*/
						       isc_79.isc_81);
			if (!/*X.RDB$DESCRIPTION.NULL*/
			     isc_79.isc_84) {
				put_source_blob (att_role_description, att_role_description,
								 &/*X.RDB$DESCRIPTION*/
								  isc_79.isc_80);
			}
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$ROLE_NAME*/
					isc_79.isc_82, temp, l, sizeof(temp));
			BURP_verbose (249, temp, NULL, NULL, NULL, NULL);
			// msg 249 writing SQL role: %s
		
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$ROLES*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_73), (char *) isc_73);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 66, &isc_74, (short) 0);
		   if (!isc_74.isc_77 || isc_status [1]) break;

			put(tdgbl, rec_sql_roles);
			const SSHORT l = PUT_TEXT(att_role_name, /*X.RDB$ROLE_NAME*/
								 isc_74.isc_76);
			PUT_TEXT (att_role_owner_name, /*X.RDB$OWNER_NAME*/
						       isc_74.isc_75);
			put(tdgbl, att_end);
			MISC_terminate (/*X.RDB$ROLE_NAME*/
					isc_74.isc_76, temp, l, sizeof(temp));
			BURP_verbose (249, temp, NULL, NULL, NULL, NULL);
			// msg 249 writing SQL role: %s

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}

void write_triggers(void)
{
/**************************************
 *
 *	w r i t e _ t r i g g e r s
 *
 **************************************
 *
 * Functional description
 * 	write the triggers in rdb$triggers
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0, req_handle2 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/* if we have all capabilities, use the first request to get the 
	most performance out of the latest engine; if we don't 
	have one of the capabilities we must use the second set of 
	requests--this requires more code but it is well worth it 
	for the performance benefits, especially remotely--deej */

	if (tdgbl->BCK_capabilities & BCK_ods8)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$TRIGGERS WITH 
			X.RDB$SYSTEM_FLAG NE 1 OR 
			X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_59), (char *) isc_59);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 102, &isc_60, (short) 0);
		   if (!isc_60.isc_66 || isc_status [1]) break;

			put(tdgbl, rec_trigger);
			const SSHORT l = PUT_TEXT (att_trig_name, /*X.RDB$TRIGGER_NAME*/
								  isc_60.isc_65);
			MISC_terminate (/*X.RDB$TRIGGER_NAME*/
					isc_60.isc_65, temp, l, sizeof(temp));
			BURP_verbose (156, temp, NULL, NULL, NULL, NULL);
			// msg 156   writing trigger %s 
		
			PUT_TEXT (att_trig_relation_name, /*X.RDB$RELATION_NAME*/
							  isc_60.isc_64);
			put_numeric (att_trig_sequence, /*X.RDB$TRIGGER_SEQUENCE*/
							isc_60.isc_72);
			put_numeric (att_trig_type, /*X.RDB$TRIGGER_TYPE*/
						    isc_60.isc_71);
			put_blr_blob (att_trig_blr, &/*X.RDB$TRIGGER_BLR*/
						     isc_60.isc_63);
			put_source_blob (att_trig_source2, att_trig_source, &/*X.RDB$TRIGGER_SOURCE*/
									     isc_60.isc_62);
			put_source_blob (att_trig_description2, att_trig_description, &/*X.RDB$DESCRIPTION*/
										       isc_60.isc_61);
			put_numeric (att_trig_system_flag, /*X.RDB$SYSTEM_FLAG*/
							   isc_60.isc_70);
			put_numeric (att_trig_inactive, /*X.RDB$TRIGGER_INACTIVE*/
							isc_60.isc_69);
			
			if (!(/*X.RDB$FLAGS.NULL*/
			      isc_60.isc_67))
				put_numeric (att_trig_flags, /*X.RDB$FLAGS*/
							     isc_60.isc_68);
			
			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$TRIGGERS WITH 
			X.RDB$SYSTEM_FLAG NE 1 OR 
			X.RDB$SYSTEM_FLAG MISSING*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_47), (char *) isc_47);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 98, &isc_48, (short) 0);
		   if (!isc_48.isc_54 || isc_status [1]) break;

			put(tdgbl, rec_trigger);
			const SSHORT l = PUT_TEXT (att_trig_name, /*X.RDB$TRIGGER_NAME*/
								  isc_48.isc_53);
			MISC_terminate (/*X.RDB$TRIGGER_NAME*/
					isc_48.isc_53, temp, l, sizeof(temp));
			BURP_verbose (156, temp, NULL, NULL, NULL, NULL);
			// msg 156   writing trigger %s 
			
			PUT_TEXT (att_trig_relation_name, /*X.RDB$RELATION_NAME*/
							  isc_48.isc_52);
			put_numeric (att_trig_sequence, /*X.RDB$TRIGGER_SEQUENCE*/
							isc_48.isc_58);
			put_numeric (att_trig_type, /*X.RDB$TRIGGER_TYPE*/
						    isc_48.isc_57);
			put_blr_blob (att_trig_blr, &/*X.RDB$TRIGGER_BLR*/
						     isc_48.isc_51);
			put_source_blob (att_trig_source2, att_trig_source, &/*X.RDB$TRIGGER_SOURCE*/
									     isc_48.isc_50);
			put_source_blob (att_trig_description2, att_trig_description, &/*X.RDB$DESCRIPTION*/
										       isc_48.isc_49);
			put_numeric (att_trig_system_flag, /*X.RDB$SYSTEM_FLAG*/
							   isc_48.isc_56);
			put_numeric (att_trig_inactive, /*X.RDB$TRIGGER_INACTIVE*/
							isc_48.isc_55);

			if (tdgbl->BCK_capabilities & BCK_ods8)
			{
				/*FOR (REQUEST_HANDLE req_handle2)
					Y IN RDB$TRIGGERS WITH 
					X.RDB$TRIGGER_NAME = Y.RDB$TRIGGER_NAME*/
				{
                                if (!req_handle2)
                                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle2, (short) sizeof (isc_40), (char *) isc_40);
				isc_vtov ((char*)isc_48.isc_53, (char*)isc_41.isc_42, 32);
				if (req_handle2)
                                   isc_start_and_send (isc_status, (FB_API_HANDLE*) &req_handle2, (FB_API_HANDLE*) &gds_trans, (short) 0, (short) 32, &isc_41, (short) 0);
				if (!isc_status [1]) {
				while (1)
				   {
                                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle2, (short) 1, (short) 6, &isc_43, (short) 0);
				   if (!isc_43.isc_44 || isc_status [1]) break;

					if (!(/*Y.RDB$FLAGS.NULL*/
					      isc_43.isc_45))
						put_numeric (att_trig_flags, /*Y.RDB$FLAGS*/
									     isc_43.isc_46);

				/*END_FOR;*/
				   }
				   };
				/*ON_ERROR*/
				if (isc_status [1])
				   {
					general_on_error();
				/*END_ERROR;*/
				   }
				}
			}

			put(tdgbl, att_end);

		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
	MISC_release_request_silent(req_handle2);
}


void write_trigger_messages(void)
{
/**************************************
 *
 *	w r i t e _ t r i g g e r _ m e s s a g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each trigger message.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		T IN RDB$TRIGGERS CROSS X IN RDB$TRIGGER_MESSAGES
		OVER RDB$TRIGGER_NAME
		WITH T.RDB$SYSTEM_FLAG NE 1 OR T.RDB$SYSTEM_FLAG MISSING*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_34), (char *) isc_34);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 1058, &isc_35, (short) 0);
	   if (!isc_35.isc_37 || isc_status [1]) break;;

		put(tdgbl, rec_trigger_message);
		const SSHORT l = PUT_TEXT (att_trigmsg_name, /*X.RDB$TRIGGER_NAME*/
							     isc_35.isc_36);
		MISC_terminate (/*X.RDB$TRIGGER_NAME*/
				isc_35.isc_36, temp, l, sizeof(temp));
		BURP_verbose (157, temp, NULL, NULL, NULL, NULL);
		/* msg 157 writing trigger message for *s */
		put_numeric (att_trigmsg_number, /*X.RDB$MESSAGE_NUMBER*/
						 isc_35.isc_39);
		PUT_MESSAGE (att_trigmsg_text, /*X.RDB$MESSAGE*/
					       isc_35.isc_38);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}

void write_types(void)
{
/**************************************
 *
 *	w r i t e _ t y p e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each type.
 *
 **************************************/
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	/*FOR (REQUEST_HANDLE req_handle1)
		X IN RDB$TYPES WITH X.RDB$SYSTEM_FLAG NE 1 OR 
		X.RDB$SYSTEM_FLAG MISSING*/
	{
        if (!req_handle1)
           isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_26), (char *) isc_26);
	if (req_handle1)
           isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
	if (!isc_status [1]) {
	while (1)
	   {
           isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 78, &isc_27, (short) 0);
	   if (!isc_27.isc_31 || isc_status [1]) break;
		put(tdgbl, rec_system_type);
		PUT_TEXT (att_type_name, /*X.RDB$TYPE_NAME*/
					 isc_27.isc_30);
		PUT_TEXT (att_type_field_name, /*X.RDB$FIELD_NAME*/
					       isc_27.isc_29);
		BURP_verbose (160, /*X.RDB$TYPE_NAME*/
				   isc_27.isc_30, /*X.RDB$FIELD_NAME*/
  isc_27.isc_29, NULL, NULL, NULL);
		// msg 160 writing type %s for field %s 
		put_numeric (att_type_type, /*X.RDB$TYPE*/
					    isc_27.isc_33);
		put_source_blob (att_type_description2, att_type_description, &/*X.RDB$DESCRIPTION*/
									       isc_27.isc_28);
		if (/*X.RDB$SYSTEM_FLAG*/
		    isc_27.isc_32)
			put_numeric (att_type_system_flag, /*X.RDB$SYSTEM_FLAG*/
							   isc_27.isc_32);
		put(tdgbl, att_end);
	/*END_FOR;*/
	   }
	   };
	/*ON_ERROR*/
	if (isc_status [1])
	   {
		general_on_error();
	/*END_ERROR;*/
	   }
	}

	MISC_release_request_silent(req_handle1);
}


void write_user_privileges(void)
{
/**************************************
 *
 *	w r i t e _ u s e r _ p r i v i l e g e s
 *
 **************************************
 *
 * Functional description
 * 	write a record in the burp file for
 *	each user privilege.
 *
 **************************************/
	TEXT temp[GDS_NAME_LEN];
	isc_req_handle req_handle1 = 0;

	BurpGlobals* tdgbl = BurpGlobals::getSpecific();

	if (tdgbl->BCK_capabilities & BCK_ods8)
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$USER_PRIVILEGES*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_14), (char *) isc_14);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 145, &isc_15, (short) 0);
		   if (!isc_15.isc_20 || isc_status [1]) break;
			put(tdgbl, rec_user_privilege);
			const SSHORT l = PUT_TEXT (att_priv_user, /*X.RDB$USER*/
								  isc_15.isc_19);
			MISC_terminate (/*X.RDB$USER*/
					isc_15.isc_19, temp, l, sizeof(temp));
			BURP_verbose (152, temp, NULL, NULL, NULL, NULL);
			// msg 152 writing privilege for user %s
			PUT_TEXT (att_priv_grantor, /*X.RDB$GRANTOR*/
						    isc_15.isc_18);
			PUT_TEXT (att_priv_privilege, /*X.RDB$PRIVILEGE*/
						      isc_15.isc_25);
			put_numeric (att_priv_grant_option, /*X.RDB$GRANT_OPTION*/
							    isc_15.isc_24);
			PUT_TEXT (att_priv_object_name, /*X.RDB$RELATION_NAME*/
							isc_15.isc_17);
			if (!/*X.RDB$FIELD_NAME.NULL*/
			     isc_15.isc_23)
			   PUT_TEXT (att_priv_field_name, /*X.RDB$FIELD_NAME*/
							  isc_15.isc_16);
			put_numeric (att_priv_user_type, /*X.RDB$USER_TYPE*/
							 isc_15.isc_22);
			put_numeric (att_priv_obj_type, /*X.RDB$OBJECT_TYPE*/
							isc_15.isc_21);
			put(tdgbl, att_end);
		/*END_FOR*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}
	else
	{
		/*FOR (REQUEST_HANDLE req_handle1)
			X IN RDB$USER_PRIVILEGES*/
		{
                if (!req_handle1)
                   isc_compile_request (isc_status, (FB_API_HANDLE*) &DB, (FB_API_HANDLE*) &req_handle1, (short) sizeof (isc_4), (char *) isc_4);
		if (req_handle1)
                   isc_start_request (isc_status, (FB_API_HANDLE*) &req_handle1, (FB_API_HANDLE*) &gds_trans, (short) 0);
		if (!isc_status [1]) {
		while (1)
		   {
                   isc_receive (isc_status, (FB_API_HANDLE*) &req_handle1, (short) 0, (short) 141, &isc_5, (short) 0);
		   if (!isc_5.isc_10 || isc_status [1]) break;
			put(tdgbl, rec_user_privilege);
			const SSHORT l = PUT_TEXT (att_priv_user, /*X.RDB$USER*/
								  isc_5.isc_9);
			MISC_terminate (/*X.RDB$USER*/
					isc_5.isc_9, temp, l, sizeof(temp));
			BURP_verbose (152, temp, NULL, NULL, NULL, NULL);
			// msg 152 writing privilege for user %s
			PUT_TEXT (att_priv_grantor, /*X.RDB$GRANTOR*/
						    isc_5.isc_8);
			PUT_TEXT (att_priv_privilege, /*X.RDB$PRIVILEGE*/
						      isc_5.isc_13);
			put_numeric (att_priv_grant_option, /*X.RDB$GRANT_OPTION*/
							    isc_5.isc_12);
			PUT_TEXT (att_priv_object_name, /*X.RDB$RELATION_NAME*/
							isc_5.isc_7);
			if (!/*X.RDB$FIELD_NAME.NULL*/
			     isc_5.isc_11)
				PUT_TEXT (att_priv_field_name, /*X.RDB$FIELD_NAME*/
							       isc_5.isc_6);
			put(tdgbl, att_end);
		/*END_FOR;*/
		   }
		   };
		/*ON_ERROR*/
		if (isc_status [1])
		   {
			general_on_error();
		/*END_ERROR;*/
		   }
		}
	}

	MISC_release_request_silent(req_handle1);
}

} // namespace

